/*
    Copyright 2015-2016 Amebis

    This file is part of ZRCola.

    ZRCola is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ZRCola is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZRCola. If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"


static const ZRCola::decomposition decompositions[] = {
    { L'\x0024', L"\x0053\xE0B8" },
    { L'\x002C', L"\x0023\xE0B6" },
    { L'\x002F', L"\x0023\xE037" },
    { L'\x005C', L"\x0023\xE0B5" },
    { L'\x0060', L"\x0023\xE000" },
    { L'\x007E', L"\x0023\xE034" },
    { L'\x00A1', L"\xE0F9\x0021" },
    { L'\x00A8', L"\x0023\xE008" },
    { L'\x00AB', L"\x2039\xE0C4\x2039" },
    { L'\x00B2', L"\xE0C5\x0032\xE0C6" },
    { L'\x00B2', L"\xE2EC\x0032\xE2ED" },
    { L'\x00B3', L"\xE0C5\x0033\xE0C6" },
    { L'\x00B3', L"\xE2EC\x0033\xE2ED" },
    { L'\x00B4', L"\x0023\xE001" },
    { L'\x00B4', L"\x0023\xE0B2" },
    { L'\x00B8', L"\x0023\xE027" },
    { L'\x00B9', L"\xE0C5\x0031\xE0C6" },
    { L'\x00B9', L"\xE2EC\x0031\xE2ED" },
    { L'\x00BB', L"\x203A\xE0C4\x203A" },
    { L'\x00BF', L"\xE0F9\x003F" },
    { L'\x00C0', L"\x0041\xE000" },
    { L'\x00C1', L"\x0041\xE001" },
    { L'\x00C2', L"\x0041\xE002" },
    { L'\x00C3', L"\x0041\xE003" },
    { L'\x00C4', L"\x0041\xE008" },
    { L'\x00C5', L"\x0041\xE00A" },
    { L'\x00C6', L"\x0041\xE0C4\x0045" },
    { L'\x00C7', L"\x0043\xE027" },
    { L'\x00C8', L"\x0045\xE000" },
    { L'\x00C9', L"\x0045\xE001" },
    { L'\x00CA', L"\x0045\xE002" },
    { L'\x00CB', L"\x0045\xE008" },
    { L'\x00CC', L"\x0049\xE000" },
    { L'\x00CD', L"\x0049\xE001" },
    { L'\x00CE', L"\x0049\xE002" },
    { L'\x00CF', L"\x0049\xE008" },
    { L'\x00D1', L"\x004E\xE003" },
    { L'\x00D2', L"\x004F\xE000" },
    { L'\x00D3', L"\x004F\xE001" },
    { L'\x00D4', L"\x004F\xE002" },
    { L'\x00D5', L"\x004F\xE003" },
    { L'\x00D6', L"\x004F\xE008" },
    { L'\x00D8', L"\x004F\xE037" },
    { L'\x00D9', L"\x0055\xE000" },
    { L'\x00DA', L"\x0055\xE001" },
    { L'\x00DB', L"\x0055\xE002" },
    { L'\x00DC', L"\x0055\xE008" },
    { L'\x00DD', L"\x0059\xE001" },
    { L'\x00DF', L"\x0073\xE0C4\x0073" },
    { L'\x00DF', L"\x0073\xE0C4\x007A" },
    { L'\x00E0', L"\x0061\xE000" },
    { L'\x00E1', L"\x0061\xE001" },
    { L'\x00E2', L"\x0061\xE002" },
    { L'\x00E3', L"\x0061\xE003" },
    { L'\x00E4', L"\x0061\xE008" },
    { L'\x00E5', L"\x0061\xE00A" },
    { L'\x00E6', L"\x0061\xE0C4\x0065" },
    { L'\x00E7', L"\x0063\xE027" },
    { L'\x00E8', L"\x0065\xE000" },
    { L'\x00E9', L"\x0065\xE001" },
    { L'\x00EA', L"\x0065\xE002" },
    { L'\x00EB', L"\x0065\xE008" },
    { L'\x00EC', L"\x0069\xE000" },
    { L'\x00ED', L"\x0069\xE001" },
    { L'\x00EE', L"\x0069\xE002" },
    { L'\x00EF', L"\x0069\xE008" },
    { L'\x00F1', L"\x006E\xE003" },
    { L'\x00F2', L"\x006F\xE000" },
    { L'\x00F3', L"\x006F\xE001" },
    { L'\x00F4', L"\x006F\xE002" },
    { L'\x00F5', L"\x006F\xE003" },
    { L'\x00F6', L"\x006F\xE008" },
    { L'\x00F7', L"\x2013\xE007\xE023" },
    { L'\x00F7', L"\x2238\xE023" },
    { L'\x00F8', L"\x006F\xE037" },
    { L'\x00F9', L"\x0075\xE000" },
    { L'\x00FA', L"\x0075\xE001" },
    { L'\x00FB', L"\x0075\xE002" },
    { L'\x00FC', L"\x0075\xE008" },
    { L'\x00FD', L"\x0079\xE001" },
    { L'\x00FF', L"\x0079\xE008" },
    { L'\x0100', L"\x0041\xE004" },
    { L'\x0101', L"\x0061\xE004" },
    { L'\x0102', L"\x0041\xE006" },
    { L'\x0103', L"\x0061\xE006" },
    { L'\x0104', L"\x0041\xE028" },
    { L'\x0105', L"\x0061\xE028" },
    { L'\x0106', L"\x0043\xE001" },
    { L'\x0107', L"\x0063\xE001" },
    { L'\x0108', L"\x0043\xE002" },
    { L'\x0109', L"\x0063\xE002" },
    { L'\x010A', L"\x0043\xE007" },
    { L'\x010B', L"\x0063\xE007" },
    { L'\x010C', L"\x0043\xE00C" },
    { L'\x010D', L"\x0063\xE00C" },
    { L'\x010E', L"\x0044\xE00C" },
    { L'\x010F', L"\x0064\xE015" },
    { L'\x010F', L"\x0064\xE0C4\x2019" },
    { L'\x0110', L"\x0044\xE035" },
    { L'\x0111', L"\x0064\xE035" },
    { L'\x0112', L"\x0045\xE004" },
    { L'\x0113', L"\x0065\xE004" },
    { L'\x0114', L"\x0045\xE006" },
    { L'\x0115', L"\x0065\xE006" },
    { L'\x0116', L"\x0045\xE007" },
    { L'\x0117', L"\x0065\xE007" },
    { L'\x0118', L"\x0045\xE028" },
    { L'\x0119', L"\x0065\xE028" },
    { L'\x011A', L"\x0045\xE00C" },
    { L'\x011B', L"\x0065\xE00C" },
    { L'\x011C', L"\x0047\xE002" },
    { L'\x011D', L"\x0067\xE002" },
    { L'\x011E', L"\x0047\xE006" },
    { L'\x011F', L"\x0067\xE006" },
    { L'\x0120', L"\x0047\xE007" },
    { L'\x0121', L"\x0067\xE007" },
    { L'\x0122', L"\x0047\xE026" },
    { L'\x0122', L"\x0047\xE027" },
    { L'\x0123', L"\x0067\xE012" },
    { L'\x0123', L"\x0067\xE026" },
    { L'\x0123', L"\x0067\xE027" },
    { L'\x0124', L"\x0048\xE002" },
    { L'\x0125', L"\x0068\xE002" },
    { L'\x0126', L"\x0048\xE035" },
    { L'\x0127', L"\x0068\xE035" },
    { L'\x0128', L"\x0049\xE003" },
    { L'\x0129', L"\x0069\xE003" },
    { L'\x012A', L"\x0049\xE004" },
    { L'\x012B', L"\x0069\xE004" },
    { L'\x012C', L"\x0049\xE006" },
    { L'\x012D', L"\x0069\xE006" },
    { L'\x012E', L"\x0049\xE028" },
    { L'\x012F', L"\x0069\xE028" },
    { L'\x0130', L"\x0049\xE007" },
    { L'\x0132', L"\x0049\xE0C4\x004A" },
    { L'\x0133', L"\x0069\xE0C4\x006A" },
    { L'\x0134', L"\x004A\xE002" },
    { L'\x0135', L"\x006A\xE002" },
    { L'\x0136', L"\x004B\xE026" },
    { L'\x0137', L"\x006B\xE026" },
    { L'\x0139', L"\x004C\xE001" },
    { L'\x013A', L"\x006C\xE001" },
    { L'\x013B', L"\x004C\xE026" },
    { L'\x013B', L"\x004C\xE027" },
    { L'\x013C', L"\x006C\xE026" },
    { L'\x013C', L"\x006C\xE027" },
    { L'\x013D', L"\x004C\xE015" },
    { L'\x013D', L"\x004C\xE0C4\x2019" },
    { L'\x013E', L"\x006C\xE015" },
    { L'\x013E', L"\x006C\xE0C4\x2019" },
    { L'\x013F', L"\x004C\xE0B1" },
    { L'\x0140', L"\x006C\xE0B1" },
    { L'\x0141', L"\x004C\xE037" },
    { L'\x0142', L"\x006C\xE037" },
    { L'\x0143', L"\x004E\xE001" },
    { L'\x0144', L"\x006E\xE001" },
    { L'\x0145', L"\x004E\xE026" },
    { L'\x0145', L"\x004E\xE027" },
    { L'\x0146', L"\x006E\xE026" },
    { L'\x0147', L"\x004E\xE00C" },
    { L'\x0148', L"\x006E\xE00C" },
    { L'\x0149', L"\x006E\xE0B0" },
    { L'\x0149', L"\x2019\xE0C4\x006E" },
    { L'\x014A', L"\x004E\xE0A2" },
    { L'\x014B', L"\x006E\xE0A2" },
    { L'\x014B', L"\xE0F8\xE15C" },
    { L'\x014C', L"\x004F\xE004" },
    { L'\x014D', L"\x006F\xE004" },
    { L'\x014E', L"\x004F\xE006" },
    { L'\x014F', L"\x006F\xE006" },
    { L'\x0150', L"\x004F\xE00B" },
    { L'\x0151', L"\x006F\xE00B" },
    { L'\x0152', L"\x004F\xE0C4\x0045" },
    { L'\x0153', L"\x006F\xE0C4\x0065" },
    { L'\x0154', L"\x0052\xE001" },
    { L'\x0155', L"\x0072\xE001" },
    { L'\x0156', L"\x0052\xE026" },
    { L'\x0157', L"\x0072\xE026" },
    { L'\x0158', L"\x0052\xE00C" },
    { L'\x0159', L"\x0072\xE00C" },
    { L'\x015A', L"\x0053\xE001" },
    { L'\x015B', L"\x0073\xE001" },
    { L'\x015C', L"\x0053\xE002" },
    { L'\x015D', L"\x0073\xE002" },
    { L'\x015E', L"\x0053\xE027" },
    { L'\x015F', L"\x0073\xE027" },
    { L'\x0160', L"\x0053\xE00C" },
    { L'\x0161', L"\x0073\xE00C" },
    { L'\x0162', L"\x0054\xE027" },
    { L'\x0163', L"\x0074\xE027" },
    { L'\x0164', L"\x0054\xE00C" },
    { L'\x0165', L"\x0074\xE015" },
    { L'\x0165', L"\x0074\xE0C4\x2019" },
    { L'\x0166', L"\x0054\xE035" },
    { L'\x0167', L"\x0074\xE035" },
    { L'\x0168', L"\x0055\xE003" },
    { L'\x0169', L"\x0075\xE003" },
    { L'\x016A', L"\x0055\xE004" },
    { L'\x016B', L"\x0075\xE004" },
    { L'\x016C', L"\x0055\xE006" },
    { L'\x016D', L"\x0075\xE006" },
    { L'\x016E', L"\x0055\xE00A" },
    { L'\x016F', L"\x0075\xE00A" },
    { L'\x0170', L"\x0055\xE00B" },
    { L'\x0171', L"\x0075\xE00B" },
    { L'\x0172', L"\x0055\xE028" },
    { L'\x0173', L"\x0075\xE028" },
    { L'\x0174', L"\x0057\xE002" },
    { L'\x0175', L"\x0077\xE002" },
    { L'\x0176', L"\x0059\xE002" },
    { L'\x0177', L"\x0079\xE002" },
    { L'\x0178', L"\x0059\xE008" },
    { L'\x0179', L"\x005A\xE001" },
    { L'\x017A', L"\x007A\xE001" },
    { L'\x017B', L"\x005A\xE007" },
    { L'\x017C', L"\x007A\xE007" },
    { L'\x017D', L"\x005A\xE00C" },
    { L'\x017E', L"\x007A\xE00C" },
    { L'\x0180', L"\x0062\xE035" },
    { L'\x0181', L"\x0042\xE08A" },
    { L'\x0186', L"\xE0F9\x0043" },
    { L'\x0187', L"\x0043\xE08A" },
    { L'\x0188', L"\x0063\xE08A" },
    { L'\x018A', L"\x0044\xE08A" },
    { L'\x018D', L"\xE0F0\xE0F2\xE0F9\x0064" },
    { L'\x018D', L"\xE0F2\xE0F9\x0064" },
    { L'\x018E', L"\xE0F9\x0045" },
    { L'\x018F', L"\xE0F8\x0259" },
    { L'\x018F', L"\xE0F8\xE0F9\x0065" },
    { L'\x0190', L"\xE0F0\xE0F2\xE0F8\x0065" },
    { L'\x0190', L"\xE0F1\xE0F2\xE0F8\x0065" },
    { L'\x0190', L"\xE0F2\xE0F8\x0065" },
    { L'\x0190', L"\xE0F8\x025B" },
    { L'\x0191', L"\x0046\xE0A2" },
    { L'\x0193', L"\x0047\xE08A" },
    { L'\x0194', L"\xE0F0\xE0F2\xE0F8\x0067" },
    { L'\x0195', L"\x0068\xE0C4\x0076" },
    { L'\x0196', L"\xE0F0\xE0F2\xE0F8\x0069" },
    { L'\x0197', L"\x0049\xE035" },
    { L'\x0198', L"\x004B\xE08A" },
    { L'\x0199', L"\x006B\xE08A" },
    { L'\x019A', L"\x006C\xE035" },
    { L'\x019B', L"\x03BB\xE037" },
    { L'\x019C', L"\xE0F8\xE0F9\x006D" },
    { L'\x019D', L"\x004E\xE021" },
    { L'\x019F', L"\x004F\xE035" },
    { L'\x01A0', L"\x004F\xE01B" },
    { L'\x01A1', L"\x006F\xE01B" },
    { L'\x01A4', L"\x0050\xE08A" },
    { L'\x01A5', L"\x0070\xE08A" },
    { L'\x01A7', L"\xE0FA\x0053" },
    { L'\x01A8', L"\xE0FA\x0073" },
    { L'\x01AC', L"\x0054\xE08A" },
    { L'\x01AD', L"\x0074\xE08A" },
    { L'\x01AE', L"\x0054\xE022" },
    { L'\x01AF', L"\x0055\xE01B" },
    { L'\x01B0', L"\x0075\xE01B" },
    { L'\x01B1', L"\xE0F0\xE0F2\xE0F9\x004F\xE004" },
    { L'\x01B2', L"\x0056\xE08A" },
    { L'\x01B3', L"\x0059\xE08A" },
    { L'\x01B4', L"\x0079\xE08A" },
    { L'\x01B5', L"\x005A\xE035" },
    { L'\x01B6', L"\x007A\xE035" },
    { L'\x01B7', L"\xE0F8\x0292" },
    { L'\x01B8', L"\xE0F8\xE0FA\x0292" },
    { L'\x01B9', L"\xE0FA\x0292" },
    { L'\x01C7', L"\x004C\xE0C4\x004A" },
    { L'\x01C8', L"\x004C\xE0C4\x006A" },
    { L'\x01C9', L"\x006C\xE0C4\x006A" },
    { L'\x01CA', L"\x004E\xE0C4\x004A" },
    { L'\x01CB', L"\x004E\xE0C4\x006A" },
    { L'\x01CC', L"\x006E\xE0C4\x006A" },
    { L'\x01CD', L"\x0041\xE00C" },
    { L'\x01CE', L"\x0061\xE00C" },
    { L'\x01CF', L"\x0049\xE00C" },
    { L'\x01D0', L"\x0069\xE00C" },
    { L'\x01D1', L"\x004F\xE00C" },
    { L'\x01D2', L"\x006F\xE00C" },
    { L'\x01D3', L"\x0055\xE00C" },
    { L'\x01D4', L"\x0075\xE00C" },
    { L'\x01D5', L"\x0055\xE008\xE004" },
    { L'\x01D6', L"\x0075\xE008\xE004" },
    { L'\x01D7', L"\x0055\xE008\xE001" },
    { L'\x01D8', L"\x0075\xE008\xE001" },
    { L'\x01D9', L"\x0055\xE008\xE00C" },
    { L'\x01DA', L"\x0075\xE008\xE00C" },
    { L'\x01DB', L"\x0055\xE008\xE000" },
    { L'\x01DC', L"\x0075\xE008\xE000" },
    { L'\x01DE', L"\x0041\xE008\xE004" },
    { L'\x01DF', L"\x0061\xE008\xE004" },
    { L'\x01E0', L"\x0041\xE007\xE004" },
    { L'\x01E1', L"\x0061\xE007\xE004" },
    { L'\x01E2', L"\x0041\xE0C4\x0045\xE004" },
    { L'\x01E3', L"\x0061\xE0C4\x0065\xE004" },
    { L'\x01E4', L"\x0047\xE082" },
    { L'\x01E5', L"\x0067\xE082" },
    { L'\x01E6', L"\x0047\xE00C" },
    { L'\x01E7', L"\x0067\xE00C" },
    { L'\x01E8', L"\x004B\xE00C" },
    { L'\x01E9', L"\x006B\xE00C" },
    { L'\x01EA', L"\x004F\xE028" },
    { L'\x01EB', L"\x006F\xE028" },
    { L'\x01EC', L"\x004F\xE028\xE004" },
    { L'\x01ED', L"\x006F\xE028\xE004" },
    { L'\x01EE', L"\x01B7\xE00C" },
    { L'\x01EF', L"\x0292\xE00C" },
    { L'\x01F0', L"\x006A\xE00C" },
    { L'\x01F4', L"\x0047\xE001" },
    { L'\x01F5', L"\x0067\xE001" },
    { L'\x01F6', L"\x0048\xE0C4\x0076" },
    { L'\x01F8', L"\x004E\xE000" },
    { L'\x01F9', L"\x006E\xE000" },
    { L'\x01FA', L"\x0041\xE00A\xE001" },
    { L'\x01FB', L"\x0061\xE00A\xE001" },
    { L'\x01FC', L"\x0041\xE0C4\x0045\xE001" },
    { L'\x01FD', L"\x0061\xE0C4\x0065\xE001" },
    { L'\x01FE', L"\x004F\xE037\xE001" },
    { L'\x01FF', L"\x006F\xE037\xE001" },
    { L'\x0200', L"\x0041\xE00F" },
    { L'\x0201', L"\x0061\xE00F" },
    { L'\x0202', L"\x0041\xE011" },
    { L'\x0203', L"\x0061\xE011" },
    { L'\x0204', L"\x0045\xE00F" },
    { L'\x0205', L"\x0065\xE00F" },
    { L'\x0206', L"\x0045\xE011" },
    { L'\x0207', L"\x0065\xE011" },
    { L'\x0208', L"\x0049\xE00F" },
    { L'\x0209', L"\x0069\xE00F" },
    { L'\x020A', L"\x0049\xE011" },
    { L'\x020B', L"\x0069\xE011" },
    { L'\x020C', L"\x004F\xE00F" },
    { L'\x020D', L"\x006F\xE00F" },
    { L'\x020E', L"\x004F\xE011" },
    { L'\x020F', L"\x006F\xE011" },
    { L'\x0210', L"\x0052\xE00F" },
    { L'\x0211', L"\x0072\xE00F" },
    { L'\x0212', L"\x0052\xE011" },
    { L'\x0213', L"\x0072\xE011" },
    { L'\x0214', L"\x0055\xE00F" },
    { L'\x0215', L"\x0075\xE00F" },
    { L'\x0216', L"\x0055\xE011" },
    { L'\x0217', L"\x0075\xE011" },
    { L'\x0218', L"\x0053\xE026" },
    { L'\x0219', L"\x0073\xE026" },
    { L'\x021A', L"\x0054\xE026" },
    { L'\x021B', L"\x0074\xE026" },
    { L'\x021E', L"\x0048\xE00C" },
    { L'\x021F', L"\x0068\xE00C" },
    { L'\x0221', L"\x0064\xE0A5" },
    { L'\x0224', L"\x005A\xE0A2" },
    { L'\x0225', L"\x007A\xE0A2" },
    { L'\x0226', L"\x0041\xE007" },
    { L'\x0227', L"\x0061\xE007" },
    { L'\x0228', L"\x0045\xE027" },
    { L'\x0229', L"\x0065\xE027" },
    { L'\x022A', L"\x004F\xE008\xE004" },
    { L'\x022B', L"\x006F\xE008\xE004" },
    { L'\x022C', L"\x004F\xE003\xE004" },
    { L'\x022D', L"\x006F\xE003\xE004" },
    { L'\x022E', L"\x004F\xE007" },
    { L'\x022F', L"\x006F\xE007" },
    { L'\x0230', L"\x004F\xE007\xE004" },
    { L'\x0231', L"\x006F\xE007\xE004" },
    { L'\x0232', L"\x0059\xE004" },
    { L'\x0233', L"\x0079\xE004" },
    { L'\x0234', L"\x006C\xE0A5" },
    { L'\x0235', L"\x006E\xE0A5" },
    { L'\x0236', L"\x0074\xE0A5" },
    { L'\x0237', L"\xE0F9\x017F" },
    { L'\x0238', L"\x0064\xE0C4\x0062" },
    { L'\x0239', L"\x0071\xE0C4\x0070" },
    { L'\x023A', L"\x0041\xE037" },
    { L'\x023B', L"\x0043\xE037" },
    { L'\x023C', L"\x0063\xE037" },
    { L'\x023D', L"\x004C\xE035" },
    { L'\x023E', L"\x0054\xE037" },
    { L'\x0243', L"\x0042\xE035" },
    { L'\x0243', L"\xE910" },
    { L'\x0244', L"\x0055\xE035" },
    { L'\x0245', L"\xE0F9\x0056" },
    { L'\x0246', L"\x0045\xE037" },
    { L'\x0247', L"\x0065\xE037" },
    { L'\x0248', L"\x004A\xE035" },
    { L'\x0249', L"\x006A\xE035" },
    { L'\x024A', L"\x0051\xE022" },
    { L'\x024B', L"\x0071\xE022" },
    { L'\x024C', L"\x0052\xE035" },
    { L'\x024D', L"\x0072\xE035" },
    { L'\x024E', L"\x0059\xE035" },
    { L'\x024F', L"\x0079\xE035" },
    { L'\x0250', L"\xE0F9\x0061" },
    { L'\x0251', L"\xE0F1\xE0F2\x0061" },
    { L'\x0252', L"\xE0F1\xE0F2\xE0F9\x0061" },
    { L'\x0253', L"\x0062\xE08A" },
    { L'\x0254', L"\xE0F9\x0063" },
    { L'\x0255', L"\x0063\xE0A5" },
    { L'\x0256', L"\x0064\xE022" },
    { L'\x0257', L"\x0064\xE08A" },
    { L'\x0258', L"\xE0FA\x0065" },
    { L'\x0259', L"\xE0F9\x0065" },
    { L'\x025A', L"\x0259\x02DE" },
    { L'\x025B', L"\xE0F0\xE0F2\x0065" },
    { L'\x025B', L"\xE0F1\xE0F2\x0065" },
    { L'\x025C', L"\xE0F1\xE0F2\xE0FA\x0065" },
    { L'\x025D', L"\x025C\x02DE" },
    { L'\x025E', L"\xE0FC\x0277" },
    { L'\x025F', L"\x0237\xE082" },
    { L'\x025F', L"\xE0F9\x0066" },
    { L'\x0260', L"\x0261\xE08A" },
    { L'\x0261', L"\xE0F1\x0067" },
    { L'\x0262', L"\xE0F8\x0047" },
    { L'\x0263', L"\xE0F1\xE0F2\x0067" },
    { L'\x0265', L"\xE0F9\x0068" },
    { L'\x0266', L"\x0068\xE08A" },
    { L'\x0267', L"\x0068\xE08A\xE0A2" },
    { L'\x0267', L"\x0068\xE0A2\xE08A" },
    { L'\x0268', L"\x0069\xE035" },
    { L'\x0269', L"\xE0F1\xE0F2\x0069" },
    { L'\x026A', L"\xE0F8\x0049" },
    { L'\x026B', L"\x006C\xE034" },
    { L'\x026D', L"\x006C\xE022" },
    { L'\x026E', L"\x006C\xE0C4\x0292" },
    { L'\x026F', L"\xE0F9\x006D" },
    { L'\x0271', L"\x006D\xE0A2" },
    { L'\x0272', L"\x006E\xE021" },
    { L'\x0273', L"\x006E\xE022" },
    { L'\x0274', L"\xE0F8\x004E" },
    { L'\x0275', L"\x006F\xE035" },
    { L'\x0276', L"\xE0F8\x004F\xE0C4\x0045" },
    { L'\x0276', L"\xE0F8\x0152" },
    { L'\x0278', L"\xE0F0\xE0F2\x0066" },
    { L'\x0278', L"\xE0F1\xE0F2\x0066" },
    { L'\x0279', L"\xE0F9\x0072" },
    { L'\x027B', L"\x0279\xE022" },
    { L'\x027D', L"\x0072\xE022" },
    { L'\x027E', L"\x0072\xE08A" },
    { L'\x027F', L"\xE0FA\x027E" },
    { L'\x0280', L"\xE0F8\x0052" },
    { L'\x0281', L"\xE0F8\xE0F9\xE0FA\x0052" },
    { L'\x0281', L"\xE0FA\xE160" },
    { L'\x0282', L"\x0073\xE022" },
    { L'\x0283', L"\x017F\xE0A2" },
    { L'\x0284', L"\x017F\xE035\xE0A2" },
    { L'\x0284', L"\x0283\xE082" },
    { L'\x0285', L"\xE0FA\x017F\xE0A2" },
    { L'\x0285', L"\xE0FA\x0283" },
    { L'\x0286', L"\x0283\xE0A5" },
    { L'\x0287', L"\xE0F9\x0074" },
    { L'\x0288', L"\x0074\xE022" },
    { L'\x0289', L"\x0075\xE035" },
    { L'\x028A', L"\xE0F0\xE0F2\xE0F8\xE0F9\x004F\xE004" },
    { L'\x028B', L"\x0076\xE08A" },
    { L'\x028C', L"\xE0F9\x0076" },
    { L'\x028D', L"\xE0F9\x0077" },
    { L'\x028E', L"\xE0F9\x0079" },
    { L'\x028F', L"\xE0F8\x0059" },
    { L'\x0290', L"\x007A\xE022" },
    { L'\x0291', L"\x007A\xE0A5" },
    { L'\x0293', L"\x0292\xE0A5" },
    { L'\x0295', L"\xE0FA\x0294" },
    { L'\x0296', L"\xE0F9\xE0FA\x0294" },
    { L'\x0299', L"\xE0F8\x0042" },
    { L'\x029A', L"\xE0FB\x0277" },
    { L'\x029B', L"\x0262\xE08A" },
    { L'\x029C', L"\xE0F8\x0048" },
    { L'\x029E', L"\xE0F9\x006B" },
    { L'\x029F', L"\xE0F8\x004C" },
    { L'\x02A0', L"\x0071\xE08A" },
    { L'\x02A1', L"\x0294\xE035" },
    { L'\x02A2', L"\x0295\xE035" },
    { L'\x02A3', L"\x0064\xE0C4\x007A" },
    { L'\x02A4', L"\x0064\xE0C4\x0292" },
    { L'\x02A5', L"\x0064\xE0C4\x007A\xE0A5" },
    { L'\x02A5', L"\x0064\xE0C4\x0291" },
    { L'\x02A6', L"\x0074\xE0C4\x0073" },
    { L'\x02A7', L"\x0074\xE0C4\x017F\xE0A2" },
    { L'\x02A7', L"\x0074\xE0C4\x0283" },
    { L'\x02A8', L"\x0074\xE0C4\x0063\xE0A5" },
    { L'\x02A8', L"\x0074\xE0C4\x0255" },
    { L'\x02A9', L"\x0066\xE0C4\x006E\xE0A2" },
    { L'\x02A9', L"\x0066\xE0C4\x014B" },
    { L'\x02AA', L"\x006C\xE0C4\x0073" },
    { L'\x02AB', L"\x006C\xE0C4\x007A" },
    { L'\x02AE', L"\x0265\xE08A" },
    { L'\x02AF', L"\x0265\xE08A\xE0A2" },
    { L'\x02AF', L"\x0265\xE0A2\xE08A" },
    { L'\x02B0', L"\xE0C5\x0068\xE0C6" },
    { L'\x02B0', L"\xE2EC\x0068\xE2ED" },
    { L'\x02B1', L"\xE0C5\x0068\xE08A\xE0C6" },
    { L'\x02B1', L"\xE0C5\x0266\xE0C6" },
    { L'\x02B1', L"\xE2EC\x0068\xE08A\xE2ED" },
    { L'\x02B1', L"\xE2EC\x0266\xE2ED" },
    { L'\x02B2', L"\xE0C5\x006A\xE0C6" },
    { L'\x02B2', L"\xE2EC\x006A\xE2ED" },
    { L'\x02B3', L"\xE0C5\x0072\xE0C6" },
    { L'\x02B3', L"\xE2EC\x0072\xE2ED" },
    { L'\x02B4', L"\xE0C5\x0279\xE0C6" },
    { L'\x02B4', L"\xE0C5\xE0F9\x0072\xE0C6" },
    { L'\x02B4', L"\xE2EC\x0279\xE2ED" },
    { L'\x02B5', L"\xE0C5\x027B\xE0C6" },
    { L'\x02B5', L"\xE0C5\xE0F9\x0072\xE08A\xE0C6" },
    { L'\x02B5', L"\xE2EC\x027B\xE2ED" },
    { L'\x02B6', L"\xE0C5\x0281\xE0C6" },
    { L'\x02B6', L"\xE2EC\x0281\xE2ED" },
    { L'\x02B7', L"\xE0C5\x0077\xE0C6" },
    { L'\x02B7', L"\xE2EC\x0077\xE2ED" },
    { L'\x02B8', L"\xE0C5\x0079\xE0C6" },
    { L'\x02B8', L"\xE2EC\x0079\xE2ED" },
    { L'\x02BA', L"\x02B9\xE0C4\x02B9" },
    { L'\x02BB', L"\x0023\xE012" },
    { L'\x02BC', L"\x0023\xE013" },
    { L'\x02BC', L"\x0023\xE015" },
    { L'\x02BD', L"\x0023\xE014" },
    { L'\x02C2', L"\x0023\xE081" },
    { L'\x02C3', L"\x0023\xE050" },
    { L'\x02C6', L"\x0023\xE002" },
    { L'\x02C6', L"\x0023\xE0B7" },
    { L'\x02C7', L"\x0023\xE00C" },
    { L'\x02C9', L"\x0023\xE004" },
    { L'\x02CC', L"\x0023\xE029" },
    { L'\x02CD', L"\x0023\xE031" },
    { L'\x02CE', L"\x0023\xE016" },
    { L'\x02CF', L"\x0023\xE017" },
    { L'\x02D8', L"\x0023\xE006" },
    { L'\x02D9', L"\x0023\xE007" },
    { L'\x02D9', L"\x0023\xE058" },
    { L'\x02DA', L"\x0023\xE00A" },
    { L'\x02DB', L"\x0023\xE028" },
    { L'\x02DC', L"\x0023\xE003" },
    { L'\x02DD', L"\x0023\xE00B" },
    { L'\x02E0', L"\xE0C5\x0263\xE0C6" },
    { L'\x02E0', L"\xE2EC\x0263\xE2ED" },
    { L'\x02E1', L"\xE0C5\x006C\xE0C6" },
    { L'\x02E1', L"\xE2EC\x006C\xE2ED" },
    { L'\x02E2', L"\xE0C5\x0073\xE0C6" },
    { L'\x02E2', L"\xE2EC\x0073\xE2ED" },
    { L'\x02E3', L"\xE0C5\x0078\xE0C6" },
    { L'\x02E3', L"\xE2EC\x0078\xE2ED" },
    { L'\x02E4', L"\xE0C5\x0295\xE0C6" },
    { L'\x02E4', L"\xE2EC\x0295\xE2ED" },
    { L'\x02EC', L"\x0023\xE02C" },
    { L'\x02ED', L"\x0023\xE03F" },
    { L'\x02F1', L"\x0023\xE054" },
    { L'\x02F2', L"\x0023\xE055" },
    { L'\x02F3', L"\x0023\xE025" },
    { L'\x02F7', L"\x0023\xE030" },
    { L'\x02F8', L"\xE0C5\x003A\xE0C6" },
    { L'\x02F8', L"\xE2EC\x003A\xE2ED" },
    { L'\x02FD', L"\x0023\xE03A" },
    { L'\x0300', L"\x203F\xE000" },
    { L'\x0301', L"\x203F\xE001" },
    { L'\x0302', L"\x203F\xE002" },
    { L'\x0303', L"\x203F\xE003" },
    { L'\x0304', L"\x203F\xE004" },
    { L'\x0306', L"\x203F\xE006" },
    { L'\x0307', L"\x203F\xE007" },
    { L'\x0308', L"\x203F\xE008" },
    { L'\x0309', L"\x203F\xE009" },
    { L'\x030A', L"\x203F\xE00A" },
    { L'\x030B', L"\x203F\xE00B" },
    { L'\x030C', L"\x203F\xE00C" },
    { L'\x030D', L"\x203F\xE00D" },
    { L'\x030E', L"\x203F\xE00E" },
    { L'\x030F', L"\x203F\xE00F" },
    { L'\x0310', L"\x203F\xE006\xE007" },
    { L'\x0311', L"\x203F\xE011" },
    { L'\x0312', L"\x203F\xE012" },
    { L'\x0313', L"\x203F\xE013" },
    { L'\x0314', L"\x203F\xE014" },
    { L'\x0315', L"\x203F\xE015" },
    { L'\x0316', L"\x203F\xE016" },
    { L'\x0317', L"\x203F\xE017" },
    { L'\x0318', L"\x203F\xE018" },
    { L'\x0319', L"\x203F\xE019" },
    { L'\x031A', L"\x203F\xE01A" },
    { L'\x031B', L"\x203F\xE01B" },
    { L'\x031C', L"\x203F\xE01C" },
    { L'\x031D', L"\x203F\xE01D" },
    { L'\x031E', L"\x203F\xE01E" },
    { L'\x031F', L"\x203F\xE01F" },
    { L'\x0320', L"\x203F\xE020" },
    { L'\x0321', L"\x203F\xE021" },
    { L'\x0322', L"\x203F\xE022" },
    { L'\x0323', L"\x203F\xE023" },
    { L'\x0324', L"\x203F\xE024" },
    { L'\x0325', L"\x203F\xE025" },
    { L'\x0326', L"\x203F\xE026" },
    { L'\x0327', L"\x203F\xE027" },
    { L'\x0328', L"\x203F\xE028" },
    { L'\x0329', L"\x203F\xE029" },
    { L'\x032A', L"\x203F\xE02A" },
    { L'\x032B', L"\x203F\xE02B" },
    { L'\x032C', L"\x203F\xE02C" },
    { L'\x032D', L"\x203F\xE02D" },
    { L'\x032E', L"\x203F\xE02E" },
    { L'\x032F', L"\x203F\xE02F" },
    { L'\x0330', L"\x203F\xE030" },
    { L'\x0331', L"\x203F\xE031" },
    { L'\x0333', L"\x203F\xE033" },
    { L'\x0334', L"\x203F\xE034" },
    { L'\x0335', L"\x203F\xE035" },
    { L'\x0337', L"\x203F\xE037" },
    { L'\x0339', L"\x203F\xE039" },
    { L'\x033A', L"\x203F\xE03A" },
    { L'\x033B', L"\x203F\xE03B" },
    { L'\x033C', L"\x203F\xE03C" },
    { L'\x033D', L"\x203F\xE03D" },
    { L'\x033E', L"\x203F\xE03E" },
    { L'\x033F', L"\x203F\xE03F" },
    { L'\x0342', L"\x203F\xE042" },
    { L'\x0345', L"\x203F\xE045" },
    { L'\x0346', L"\x203F\xE046" },
    { L'\x0347', L"\x203F\xE047" },
    { L'\x0348', L"\x203F\xE048" },
    { L'\x0349', L"\x203F\xE049" },
    { L'\x034A', L"\x203F\xE04A" },
    { L'\x034B', L"\x203F\xE04B" },
    { L'\x034C', L"\x203F\xE04C" },
    { L'\x034D', L"\x203F\xE04D" },
    { L'\x034E', L"\x203F\xE04E" },
    { L'\x0350', L"\x203F\xE050" },
    { L'\x0351', L"\x203F\xE051" },
    { L'\x0352', L"\x203F\xE007\xE011" },
    { L'\x0353', L"\x203F\xE053" },
    { L'\x0354', L"\x203F\xE054" },
    { L'\x0355', L"\x203F\xE055" },
    { L'\x0356', L"\x203F\xE056" },
    { L'\x0356', L"\x203F\xE0A4" },
    { L'\x0357', L"\x203F\xE057" },
    { L'\x0358', L"\x203F\xE058" },
    { L'\x0359', L"\x203F\xE059" },
    { L'\x035A', L"\x203F\xE05A" },
    { L'\x035B', L"\x203F\xE05B" },
    { L'\x035C', L"\x203F\xE05C" },
    { L'\x035C', L"\x203F\xE0C9" },
    { L'\x035D', L"\x203F\xE05D" },
    { L'\x035E', L"\x203F\xE05E" },
    { L'\x035F', L"\x203F\xE05F" },
    { L'\x0360', L"\x203F\xE060" },
    { L'\x0361', L"\x203F\xE061" },
    { L'\x0361', L"\x203F\xE0C8" },
    { L'\x0362', L"\x203F\xE062" },
    { L'\x0363', L"\x203F\xE063" },
    { L'\x0364', L"\x203F\xE064" },
    { L'\x0365', L"\x203F\xE065" },
    { L'\x0366', L"\x203F\xE066" },
    { L'\x0367', L"\x203F\xE067" },
    { L'\x0368', L"\x203F\xE068" },
    { L'\x0369', L"\x203F\xE069" },
    { L'\x036A', L"\x203F\xE06A" },
    { L'\x036B', L"\x203F\xE06B" },
    { L'\x036C', L"\x203F\xE06C" },
    { L'\x036D', L"\x203F\xE06D" },
    { L'\x036E', L"\x203F\xE06E" },
    { L'\x036F', L"\x203F\xE06F" },
    { L'\x037A', L"\x0023\xE045" },
    { L'\x0386', L"\x0391\xE001" },
    { L'\x0388', L"\x0395\xE001" },
    { L'\x0389', L"\x0397\xE001" },
    { L'\x038A', L"\x0399\xE001" },
    { L'\x038C', L"\x039F\xE001" },
    { L'\x038E', L"\x03A5\xE001" },
    { L'\x038F', L"\x03A9\xE001" },
    { L'\x0390', L"\x03B9\xE008\xE001" },
    { L'\x0391', L"\xE0F2\x0041" },
    { L'\x0392', L"\xE0F2\x0042" },
    { L'\x0393', L"\xE0F2\x0047" },
    { L'\x0394', L"\xE0F2\x0044" },
    { L'\x0395', L"\xE0F2\x0045" },
    { L'\x0396', L"\xE0F2\x005A" },
    { L'\x0397', L"\xE0F2\x0045\xE004" },
    { L'\x0398', L"\xE0F2\x0054\xE0C4\x0048" },
    { L'\x0398', L"\xE0F2\x0054\xE0C4\x0068" },
    { L'\x0399', L"\xE0F2\x0049" },
    { L'\x039A', L"\xE0F2\x004B" },
    { L'\x039B', L"\xE0F2\x004C" },
    { L'\x039C', L"\xE0F2\x004D" },
    { L'\x039D', L"\xE0F2\x004E" },
    { L'\x039E', L"\xE0F2\x0058" },
    { L'\x039F', L"\xE0F2\x004F" },
    { L'\x03A0', L"\xE0F2\x0050" },
    { L'\x03A1', L"\xE0F2\x0052" },
    { L'\x03A3', L"\xE0F2\x0053" },
    { L'\x03A4', L"\xE0F2\x0054" },
    { L'\x03A5', L"\xE0F2\x0059" },
    { L'\x03A6', L"\xE0F2\x0046" },
    { L'\x03A6', L"\xE0F2\x0050\xE0C4\x0048" },
    { L'\x03A6', L"\xE0F2\x0050\xE0C4\x0068" },
    { L'\x03A7', L"\xE0F2\x0048" },
    { L'\x03A8', L"\xE0F2\x0050\xE0C4\x0053" },
    { L'\x03A8', L"\xE0F2\x0050\xE0C4\x0073" },
    { L'\x03A9', L"\xE0F2\x004F\xE004" },
    { L'\x03AA', L"\x0399\xE008" },
    { L'\x03AB', L"\x03A5\xE008" },
    { L'\x03AC', L"\x03B1\xE001" },
    { L'\x03AD', L"\x03B5\xE001" },
    { L'\x03AE', L"\x03B7\xE001" },
    { L'\x03AF', L"\x03B9\xE001" },
    { L'\x03B0', L"\x03C5\xE008\xE001" },
    { L'\x03B1', L"\xE0F2\x0061" },
    { L'\x03B2', L"\xE0F2\x0062" },
    { L'\x03B3', L"\xE0F2\x0067" },
    { L'\x03B4', L"\xE0F2\x0064" },
    { L'\x03B5', L"\xE0F2\x0065" },
    { L'\x03B6', L"\xE0F2\x007A" },
    { L'\x03B7', L"\xE0F2\x0065\xE004" },
    { L'\x03B8', L"\xE0F2\x0074\xE0C4\x0068" },
    { L'\x03B9', L"\xE0F2\x0069" },
    { L'\x03BA', L"\xE0F2\x006B" },
    { L'\x03BB', L"\xE0F2\x006C" },
    { L'\x03BC', L"\xE0F2\x006D" },
    { L'\x03BD', L"\xE0F2\x006E" },
    { L'\x03BE', L"\xE0F2\x0078" },
    { L'\x03BF', L"\xE0F2\x006F" },
    { L'\x03C0', L"\xE0F2\x0070" },
    { L'\x03C1', L"\xE0F2\x0072" },
    { L'\x03C2', L"\xE0F2\x0073\x0023" },
    { L'\x03C3', L"\xE0F2\x0073" },
    { L'\x03C3', L"\xE0F2\x0073\xE00C" },
    { L'\x03C3', L"\xE0F2\x0077" },
    { L'\x03C4', L"\xE0F2\x0074" },
    { L'\x03C5', L"\xE0F2\x0079" },
    { L'\x03C6', L"\xE0F2\x0066" },
    { L'\x03C6', L"\xE0F2\x0070\xE0C4\x0068" },
    { L'\x03C7', L"\xE0F2\x0068" },
    { L'\x03C7', L"\xE0F8\xE15B" },
    { L'\x03C8', L"\xE0F2\x0070\xE0C4\x0073" },
    { L'\x03C9', L"\xE0F2\x006F\xE004" },
    { L'\x03CA', L"\x03B9\xE008" },
    { L'\x03CB', L"\x03C5\xE008" },
    { L'\x03CC', L"\x03BF\xE001" },
    { L'\x03CD', L"\x03C5\xE001" },
    { L'\x03CE', L"\x03C9\xE001" },
    { L'\x03D1', L"\xE0F1\xE0F2\x0074\xE0C4\x0068" },
    { L'\x03D1', L"\xE0F2\x0074\xE0C4\x006B" },
    { L'\x03DC', L"\xE0F2\x0056" },
    { L'\x03DD', L"\xE0F2\x0076" },
    { L'\x0400', L"\x0415\xE000" },
    { L'\x0401', L"\x0415\xE008" },
    { L'\x0403', L"\x0413\xE001" },
    { L'\x0407', L"\x0406\xE008" },
    { L'\x0408', L"\xE0F3\x004A" },
    { L'\x040C', L"\x041A\xE001" },
    { L'\x040D', L"\x0418\xE000" },
    { L'\x040E', L"\x0423\xE006" },
    { L'\x0410', L"\xE0F3\x0041" },
    { L'\x0411', L"\xE0F3\x0042" },
    { L'\x0412', L"\xE0F3\x0056" },
    { L'\x0413', L"\xE0F3\x0047" },
    { L'\x0414', L"\xE0F3\x0044" },
    { L'\x0415', L"\xE0F3\x0045" },
    { L'\x0416', L"\xE0F3\x005A\xE00C" },
    { L'\x0416', L"\xE0F3\x017D" },
    { L'\x0417', L"\xE0F3\x005A" },
    { L'\x0418', L"\xE0F3\x0049" },
    { L'\x0419', L"\x0418\xE006" },
    { L'\x041A', L"\xE0F3\x004B" },
    { L'\x041B', L"\xE0F3\x004C" },
    { L'\x041C', L"\xE0F3\x004D" },
    { L'\x041D', L"\xE0F3\x004E" },
    { L'\x041E', L"\xE0F3\x004F" },
    { L'\x041F', L"\xE0F3\x0050" },
    { L'\x0420', L"\xE0F3\x0052" },
    { L'\x0421', L"\xE0F3\x0053" },
    { L'\x0422', L"\xE0F3\x0054" },
    { L'\x0423', L"\xE0F3\x0055" },
    { L'\x0424', L"\xE0F3\x0046" },
    { L'\x0425', L"\xE0F3\x0048" },
    { L'\x0426', L"\xE0F3\x0043" },
    { L'\x0427', L"\xE0F3\x0043\xE00C" },
    { L'\x0427', L"\xE0F3\x010C" },
    { L'\x0428', L"\xE0F3\x0053\xE00C" },
    { L'\x0428', L"\xE0F3\x0160" },
    { L'\x042B', L"\xE0F3\x0059" },
    { L'\x0430', L"\xE0F3\x0061" },
    { L'\x0431', L"\xE0F3\x0062" },
    { L'\x0432', L"\xE0F3\x0076" },
    { L'\x0433', L"\xE0F3\x0067" },
    { L'\x0434', L"\xE0F3\x0064" },
    { L'\x0435', L"\xE0F3\x0065" },
    { L'\x0436', L"\xE0F3\x007A\xE00C" },
    { L'\x0436', L"\xE0F3\x017E" },
    { L'\x0437', L"\xE0F3\x007A" },
    { L'\x0438', L"\xE0F3\x0069" },
    { L'\x0439', L"\x0438\xE006" },
    { L'\x043A', L"\xE0F3\x006B" },
    { L'\x043B', L"\xE0F3\x006C" },
    { L'\x043C', L"\xE0F3\x006D" },
    { L'\x043D', L"\xE0F3\x006E" },
    { L'\x043E', L"\xE0F3\x006F" },
    { L'\x043F', L"\xE0F3\x0070" },
    { L'\x0440', L"\xE0F3\x0072" },
    { L'\x0441', L"\xE0F3\x0073" },
    { L'\x0442', L"\xE0F3\x0074" },
    { L'\x0443', L"\xE0F3\x0075" },
    { L'\x0444', L"\xE0F3\x0066" },
    { L'\x0445', L"\xE0F3\x0068" },
    { L'\x0446', L"\xE0F3\x0063" },
    { L'\x0447', L"\xE0F3\x0063\xE00C" },
    { L'\x0447', L"\xE0F3\x010D" },
    { L'\x0448', L"\xE0F3\x0073\xE00C" },
    { L'\x0448', L"\xE0F3\x0161" },
    { L'\x044B', L"\xE0F3\x0079" },
    { L'\x0450', L"\x0435\xE000" },
    { L'\x0451', L"\x0435\xE008" },
    { L'\x0453', L"\x0433\xE001" },
    { L'\x0457', L"\x0456\xE008" },
    { L'\x0458', L"\xE0F3\x006A" },
    { L'\x045C', L"\x043A\xE001" },
    { L'\x045D', L"\x0438\xE000" },
    { L'\x045E', L"\x0443\xE006" },
    { L'\x0476', L"\x0474\xE00F" },
    { L'\x0477', L"\x0475\xE00F" },
    { L'\x0492', L"\x0413\xE035" },
    { L'\x0493', L"\x0433\xE035" },
    { L'\x0496', L"\x0416\xE0A6" },
    { L'\x0497', L"\x0436\xE0A6" },
    { L'\x0498', L"\x0417\xE0A6" },
    { L'\x0499', L"\x0437\xE0A6" },
    { L'\x049A', L"\x041A\xE0A6" },
    { L'\x049B', L"\x043A\xE0A6" },
    { L'\x049C', L"\x041A\xE0B8" },
    { L'\x049D', L"\x043A\xE0B8" },
    { L'\x049E', L"\x041A\xE035" },
    { L'\x049F', L"\x043A\xE035" },
    { L'\x04A2', L"\x041D\xE0A6" },
    { L'\x04A3', L"\x043D\xE0A6" },
    { L'\x04A4', L"\x041D\xE0C4\x0413" },
    { L'\x04A5', L"\x043D\xE0C4\x0433" },
    { L'\x04A6', L"\x041F\xE0A2" },
    { L'\x04A7', L"\x043F\xE0A2" },
    { L'\x04AA', L"\x0421\xE0A6" },
    { L'\x04AB', L"\x0441\xE0A6" },
    { L'\x04AC', L"\x0422\xE0A6" },
    { L'\x04AD', L"\x0442\xE0A6" },
    { L'\x04B2', L"\x0425\xE0A6" },
    { L'\x04B3', L"\x0445\xE0A6" },
    { L'\x04B4', L"\x0422\xE0C4\x0426" },
    { L'\x04B5', L"\x0442\xE0C4\x0446" },
    { L'\x04B6', L"\x0427\xE0A6" },
    { L'\x04B7', L"\x0447\xE0A6" },
    { L'\x04B8', L"\x0427\xE0B8" },
    { L'\x04B9', L"\x0447\xE0B8" },
    { L'\x04BE', L"\x04BC\xE0A6" },
    { L'\x04BF', L"\x04BD\xE0A6" },
    { L'\x04C1', L"\x0416\xE006" },
    { L'\x04C2', L"\x0436\xE006" },
    { L'\x04C3', L"\x041A\xE0A2" },
    { L'\x04C4', L"\x043A\xE0A2" },
    { L'\x04C5', L"\x041B\xE0A6" },
    { L'\x04C6', L"\x043B\xE0A6" },
    { L'\x04C7', L"\x041D\xE0A2" },
    { L'\x04C8', L"\x043D\xE0A2" },
    { L'\x04D0', L"\x0410\xE006" },
    { L'\x04D1', L"\x0430\xE006" },
    { L'\x04D2', L"\x0410\xE008" },
    { L'\x04D3', L"\x0430\xE008" },
    { L'\x04D4', L"\x0410\xE0C4\x0415" },
    { L'\x04D5', L"\x0430\xE0C4\x0435" },
    { L'\x04D6', L"\x0415\xE006" },
    { L'\x04D7', L"\x0435\xE006" },
    { L'\x04DA', L"\x04D8\xE008" },
    { L'\x04DB', L"\x04D9\xE008" },
    { L'\x04DC', L"\x0416\xE008" },
    { L'\x04DD', L"\x0436\xE008" },
    { L'\x04DE', L"\x0417\xE008" },
    { L'\x04DF', L"\x0437\xE008" },
    { L'\x04E2', L"\x0418\xE004" },
    { L'\x04E3', L"\x0438\xE004" },
    { L'\x04E4', L"\x0418\xE008" },
    { L'\x04E5', L"\x0438\xE008" },
    { L'\x04E6', L"\x041E\xE008" },
    { L'\x04E7', L"\x043E\xE008" },
    { L'\x04E8', L"\x041E\xE035" },
    { L'\x04E9', L"\x043E\xE035" },
    { L'\x04EA', L"\x041E\xE035\xE008" },
    { L'\x04EB', L"\x043E\xE035\xE008" },
    { L'\x04EC', L"\x042D\xE008" },
    { L'\x04ED', L"\x044D\xE008" },
    { L'\x04EE', L"\x0423\xE004" },
    { L'\x04EF', L"\x0443\xE004" },
    { L'\x04F0', L"\x0423\xE008" },
    { L'\x04F1', L"\x0443\xE008" },
    { L'\x04F2', L"\x0423\xE00B" },
    { L'\x04F3', L"\x0443\xE00B" },
    { L'\x04F4', L"\x0427\xE008" },
    { L'\x04F5', L"\x0447\xE008" },
    { L'\x04F6', L"\x0413\xE0A6" },
    { L'\x04F7', L"\x0433\xE0A6" },
    { L'\x04F8', L"\x042B\xE008" },
    { L'\x04F9', L"\x044B\xE008" },
    { L'\x04FA', L"\x0413\xE035\xE0A2" },
    { L'\x04FA', L"\x0413\xE0A2\xE035" },
    { L'\x04FB', L"\x0433\xE035\xE0A2" },
    { L'\x04FB', L"\x0433\xE0A2\xE035" },
    { L'\x04FC', L"\x0425\xE0A2" },
    { L'\x04FD', L"\x0445\xE0A2" },
    { L'\x04FE', L"\x0425\xE035" },
    { L'\x04FF', L"\x0445\xE035" },
    { L'\x0510', L"\xE0F3\xE0FA\x005A" },
    { L'\x0510', L"\xE0FA\x0417" },
    { L'\x0511', L"\xE0F3\xE0FA\x007A" },
    { L'\x0511', L"\xE0FA\x0437" },
    { L'\x0512', L"\x041B\xE0A2" },
    { L'\x0513', L"\x043B\xE0A2" },
    { L'\x1D01', L"\xE0F8\x0041\xE0C4\x0045" },
    { L'\x1D01', L"\xE0F8\x00C6" },
    { L'\x1D02', L"\xE0F9\x0061\xE0C4\x0065" },
    { L'\x1D02', L"\xE0F9\x00E6" },
    { L'\x1D03', L"\x0299\xE035" },
    { L'\x1D03', L"\xE0F8\x0042\xE035" },
    { L'\x1D03', L"\xE0F8\x0243" },
    { L'\x1D04', L"\xE0F8\x0043" },
    { L'\x1D05', L"\xE0F8\x0044" },
    { L'\x1D06', L"\xE0F8\x0044\xE035" },
    { L'\x1D08', L"\xE0F1\xE0F2\xE0F9\x0065" },
    { L'\x1D09', L"\xE0F9\x0069" },
    { L'\x1D09', L"\xE13E" },
    { L'\x1D0A', L"\xE0F8\x004A" },
    { L'\x1D0C', L"\xE0F8\x004C\xE037" },
    { L'\x1D0C', L"\xE0F8\x0141" },
    { L'\x1D0D', L"\xE0F8\x004D" },
    { L'\x1D0E', L"\xE0F8\xE0FA\x004E" },
    { L'\x1D0F', L"\xE0F8\x004F" },
    { L'\x1D10', L"\xE0F8\xE0F9\x0063" },
    { L'\x1D11', L"\xE0F8\xE0FB\x006F" },
    { L'\x1D11', L"\xE0F8\xE0FC\x006F" },
    { L'\x1D12', L"\xE0F8\xE0FB\x0063" },
    { L'\x1D13', L"\xE0F8\xE0FB\x006F\xE037" },
    { L'\x1D13', L"\xE0F8\xE0FC\x006F\xE037" },
    { L'\x1D14', L"\xE0F9\x006F\xE0C4\x0065" },
    { L'\x1D14', L"\xE0F9\x0153" },
    { L'\x1D18', L"\xE0F8\x0050" },
    { L'\x1D19', L"\xE0F8\xE0FA\x0052" },
    { L'\x1D1B', L"\xE0F8\x0054" },
    { L'\x1D1D', L"\xE0FC\x0075" },
    { L'\x1D1E', L"\xE0FC\x0075\xE008" },
    { L'\x1D1F', L"\xE0FB\x006D" },
    { L'\x1D20', L"\xE0F8\x0056" },
    { L'\x1D21', L"\xE0F8\x0057" },
    { L'\x1D22', L"\xE0F8\x005A" },
    { L'\x1D23', L"\xE0F8\x01B7" },
    { L'\x1D26', L"\xE0F2\xE0F8\x0047" },
    { L'\x1D26', L"\xE0F8\x0393" },
    { L'\x1D27', L"\xE0F2\xE0F8\x004C" },
    { L'\x1D27', L"\xE0F8\x039B" },
    { L'\x1D28', L"\xE0F2\xE0F8\x0050" },
    { L'\x1D28', L"\xE0F8\x03A0" },
    { L'\x1D29', L"\xE0F2\xE0F8\x0052" },
    { L'\x1D29', L"\xE0F8\x03A1" },
    { L'\x1D2A', L"\xE0F2\xE0F8\x0050\xE0C4\x0053" },
    { L'\x1D2A', L"\xE0F8\x03A8" },
    { L'\x1D2B', L"\xE0F3\xE0F8\x004C" },
    { L'\x1D2B', L"\xE0F8\x041B" },
    { L'\x1D2C', L"\xE0C5\x0041\xE0C6" },
    { L'\x1D2C', L"\xE2EC\x0041\xE2ED" },
    { L'\x1D2D', L"\xE0C5\x0041\xE0C4\x0045\xE0C6" },
    { L'\x1D2D', L"\xE2EC\x0041\xE0C4\x0045\xE2ED" },
    { L'\x1D2E', L"\xE0C5\x0042\xE0C6" },
    { L'\x1D2E', L"\xE2EC\x0042\xE2ED" },
    { L'\x1D2F', L"\x1D2E\xE035" },
    { L'\x1D2F', L"\xE0C5\x0042\xE035\xE0C6" },
    { L'\x1D2F', L"\xE2EC\x0042\xE035\xE2ED" },
    { L'\x1D30', L"\xE0C5\x0044\xE0C6" },
    { L'\x1D30', L"\xE2EC\x0044\xE2ED" },
    { L'\x1D31', L"\xE0C5\x0045\xE0C6" },
    { L'\x1D31', L"\xE2EC\x0045\xE2ED" },
    { L'\x1D32', L"\xE0C5\x018E\xE0C6" },
    { L'\x1D32', L"\xE0C5\xE0F9\x0045\xE0C6" },
    { L'\x1D32', L"\xE2EC\x018E\xE2ED" },
    { L'\x1D33', L"\xE0C5\x0047\xE0C6" },
    { L'\x1D33', L"\xE2EC\x0047\xE2ED" },
    { L'\x1D34', L"\xE0C5\x0048\xE0C6" },
    { L'\x1D34', L"\xE2EC\x0048\xE2ED" },
    { L'\x1D35', L"\xE0C5\x0049\xE0C6" },
    { L'\x1D35', L"\xE0C5\x026A\xE0C6" },
    { L'\x1D35', L"\xE2EC\x0049\xE2ED" },
    { L'\x1D35', L"\xE2EC\x026A\xE2ED" },
    { L'\x1D36', L"\xE0C5\x004A\xE0C6" },
    { L'\x1D36', L"\xE2EC\x004A\xE2ED" },
    { L'\x1D37', L"\xE0C5\x004B\xE0C6" },
    { L'\x1D37', L"\xE2EC\x004B\xE2ED" },
    { L'\x1D38', L"\xE0C5\x004C\xE0C6" },
    { L'\x1D38', L"\xE2EC\x004C\xE2ED" },
    { L'\x1D39', L"\xE0C5\x004D\xE0C6" },
    { L'\x1D39', L"\xE2EC\x004D\xE2ED" },
    { L'\x1D3A', L"\xE0C5\x004E\xE0C6" },
    { L'\x1D3A', L"\xE2EC\x004E\xE2ED" },
    { L'\x1D3B', L"\xE0C5\xE0FA\x004E\xE0C6" },
    { L'\x1D3C', L"\xE0C5\x004F\xE0C6" },
    { L'\x1D3C', L"\xE2EC\x004F\xE2ED" },
    { L'\x1D3E', L"\xE0C5\x0050\xE0C6" },
    { L'\x1D3E', L"\xE2EC\x0050\xE2ED" },
    { L'\x1D3F', L"\xE0C5\x0052\xE0C6" },
    { L'\x1D3F', L"\xE2EC\x0052\xE2ED" },
    { L'\x1D40', L"\xE0C5\x0054\xE0C6" },
    { L'\x1D40', L"\xE2EC\x0054\xE2ED" },
    { L'\x1D41', L"\xE0C5\x0055\xE0C6" },
    { L'\x1D41', L"\xE2EC\x0055\xE2ED" },
    { L'\x1D42', L"\xE0C5\x0057\xE0C6" },
    { L'\x1D42', L"\xE2EC\x0057\xE2ED" },
    { L'\x1D43', L"\xE0C5\x0061\xE0C6" },
    { L'\x1D43', L"\xE2EC\x0061\xE2ED" },
    { L'\x1D44', L"\xE0C5\x0250\xE0C6" },
    { L'\x1D44', L"\xE0C5\xE0F9\x0061\xE0C6" },
    { L'\x1D44', L"\xE2EC\x0250\xE2ED" },
    { L'\x1D45', L"\xE0C5\x0251\xE0C6" },
    { L'\x1D45', L"\xE0C5\xE0F1\xE0F2\x0061\xE0C6" },
    { L'\x1D45', L"\xE2EC\x0251\xE2ED" },
    { L'\x1D46', L"\xE0C5\x1D02\xE0C6" },
    { L'\x1D46', L"\xE0C5\xE0F9\x0061\xE0C4\x0065\xE0C6" },
    { L'\x1D46', L"\xE2EC\x1D02\xE2ED" },
    { L'\x1D47', L"\xE0C5\x0062\xE0C6" },
    { L'\x1D47', L"\xE2EC\x0062\xE2ED" },
    { L'\x1D48', L"\xE0C5\x0064\xE0C6" },
    { L'\x1D48', L"\xE2EC\x0064\xE2ED" },
    { L'\x1D49', L"\xE0C5\x0065\xE0C6" },
    { L'\x1D49', L"\xE2EC\x0065\xE2ED" },
    { L'\x1D4A', L"\xE0C5\x0259\xE0C6" },
    { L'\x1D4A', L"\xE2EC\x0259\xE2ED" },
    { L'\x1D4B', L"\xE0C5\x03B5\xE0C6" },
    { L'\x1D4B', L"\xE0C5\xE0F1\xE0F2\x0065\xE0C6" },
    { L'\x1D4B', L"\xE2EC\x03B5\xE2ED" },
    { L'\x1D4C', L"\xE0C5\x1D08\xE0C6" },
    { L'\x1D4C', L"\xE0C5\xE0F1\xE0F2\xE0F9\x0065\xE0C6" },
    { L'\x1D4C', L"\xE0C5\xE0F9\x03B5\xE0C6" },
    { L'\x1D4D', L"\xE0C5\x0067\xE0C6" },
    { L'\x1D4D', L"\xE2EC\x0067\xE2ED" },
    { L'\x1D4E', L"\xE0C5\x1D09\xE0C6" },
    { L'\x1D4E', L"\xE0C5\xE0F9\x0069\xE0C6" },
    { L'\x1D4E', L"\xE0C5\xE13E\xE0C6" },
    { L'\x1D4E', L"\xE2EC\x1D09\xE2ED" },
    { L'\x1D4F', L"\xE0C5\x006B\xE0C6" },
    { L'\x1D4F', L"\xE2EC\x006B\xE2ED" },
    { L'\x1D50', L"\xE0C5\x006D\xE0C6" },
    { L'\x1D50', L"\xE2EC\x006D\xE2ED" },
    { L'\x1D51', L"\xE0C5\x006E\xE0A2\xE0C6" },
    { L'\x1D51', L"\xE0C5\x014B\xE0C6" },
    { L'\x1D51', L"\xE2EC\x006E\xE0A2\xE2ED" },
    { L'\x1D51', L"\xE2EC\x014B\xE2ED" },
    { L'\x1D52', L"\xE0C5\x006F\xE0C6" },
    { L'\x1D52', L"\xE2EC\x006F\xE2ED" },
    { L'\x1D53', L"\xE0C5\xE0F9\x0063\xE0C6" },
    { L'\x1D54', L"\xE0C5\x1D16\xE0C6" },
    { L'\x1D54', L"\xE2EC\x1D16\xE2ED" },
    { L'\x1D55', L"\xE0C5\x1D17\xE0C6" },
    { L'\x1D55', L"\xE2EC\x1D17\xE2ED" },
    { L'\x1D56', L"\xE0C5\x0070\xE0C6" },
    { L'\x1D56', L"\xE2EC\x0070\xE2ED" },
    { L'\x1D57', L"\xE0C5\x0074\xE0C6" },
    { L'\x1D57', L"\xE2EC\x0074\xE2ED" },
    { L'\x1D58', L"\xE0C5\x0075\xE0C6" },
    { L'\x1D58', L"\xE2EC\x0075\xE2ED" },
    { L'\x1D59', L"\xE0C5\x1D1D\xE0C6" },
    { L'\x1D59', L"\xE0C5\xE0FC\x0075\xE0C6" },
    { L'\x1D59', L"\xE2EC\x1D1D\xE2ED" },
    { L'\x1D5A', L"\xE0C5\xE0F9\x006D\xE0C6" },
    { L'\x1D5B', L"\xE0C5\x0076\xE0C6" },
    { L'\x1D5B', L"\xE2EC\x0076\xE2ED" },
    { L'\x1D5C', L"\xE0C5\x1D25\xE0C6" },
    { L'\x1D5C', L"\xE2EC\x1D25\xE2ED" },
    { L'\x1D5D', L"\xE0C5\x03B2\xE0C6" },
    { L'\x1D5D', L"\xE0C5\xE0F2\x0062\xE0C6" },
    { L'\x1D5D', L"\xE2EC\x03B2\xE2ED" },
    { L'\x1D5E', L"\xE0C5\x03B3\xE0C6" },
    { L'\x1D5E', L"\xE0C5\xE0F2\x0067\xE0C6" },
    { L'\x1D5E', L"\xE2EC\x03B3\xE2ED" },
    { L'\x1D5F', L"\xE0C5\x03B4\xE0C6" },
    { L'\x1D5F', L"\xE0C5\xE0F2\x0064\xE0C6" },
    { L'\x1D5F', L"\xE2EC\x03B4\xE2ED" },
    { L'\x1D60', L"\xE0C5\x03C6\xE0C6" },
    { L'\x1D60', L"\xE0C5\xE0F2\x0066\xE0C6" },
    { L'\x1D60', L"\xE2EC\x03C6\xE2ED" },
    { L'\x1D61', L"\xE0C5\x03C7\xE0C6" },
    { L'\x1D61', L"\xE0C5\xE0F2\x0068\xE0C6" },
    { L'\x1D61', L"\xE2EC\x03C7\xE2ED" },
    { L'\x1D62', L"\xE0CE\x0069\xE0CF" },
    { L'\x1D62', L"\xE2EE\x0069\xE2EF" },
    { L'\x1D63', L"\xE0CE\x0072\xE0CF" },
    { L'\x1D63', L"\xE2EE\x0072\xE2EF" },
    { L'\x1D64', L"\xE0CE\x0075\xE0CF" },
    { L'\x1D64', L"\xE2EE\x0075\xE2EF" },
    { L'\x1D65', L"\xE0CE\x0076\xE0CF" },
    { L'\x1D65', L"\xE2EE\x0076\xE2EF" },
    { L'\x1D66', L"\xE0CE\x03B2\xE0CF" },
    { L'\x1D66', L"\xE0CE\xE0F2\x0062\xE0CF" },
    { L'\x1D66', L"\xE2EE\x03B2\xE2EF" },
    { L'\x1D66', L"\xE2EE\xE0F2\x0062\xE2EF" },
    { L'\x1D67', L"\xE0CE\x03B3\xE0CF" },
    { L'\x1D67', L"\xE0CE\xE0F2\x0067\xE0CF" },
    { L'\x1D67', L"\xE2EE\x03B3\xE2EF" },
    { L'\x1D67', L"\xE2EE\xE0F2\x0067\xE2EF" },
    { L'\x1D68', L"\xE0CE\x03C1\xE0CF" },
    { L'\x1D68', L"\xE0CE\xE0F2\x0072\xE0CF" },
    { L'\x1D68', L"\xE2EE\x03C1\xE2EF" },
    { L'\x1D68', L"\xE2EE\xE0F2\x0072\xE2EF" },
    { L'\x1D69', L"\xE0CE\x03C6\xE0CF" },
    { L'\x1D69', L"\xE0CE\xE0F2\x0066\xE0CF" },
    { L'\x1D69', L"\xE2EE\x03C6\xE2EF" },
    { L'\x1D69', L"\xE2EE\xE0F2\x0066\xE2EF" },
    { L'\x1D6A', L"\xE0CE\x03C7\xE0CF" },
    { L'\x1D6A', L"\xE0CE\xE0F2\x0068\xE0CF" },
    { L'\x1D6A', L"\xE2EE\x03C7\xE2EF" },
    { L'\x1D6A', L"\xE2EE\xE0F2\x0068\xE2EF" },
    { L'\x1D6B', L"\x0075\xE0C4\x0065" },
    { L'\x1D6C', L"\x0062\xE034" },
    { L'\x1D6D', L"\x0064\xE034" },
    { L'\x1D6E', L"\x0066\xE034" },
    { L'\x1D6F', L"\x006D\xE034" },
    { L'\x1D70', L"\x006E\xE034" },
    { L'\x1D71', L"\x0070\xE034" },
    { L'\x1D72', L"\x0072\xE034" },
    { L'\x1D73', L"\x0072\xE034\xE08A" },
    { L'\x1D73', L"\x0072\xE08A\xE034" },
    { L'\x1D73', L"\x027E\xE034" },
    { L'\x1D74', L"\x0073\xE034" },
    { L'\x1D75', L"\x0074\xE034" },
    { L'\x1D76', L"\x007A\xE034" },
    { L'\x1D77', L"\xE0F9\x0067" },
    { L'\x1D78', L"\xE0C5\x043D\xE0C6" },
    { L'\x1D78', L"\xE0C5\xE0F3\x004E\xE0C6" },
    { L'\x1D78', L"\xE2EC\x043D\xE2ED" },
    { L'\x1D7A', L"\x0074\xE0CC\x0068" },
    { L'\x1D7B', L"\x026A\xE035" },
    { L'\x1D7B', L"\xE0F8\x0049\xE035" },
    { L'\x1D7C', L"\x0269\xE035" },
    { L'\x1D7C', L"\xE0F1\xE0F2\x0069\xE035" },
    { L'\x1D7D', L"\x0070\xE035" },
    { L'\x1D7E', L"\x1D1C\xE035" },
    { L'\x1D7E', L"\xE0F8\x0055\xE035" },
    { L'\x1D7E', L"\xE13F\xE035" },
    { L'\x1D7F', L"\x028A\xE035" },
    { L'\x1D9C', L"\xE0C5\x0063\xE0C6" },
    { L'\x1D9C', L"\xE2EC\x0063\xE2ED" },
    { L'\x1DA0', L"\xE0C5\x0066\xE0C6" },
    { L'\x1DA0', L"\xE2EC\x0066\xE2ED" },
    { L'\x1DBB', L"\xE0C5\x007A\xE0C6" },
    { L'\x1DBB', L"\xE2EC\x007A\xE2ED" },
    { L'\x1DBE', L"\xE0C5\x0292\xE0C6" },
    { L'\x1DBE', L"\xE2EC\x0292\xE2ED" },
    { L'\x1DC4', L"\x203F\xE088" },
    { L'\x1DC5', L"\x203F\xE087" },
    { L'\x1DC6', L"\x203F\xE089" },
    { L'\x1DCA', L"\x203F\xE0A7" },
    { L'\x1DFE', L"\x203F\xE081" },
    { L'\x1E00', L"\x0041\xE025" },
    { L'\x1E01', L"\x0061\xE025" },
    { L'\x1E02', L"\x0042\xE007" },
    { L'\x1E03', L"\x0062\xE007" },
    { L'\x1E04', L"\x0042\xE023" },
    { L'\x1E05', L"\x0062\xE023" },
    { L'\x1E06', L"\x0042\xE031" },
    { L'\x1E07', L"\x0062\xE031" },
    { L'\x1E08', L"\x0043\xE027\xE001" },
    { L'\x1E09', L"\x0063\xE027\xE001" },
    { L'\x1E0A', L"\x0044\xE007" },
    { L'\x1E0B', L"\x0064\xE007" },
    { L'\x1E0C', L"\x0044\xE023" },
    { L'\x1E0D', L"\x0064\xE023" },
    { L'\x1E0E', L"\x0044\xE031" },
    { L'\x1E0F', L"\x0064\xE031" },
    { L'\x1E10', L"\x0044\xE027" },
    { L'\x1E11', L"\x0064\xE027" },
    { L'\x1E12', L"\x0044\xE02D" },
    { L'\x1E13', L"\x0064\xE02D" },
    { L'\x1E14', L"\x0045\xE004\xE000" },
    { L'\x1E15', L"\x0065\xE004\xE000" },
    { L'\x1E16', L"\x0045\xE004\xE001" },
    { L'\x1E17', L"\x0065\xE004\xE001" },
    { L'\x1E18', L"\x0045\xE02D" },
    { L'\x1E19', L"\x0065\xE02D" },
    { L'\x1E1A', L"\x0045\xE030" },
    { L'\x1E1B', L"\x0065\xE030" },
    { L'\x1E1C', L"\x0045\xE027\xE006" },
    { L'\x1E1D', L"\x0065\xE027\xE006" },
    { L'\x1E1E', L"\x0046\xE007" },
    { L'\x1E1F', L"\x0066\xE007" },
    { L'\x1E20', L"\x0047\xE004" },
    { L'\x1E20', L"\xE9B4" },
    { L'\x1E21', L"\x0067\xE004" },
    { L'\x1E22', L"\x0048\xE007" },
    { L'\x1E23', L"\x0068\xE007" },
    { L'\x1E24', L"\x0048\xE023" },
    { L'\x1E25', L"\x0068\xE023" },
    { L'\x1E26', L"\x0048\xE008" },
    { L'\x1E27', L"\x0068\xE008" },
    { L'\x1E28', L"\x0048\xE027" },
    { L'\x1E29', L"\x0068\xE027" },
    { L'\x1E2A', L"\x0048\xE02E" },
    { L'\x1E2B', L"\x0068\xE02E" },
    { L'\x1E2C', L"\x0049\xE030" },
    { L'\x1E2D', L"\x0069\xE030" },
    { L'\x1E2E', L"\x0049\xE008\xE001" },
    { L'\x1E2F', L"\x0069\xE008\xE001" },
    { L'\x1E30', L"\x004B\xE001" },
    { L'\x1E31', L"\x006B\xE001" },
    { L'\x1E32', L"\x004B\xE023" },
    { L'\x1E33', L"\x006B\xE023" },
    { L'\x1E34', L"\x004B\xE031" },
    { L'\x1E35', L"\x006B\xE031" },
    { L'\x1E36', L"\x004C\xE023" },
    { L'\x1E37', L"\x006C\xE023" },
    { L'\x1E38', L"\x004C\xE004\xE023" },
    { L'\x1E39', L"\x006C\xE004\xE023" },
    { L'\x1E3A', L"\x004C\xE031" },
    { L'\x1E3B', L"\x006C\xE031" },
    { L'\x1E3C', L"\x004C\xE02D" },
    { L'\x1E3D', L"\x006C\xE02D" },
    { L'\x1E3E', L"\x004D\xE001" },
    { L'\x1E3F', L"\x006D\xE001" },
    { L'\x1E40', L"\x004D\xE007" },
    { L'\x1E41', L"\x006D\xE007" },
    { L'\x1E42', L"\x004D\xE023" },
    { L'\x1E43', L"\x006D\xE023" },
    { L'\x1E44', L"\x004E\xE007" },
    { L'\x1E45', L"\x006E\xE007" },
    { L'\x1E46', L"\x004E\xE023" },
    { L'\x1E47', L"\x006E\xE023" },
    { L'\x1E48', L"\x004E\xE031" },
    { L'\x1E49', L"\x006E\xE031" },
    { L'\x1E4A', L"\x004E\xE02D" },
    { L'\x1E4B', L"\x006E\xE02D" },
    { L'\x1E4C', L"\x004F\xE003\xE001" },
    { L'\x1E4D', L"\x006F\xE003\xE001" },
    { L'\x1E4E', L"\x004F\xE003\xE008" },
    { L'\x1E4F', L"\x006F\xE003\xE008" },
    { L'\x1E50', L"\x004F\xE004\xE000" },
    { L'\x1E51', L"\x006F\xE004\xE000" },
    { L'\x1E52', L"\x004F\xE004\xE001" },
    { L'\x1E53', L"\x006F\xE004\xE001" },
    { L'\x1E54', L"\x0050\xE001" },
    { L'\x1E55', L"\x0070\xE001" },
    { L'\x1E56', L"\x0050\xE007" },
    { L'\x1E57', L"\x0070\xE007" },
    { L'\x1E58', L"\x0052\xE007" },
    { L'\x1E59', L"\x0072\xE007" },
    { L'\x1E5A', L"\x0052\xE023" },
    { L'\x1E5B', L"\x0072\xE023" },
    { L'\x1E5C', L"\x0052\xE004\xE023" },
    { L'\x1E5D', L"\x0072\xE004\xE023" },
    { L'\x1E5E', L"\x0052\xE031" },
    { L'\x1E5F', L"\x0072\xE031" },
    { L'\x1E60', L"\x0053\xE007" },
    { L'\x1E61', L"\x0073\xE007" },
    { L'\x1E62', L"\x0053\xE023" },
    { L'\x1E63', L"\x0073\xE023" },
    { L'\x1E64', L"\x0053\xE001\xE007" },
    { L'\x1E65', L"\x0073\xE001\xE007" },
    { L'\x1E66', L"\x0053\xE00C\xE007" },
    { L'\x1E67', L"\x0073\xE00C\xE007" },
    { L'\x1E68', L"\x0053\xE007\xE023" },
    { L'\x1E69', L"\x0073\xE007\xE023" },
    { L'\x1E6A', L"\x0054\xE007" },
    { L'\x1E6B', L"\x0074\xE007" },
    { L'\x1E6C', L"\x0054\xE023" },
    { L'\x1E6D', L"\x0074\xE023" },
    { L'\x1E6E', L"\x0054\xE031" },
    { L'\x1E6F', L"\x0074\xE031" },
    { L'\x1E70', L"\x0054\xE02D" },
    { L'\x1E71', L"\x0074\xE02D" },
    { L'\x1E72', L"\x0055\xE024" },
    { L'\x1E73', L"\x0075\xE024" },
    { L'\x1E74', L"\x0055\xE030" },
    { L'\x1E75', L"\x0075\xE030" },
    { L'\x1E76', L"\x0055\xE02D" },
    { L'\x1E77', L"\x0075\xE02D" },
    { L'\x1E78', L"\x0055\xE003\xE001" },
    { L'\x1E79', L"\x0075\xE003\xE001" },
    { L'\x1E7A', L"\x0055\xE004\xE008" },
    { L'\x1E7B', L"\x0075\xE004\xE008" },
    { L'\x1E7C', L"\x0056\xE003" },
    { L'\x1E7D', L"\x0076\xE003" },
    { L'\x1E7E', L"\x0056\xE023" },
    { L'\x1E7F', L"\x0076\xE023" },
    { L'\x1E80', L"\x0057\xE000" },
    { L'\x1E81', L"\x0077\xE000" },
    { L'\x1E82', L"\x0057\xE001" },
    { L'\x1E83', L"\x0077\xE001" },
    { L'\x1E84', L"\x0057\xE008" },
    { L'\x1E85', L"\x0077\xE008" },
    { L'\x1E86', L"\x0057\xE007" },
    { L'\x1E87', L"\x0077\xE007" },
    { L'\x1E88', L"\x0057\xE023" },
    { L'\x1E89', L"\x0077\xE023" },
    { L'\x1E8A', L"\x0058\xE007" },
    { L'\x1E8B', L"\x0078\xE007" },
    { L'\x1E8C', L"\x0058\xE008" },
    { L'\x1E8D', L"\x0078\xE008" },
    { L'\x1E8E', L"\x0059\xE007" },
    { L'\x1E8F', L"\x0079\xE007" },
    { L'\x1E90', L"\x005A\xE002" },
    { L'\x1E91', L"\x007A\xE002" },
    { L'\x1E92', L"\x005A\xE023" },
    { L'\x1E93', L"\x007A\xE023" },
    { L'\x1E94', L"\x005A\xE031" },
    { L'\x1E95', L"\x007A\xE031" },
    { L'\x1E96', L"\x0068\xE031" },
    { L'\x1E97', L"\x0074\xE008" },
    { L'\x1E98', L"\x0077\xE00A" },
    { L'\x1E99', L"\x0079\xE00A" },
    { L'\x1E9A', L"\x0061\xE057" },
    { L'\x1E9B', L"\x017F\xE007" },
    { L'\x1E9C', L"\x017F\xE037" },
    { L'\x1E9D', L"\x017F\xE035" },
    { L'\x1E9E', L"\x0053\xE0C4\x0053" },
    { L'\x1E9E', L"\x0053\xE0C4\x005A" },
    { L'\x1E9F', L"\xE0F0\xE0F2\x0064" },
    { L'\x1EA0', L"\x0041\xE023" },
    { L'\x1EA1', L"\x0061\xE023" },
    { L'\x1EA2', L"\x0041\xE009" },
    { L'\x1EA3', L"\x0061\xE009" },
    { L'\x1EA4', L"\x0041\xE002\xE001" },
    { L'\x1EA5', L"\x0061\xE002\xE001" },
    { L'\x1EA6', L"\x0041\xE002\xE000" },
    { L'\x1EA7', L"\x0061\xE002\xE000" },
    { L'\x1EA8', L"\x0041\xE002\xE009" },
    { L'\x1EA9', L"\x0061\xE002\xE009" },
    { L'\x1EAA', L"\x0041\xE002\xE003" },
    { L'\x1EAB', L"\x0061\xE002\xE003" },
    { L'\x1EAC', L"\x0041\xE002\xE023" },
    { L'\x1EAD', L"\x0061\xE002\xE023" },
    { L'\x1EAE', L"\x0041\xE006\xE001" },
    { L'\x1EAF', L"\x0061\xE006\xE001" },
    { L'\x1EB0', L"\x0041\xE006\xE000" },
    { L'\x1EB1', L"\x0061\xE006\xE000" },
    { L'\x1EB2', L"\x0041\xE006\xE009" },
    { L'\x1EB3', L"\x0061\xE006\xE009" },
    { L'\x1EB4', L"\x0041\xE006\xE003" },
    { L'\x1EB5', L"\x0061\xE006\xE003" },
    { L'\x1EB6', L"\x0041\xE006\xE023" },
    { L'\x1EB7', L"\x0061\xE006\xE023" },
    { L'\x1EB8', L"\x0045\xE023" },
    { L'\x1EB9', L"\x0065\xE023" },
    { L'\x1EBA', L"\x0045\xE009" },
    { L'\x1EBB', L"\x0065\xE009" },
    { L'\x1EBC', L"\x0045\xE003" },
    { L'\x1EBD', L"\x0065\xE003" },
    { L'\x1EBE', L"\x0045\xE002\xE001" },
    { L'\x1EBF', L"\x0065\xE002\xE001" },
    { L'\x1EC0', L"\x0045\xE002\xE000" },
    { L'\x1EC1', L"\x0065\xE002\xE000" },
    { L'\x1EC2', L"\x0045\xE002\xE009" },
    { L'\x1EC3', L"\x0065\xE002\xE009" },
    { L'\x1EC4', L"\x0045\xE002\xE003" },
    { L'\x1EC5', L"\x0065\xE002\xE003" },
    { L'\x1EC6', L"\x0045\xE002\xE023" },
    { L'\x1EC7', L"\x0065\xE002\xE023" },
    { L'\x1EC8', L"\x0049\xE009" },
    { L'\x1EC9', L"\x0069\xE009" },
    { L'\x1ECA', L"\x0049\xE023" },
    { L'\x1ECB', L"\x0069\xE023" },
    { L'\x1ECC', L"\x004F\xE023" },
    { L'\x1ECD', L"\x006F\xE023" },
    { L'\x1ECE', L"\x004F\xE009" },
    { L'\x1ECF', L"\x006F\xE009" },
    { L'\x1ED0', L"\x004F\xE002\xE001" },
    { L'\x1ED1', L"\x006F\xE002\xE001" },
    { L'\x1ED2', L"\x004F\xE002\xE000" },
    { L'\x1ED3', L"\x006F\xE002\xE000" },
    { L'\x1ED4', L"\x004F\xE002\xE009" },
    { L'\x1ED5', L"\x006F\xE002\xE009" },
    { L'\x1ED6', L"\x004F\xE002\xE003" },
    { L'\x1ED7', L"\x006F\xE002\xE003" },
    { L'\x1ED8', L"\x004F\xE002\xE023" },
    { L'\x1ED9', L"\x006F\xE002\xE023" },
    { L'\x1EDA', L"\x004F\xE01B\xE001" },
    { L'\x1EDB', L"\x006F\xE01B\xE001" },
    { L'\x1EDC', L"\x004F\xE01B\xE000" },
    { L'\x1EDD', L"\x006F\xE01B\xE000" },
    { L'\x1EDE', L"\x004F\xE01B\xE009" },
    { L'\x1EDF', L"\x006F\xE01B\xE009" },
    { L'\x1EE0', L"\x004F\xE01B\xE003" },
    { L'\x1EE1', L"\x006F\xE01B\xE003" },
    { L'\x1EE2', L"\x004F\xE01B\xE023" },
    { L'\x1EE3', L"\x006F\xE01B\xE023" },
    { L'\x1EE4', L"\x0055\xE023" },
    { L'\x1EE5', L"\x0075\xE023" },
    { L'\x1EE6', L"\x0055\xE009" },
    { L'\x1EE7', L"\x0075\xE009" },
    { L'\x1EE8', L"\x0055\xE01B\xE001" },
    { L'\x1EE9', L"\x0075\xE01B\xE001" },
    { L'\x1EEA', L"\x0055\xE01B\xE000" },
    { L'\x1EEB', L"\x0075\xE01B\xE000" },
    { L'\x1EEC', L"\x0055\xE01B\xE009" },
    { L'\x1EED', L"\x0075\xE01B\xE009" },
    { L'\x1EEE', L"\x0055\xE01B\xE003" },
    { L'\x1EEF', L"\x0075\xE01B\xE003" },
    { L'\x1EF0', L"\x0055\xE01B\xE023" },
    { L'\x1EF1', L"\x0075\xE01B\xE023" },
    { L'\x1EF2', L"\x0059\xE000" },
    { L'\x1EF3', L"\x0079\xE000" },
    { L'\x1EF4', L"\x0059\xE023" },
    { L'\x1EF5', L"\x0079\xE023" },
    { L'\x1EF6', L"\x0059\xE009" },
    { L'\x1EF7', L"\x0079\xE009" },
    { L'\x1EF8', L"\x0059\xE003" },
    { L'\x1EF9', L"\x0079\xE003" },
    { L'\x1EFA', L"\x004C\xE0C4\x004C" },
    { L'\x1EFB', L"\x006C\xE0D2\x006C" },
    { L'\x1F00', L"\x03B1\xE013" },
    { L'\x1F01', L"\x03B1\xE014" },
    { L'\x1F02', L"\x03B1\xE013\xE000" },
    { L'\x1F03', L"\x03B1\xE014\xE000" },
    { L'\x1F04', L"\x03B1\xE013\xE001" },
    { L'\x1F05', L"\x03B1\xE014\xE001" },
    { L'\x1F06', L"\x03B1\xE013\xE003" },
    { L'\x1F06', L"\x03B1\xE013\xE042" },
    { L'\x1F07', L"\x03B1\xE014\xE003" },
    { L'\x1F07', L"\x03B1\xE014\xE042" },
    { L'\x1F08', L"\x0391\xE013" },
    { L'\x1F09', L"\x0391\xE014" },
    { L'\x1F0A', L"\x0391\xE013\xE000" },
    { L'\x1F0B', L"\x0391\xE014\xE000" },
    { L'\x1F0C', L"\x0391\xE013\xE001" },
    { L'\x1F0D', L"\x0391\xE014\xE001" },
    { L'\x1F0E', L"\x0391\xE013\xE003" },
    { L'\x1F0E', L"\x0391\xE013\xE042" },
    { L'\x1F0F', L"\x0391\xE014\xE003" },
    { L'\x1F0F', L"\x0391\xE014\xE042" },
    { L'\x1F10', L"\x03B5\xE013" },
    { L'\x1F11', L"\x03B5\xE014" },
    { L'\x1F12', L"\x03B5\xE013\xE000" },
    { L'\x1F13', L"\x03B5\xE014\xE000" },
    { L'\x1F14', L"\x03B5\xE013\xE001" },
    { L'\x1F15', L"\x03B5\xE014\xE001" },
    { L'\x1F18', L"\x0395\xE013" },
    { L'\x1F19', L"\x0395\xE014" },
    { L'\x1F1A', L"\x0395\xE013\xE000" },
    { L'\x1F1B', L"\x0395\xE014\xE000" },
    { L'\x1F1C', L"\x0395\xE013\xE001" },
    { L'\x1F1D', L"\x0395\xE014\xE001" },
    { L'\x1F20', L"\x03B7\xE013" },
    { L'\x1F21', L"\x03B7\xE014" },
    { L'\x1F22', L"\x03B7\xE013\xE000" },
    { L'\x1F23', L"\x03B7\xE014\xE000" },
    { L'\x1F24', L"\x03B7\xE013\xE001" },
    { L'\x1F25', L"\x03B7\xE014\xE001" },
    { L'\x1F26', L"\x03B7\xE013\xE003" },
    { L'\x1F26', L"\x03B7\xE013\xE042" },
    { L'\x1F27', L"\x03B7\xE014\xE003" },
    { L'\x1F27', L"\x03B7\xE014\xE042" },
    { L'\x1F28', L"\x0397\xE013" },
    { L'\x1F29', L"\x0397\xE014" },
    { L'\x1F2A', L"\x0397\xE013\xE000" },
    { L'\x1F2B', L"\x0397\xE014\xE000" },
    { L'\x1F2C', L"\x0397\xE013\xE001" },
    { L'\x1F2D', L"\x0397\xE014\xE001" },
    { L'\x1F2E', L"\x0397\xE013\xE003" },
    { L'\x1F2E', L"\x0397\xE013\xE042" },
    { L'\x1F2F', L"\x0397\xE014\xE042" },
    { L'\x1F30', L"\x03B9\xE013" },
    { L'\x1F31', L"\x03B9\xE014" },
    { L'\x1F32', L"\x03B9\xE013\xE000" },
    { L'\x1F33', L"\x03B9\xE014\xE000" },
    { L'\x1F34', L"\x03B9\xE013\xE001" },
    { L'\x1F35', L"\x03B9\xE014\xE001" },
    { L'\x1F36', L"\x03B9\xE013\xE003" },
    { L'\x1F36', L"\x03B9\xE013\xE042" },
    { L'\x1F37', L"\x03B9\xE014\xE003" },
    { L'\x1F37', L"\x03B9\xE014\xE042" },
    { L'\x1F38', L"\x0399\xE013" },
    { L'\x1F39', L"\x0399\xE014" },
    { L'\x1F3A', L"\x0399\xE013\xE000" },
    { L'\x1F3B', L"\x0399\xE014\xE000" },
    { L'\x1F3C', L"\x0399\xE013\xE001" },
    { L'\x1F3D', L"\x0399\xE014\xE001" },
    { L'\x1F3E', L"\x0399\xE013\xE003" },
    { L'\x1F3E', L"\x0399\xE013\xE042" },
    { L'\x1F3F', L"\x0399\xE014\xE003" },
    { L'\x1F3F', L"\x0399\xE014\xE042" },
    { L'\x1F40', L"\x03BF\xE013" },
    { L'\x1F41', L"\x03BF\xE014" },
    { L'\x1F42', L"\x03BF\xE013\xE000" },
    { L'\x1F43', L"\x03BF\xE014\xE000" },
    { L'\x1F44', L"\x03BF\xE013\xE001" },
    { L'\x1F45', L"\x03BF\xE014\xE001" },
    { L'\x1F48', L"\x039F\xE013" },
    { L'\x1F49', L"\x039F\xE014" },
    { L'\x1F4A', L"\x039F\xE013\xE000" },
    { L'\x1F4B', L"\x039F\xE014\xE000" },
    { L'\x1F4C', L"\x039F\xE013\xE001" },
    { L'\x1F4D', L"\x039F\xE014\xE001" },
    { L'\x1F50', L"\x03C5\xE013" },
    { L'\x1F51', L"\x03C5\xE014" },
    { L'\x1F52', L"\x03C5\xE013\xE000" },
    { L'\x1F53', L"\x03C5\xE014\xE000" },
    { L'\x1F54', L"\x03C5\xE013\xE001" },
    { L'\x1F55', L"\x03C5\xE014\xE001" },
    { L'\x1F56', L"\x03C5\xE013\xE042" },
    { L'\x1F57', L"\x03C5\xE014\xE042" },
    { L'\x1F59', L"\x03A5\xE014" },
    { L'\x1F5B', L"\x03A5\xE014\xE000" },
    { L'\x1F5D', L"\x03A5\xE014\xE001" },
    { L'\x1F5F', L"\x03A5\xE014\xE003" },
    { L'\x1F5F', L"\x03A5\xE014\xE042" },
    { L'\x1F60', L"\x03C9\xE013" },
    { L'\x1F61', L"\x03C9\xE014" },
    { L'\x1F62', L"\x03C9\xE013\xE000" },
    { L'\x1F63', L"\x03C9\xE014\xE000" },
    { L'\x1F64', L"\x03C9\xE013\xE001" },
    { L'\x1F65', L"\x03C9\xE014\xE001" },
    { L'\x1F66', L"\x03C9\xE013\xE003" },
    { L'\x1F66', L"\x03C9\xE013\xE042" },
    { L'\x1F67', L"\x03C9\xE014\xE003" },
    { L'\x1F67', L"\x03C9\xE014\xE042" },
    { L'\x1F68', L"\x03A9\xE013" },
    { L'\x1F69', L"\x03A9\xE014" },
    { L'\x1F6A', L"\x03A9\xE013\xE000" },
    { L'\x1F6B', L"\x03A9\xE014\xE000" },
    { L'\x1F6C', L"\x03A9\xE013\xE001" },
    { L'\x1F6D', L"\x03A9\xE014\xE001" },
    { L'\x1F6E', L"\x03A9\xE013\xE003" },
    { L'\x1F6E', L"\x03A9\xE013\xE042" },
    { L'\x1F6F', L"\x03A9\xE014\xE003" },
    { L'\x1F6F', L"\x03A9\xE014\xE042" },
    { L'\x1F70', L"\x03B1\xE000" },
    { L'\x1F71', L"\x03B1\xE001" },
    { L'\x1F72', L"\x03B5\xE000" },
    { L'\x1F73', L"\x03B5\xE001" },
    { L'\x1F74', L"\x03B7\xE000" },
    { L'\x1F75', L"\x03B7\xE001" },
    { L'\x1F76', L"\x03B9\xE000" },
    { L'\x1F77', L"\x03B9\xE001" },
    { L'\x1F78', L"\x03BF\xE000" },
    { L'\x1F79', L"\x03BF\xE001" },
    { L'\x1F7A', L"\x03C5\xE000" },
    { L'\x1F7B', L"\x03C5\xE001" },
    { L'\x1F7C', L"\x03C9\xE000" },
    { L'\x1F7D', L"\x03C9\xE001" },
    { L'\x1F80', L"\x03B1\xE013\xE045" },
    { L'\x1F81', L"\x03B1\xE014\xE045" },
    { L'\x1F82', L"\x03B1\xE013\xE000\xE045" },
    { L'\x1F83', L"\x03B1\xE014\xE000\xE045" },
    { L'\x1F84', L"\x03B1\xE013\xE001\xE045" },
    { L'\x1F85', L"\x03B1\xE014\xE001\xE045" },
    { L'\x1F86', L"\x03B1\xE013\xE003\xE045" },
    { L'\x1F86', L"\x03B1\xE013\xE042\xE045" },
    { L'\x1F87', L"\x03B1\xE014\xE003\xE045" },
    { L'\x1F87', L"\x03B1\xE014\xE042\xE045" },
    { L'\x1F88', L"\x0391\xE013\xE045" },
    { L'\x1F89', L"\x0391\xE014\xE045" },
    { L'\x1F8A', L"\x0391\xE013\xE000\xE045" },
    { L'\x1F8B', L"\x0391\xE014\xE000\xE045" },
    { L'\x1F8C', L"\x0391\xE013\xE001\xE045" },
    { L'\x1F8D', L"\x0391\xE014\xE001\xE045" },
    { L'\x1F8E', L"\x0391\xE013\xE003\xE045" },
    { L'\x1F8E', L"\x0391\xE013\xE042\xE045" },
    { L'\x1F8F', L"\x0391\xE014\xE003\xE045" },
    { L'\x1F8F', L"\x0391\xE014\xE042\xE045" },
    { L'\x1F90', L"\x03B7\xE013\xE045" },
    { L'\x1F91', L"\x03B7\xE014\xE045" },
    { L'\x1F92', L"\x03B7\xE013\xE000\xE045" },
    { L'\x1F93', L"\x03B7\xE014\xE000\xE045" },
    { L'\x1F94', L"\x03B7\xE013\xE001\xE045" },
    { L'\x1F95', L"\x03B7\xE014\xE001\xE045" },
    { L'\x1F96', L"\x03B7\xE013\xE003\xE045" },
    { L'\x1F96', L"\x03B7\xE013\xE042\xE045" },
    { L'\x1F97', L"\x03B7\xE014\xE003\xE045" },
    { L'\x1F97', L"\x03B7\xE014\xE042\xE045" },
    { L'\x1F98', L"\x0397\xE013\xE045" },
    { L'\x1F99', L"\x0397\xE014\xE045" },
    { L'\x1F9A', L"\x0397\xE013\xE000\xE045" },
    { L'\x1F9B', L"\x0397\xE014\xE000\xE045" },
    { L'\x1F9C', L"\x0397\xE013\xE001\xE045" },
    { L'\x1F9D', L"\x0397\xE014\xE001\xE045" },
    { L'\x1F9E', L"\x0397\xE013\xE003\xE045" },
    { L'\x1F9E', L"\x0397\xE013\xE042\xE045" },
    { L'\x1F9F', L"\x0397\xE014\xE003\xE045" },
    { L'\x1F9F', L"\x0397\xE014\xE042\xE045" },
    { L'\x1FA0', L"\x03C9\xE013\xE045" },
    { L'\x1FA1', L"\x03C9\xE014\xE045" },
    { L'\x1FA2', L"\x03C9\xE013\xE000\xE045" },
    { L'\x1FA3', L"\x03C9\xE014\xE000\xE045" },
    { L'\x1FA4', L"\x03C9\xE013\xE001\xE045" },
    { L'\x1FA5', L"\x03C9\xE014\xE001\xE045" },
    { L'\x1FA6', L"\x03C9\xE013\xE003\xE045" },
    { L'\x1FA6', L"\x03C9\xE013\xE042\xE045" },
    { L'\x1FA7', L"\x03C9\xE014\xE003\xE045" },
    { L'\x1FA7', L"\x03C9\xE014\xE042\xE045" },
    { L'\x1FA8', L"\x03A9\xE013\xE045" },
    { L'\x1FA9', L"\x03A9\xE014\xE045" },
    { L'\x1FAA', L"\x03A9\xE013\xE000\xE045" },
    { L'\x1FAB', L"\x03A9\xE014\xE000\xE045" },
    { L'\x1FAC', L"\x03A9\xE013\xE001\xE045" },
    { L'\x1FAD', L"\x03A9\xE014\xE001\xE045" },
    { L'\x1FAE', L"\x03A9\xE013\xE003\xE045" },
    { L'\x1FAE', L"\x03A9\xE013\xE042\xE045" },
    { L'\x1FAF', L"\x03A9\xE014\xE003\xE045" },
    { L'\x1FAF', L"\x03A9\xE014\xE042\xE045" },
    { L'\x1FB0', L"\x03B1\xE006" },
    { L'\x1FB1', L"\x03B1\xE004" },
    { L'\x1FB2', L"\x03B1\xE000\xE045" },
    { L'\x1FB3', L"\x03B1\xE045" },
    { L'\x1FB4', L"\x03B1\xE001\xE045" },
    { L'\x1FB6', L"\x03B1\xE003" },
    { L'\x1FB6', L"\x03B1\xE042" },
    { L'\x1FB7', L"\x03B1\xE003\xE045" },
    { L'\x1FB7', L"\x03B1\xE042\xE045" },
    { L'\x1FB8', L"\x0391\xE006" },
    { L'\x1FB9', L"\x0391\xE004" },
    { L'\x1FBA', L"\x0391\xE000" },
    { L'\x1FBB', L"\x0391\xE001" },
    { L'\x1FBC', L"\x0391\xE045" },
    { L'\x1FC0', L"\x0023\xE042" },
    { L'\x1FC2', L"\x03B7\xE000\xE045" },
    { L'\x1FC3', L"\x03B7\xE045" },
    { L'\x1FC4', L"\x03B7\xE001\xE045" },
    { L'\x1FC6', L"\x03B7\xE003" },
    { L'\x1FC6', L"\x03B7\xE042" },
    { L'\x1FC7', L"\x03B7\xE003\xE045" },
    { L'\x1FC7', L"\x03B7\xE042\xE045" },
    { L'\x1FC8', L"\x0395\xE000" },
    { L'\x1FC9', L"\x0395\xE001" },
    { L'\x1FCA', L"\x0397\xE000" },
    { L'\x1FCB', L"\x0397\xE001" },
    { L'\x1FCC', L"\x0397\xE045" },
    { L'\x1FD0', L"\x03B9\xE006" },
    { L'\x1FD1', L"\x03B9\xE004" },
    { L'\x1FD2', L"\x03B9\xE008\xE000" },
    { L'\x1FD3', L"\x03B9\xE008\xE001" },
    { L'\x1FD6', L"\x03B9\xE003" },
    { L'\x1FD6', L"\x03B9\xE042" },
    { L'\x1FD7', L"\x03B9\xE008\xE003" },
    { L'\x1FD7', L"\x03B9\xE008\xE042" },
    { L'\x1FD8', L"\x0399\xE006" },
    { L'\x1FD9', L"\x0399\xE004" },
    { L'\x1FDA', L"\x0399\xE000" },
    { L'\x1FDB', L"\x0399\xE001" },
    { L'\x1FE0', L"\x03C5\xE006" },
    { L'\x1FE1', L"\x03C5\xE004" },
    { L'\x1FE1', L"\xF4E6" },
    { L'\x1FE2', L"\x03C5\xE008\xE000" },
    { L'\x1FE3', L"\x03C5\xE008\xE001" },
    { L'\x1FE4', L"\x03C1\xE013" },
    { L'\x1FE5', L"\x03C1\xE014" },
    { L'\x1FE6', L"\x03C5\xE003" },
    { L'\x1FE6', L"\x03C5\xE042" },
    { L'\x1FE7', L"\x03C5\xE008\xE003" },
    { L'\x1FE7', L"\x03C5\xE008\xE042" },
    { L'\x1FE8', L"\x03A5\xE006" },
    { L'\x1FE9', L"\x03A5\xE004" },
    { L'\x1FEA', L"\x03A5\xE000" },
    { L'\x1FEB', L"\x03A5\xE001" },
    { L'\x1FEC', L"\x03A1\xE014" },
    { L'\x1FF2', L"\x03C9\xE000\xE045" },
    { L'\x1FF3', L"\x03C9\xE045" },
    { L'\x1FF4', L"\x03C9\xE001\xE045" },
    { L'\x1FF6', L"\x03C9\xE003" },
    { L'\x1FF6', L"\x03C9\xE042" },
    { L'\x1FF7', L"\x03C9\xE003\xE045" },
    { L'\x1FF7', L"\x03C9\xE042\xE045" },
    { L'\x1FF8', L"\x039F\xE000" },
    { L'\x1FF9', L"\x039F\xE001" },
    { L'\x1FFA', L"\x03A9\xE000" },
    { L'\x1FFB', L"\x03A9\xE001" },
    { L'\x1FFC', L"\x03A9\xE045" },
    { L'\x2013', L"\x0023\xE035" },
    { L'\x2016', L"\x007C\xE0C4\x007C" },
    { L'\x2017', L"\x0023\xE033" },
    { L'\x2017', L"\x0023\xE047" },
    { L'\x2019', L"\x0023\xE0B0" },
    { L'\x201C', L"\x2018\xE0C4\x2018" },
    { L'\x201D', L"\x2019\xE0C4\x2019" },
    { L'\x201E', L"\x002C\xE0C4\x002C" },
    { L'\x201E', L"\x201A\xE0C4\x201A" },
    { L'\x201F', L"\x201B\xE0C4\x201B" },
    { L'\x203C', L"\x0021\xE0C4\x0021" },
    { L'\x2047', L"\x003F\xE0C4\x003F" },
    { L'\x2048', L"\x003F\xE0C4\x0021" },
    { L'\x2049', L"\x0021\xE0C4\x003F" },
    { L'\x2070', L"\xE0C5\x0030\xE0C6" },
    { L'\x2070', L"\xE2EC\x0030\xE2ED" },
    { L'\x2071', L"\xE0C5\x0069\xE0C6" },
    { L'\x2071', L"\xE2EC\x0069\xE2ED" },
    { L'\x2074', L"\xE0C5\x0034\xE0C6" },
    { L'\x2074', L"\xE2EC\x0034\xE2ED" },
    { L'\x2075', L"\xE0C5\x0035\xE0C6" },
    { L'\x2075', L"\xE2EC\x0035\xE2ED" },
    { L'\x2076', L"\xE0C5\x0036\xE0C6" },
    { L'\x2076', L"\xE2EC\x0036\xE2ED" },
    { L'\x2077', L"\xE0C5\x0037\xE0C6" },
    { L'\x2077', L"\xE2EC\x0037\xE2ED" },
    { L'\x2078', L"\xE0C5\x0038\xE0C6" },
    { L'\x2078', L"\xE2EC\x0038\xE2ED" },
    { L'\x2079', L"\xE0C5\x0039\xE0C6" },
    { L'\x2079', L"\xE2EC\x0039\xE2ED" },
    { L'\x207A', L"\xE0C5\x002B\xE0C6" },
    { L'\x207A', L"\xE2EC\x002B\xE2ED" },
    { L'\x207B', L"\xE0C5\x2212\xE0C6" },
    { L'\x207B', L"\xE2EC\x2212\xE2ED" },
    { L'\x207C', L"\xE0C5\x003D\xE0C6" },
    { L'\x207C', L"\xE2EC\x003D\xE2ED" },
    { L'\x207D', L"\xE0C5\x0028\xE0C6" },
    { L'\x207D', L"\xE2EC\x0028\xE2ED" },
    { L'\x207E', L"\xE0C5\x0029\xE0C6" },
    { L'\x207E', L"\xE2EC\x0029\xE2ED" },
    { L'\x207F', L"\xE0C5\x006E\xE0C6" },
    { L'\x207F', L"\xE2EC\x006E\xE2ED" },
    { L'\x2080', L"\xE0CE\x0030\xE0CF" },
    { L'\x2080', L"\xE2EE\x0030\xE2EF" },
    { L'\x2081', L"\xE0CE\x0031\xE0CF" },
    { L'\x2081', L"\xE2EE\x0031\xE2EF" },
    { L'\x2082', L"\xE0CE\x0032\xE0CF" },
    { L'\x2082', L"\xE2EE\x0032\xE2EF" },
    { L'\x2083', L"\xE0CE\x0033\xE0CF" },
    { L'\x2083', L"\xE2EE\x0033\xE2EF" },
    { L'\x2084', L"\xE0CE\x0034\xE0CF" },
    { L'\x2084', L"\xE2EE\x0034\xE2EF" },
    { L'\x2085', L"\xE0CE\x0035\xE0CF" },
    { L'\x2085', L"\xE2EE\x0035\xE2EF" },
    { L'\x2086', L"\xE0CE\x0036\xE0CF" },
    { L'\x2086', L"\xE2EE\x0036\xE2EF" },
    { L'\x2087', L"\xE0CE\x0037\xE0CF" },
    { L'\x2087', L"\xE2EE\x0037\xE2EF" },
    { L'\x2088', L"\xE0CE\x0038\xE0CF" },
    { L'\x2088', L"\xE2EE\x0038\xE2EF" },
    { L'\x2089', L"\xE0CE\x0039\xE0CF" },
    { L'\x2089', L"\xE2EE\x0039\xE2EF" },
    { L'\x208A', L"\xE0CE\x002B\xE0CF" },
    { L'\x208A', L"\xE2EE\x002B\xE2EF" },
    { L'\x208B', L"\xE0CE\x2212\xE0CF" },
    { L'\x208B', L"\xE2EE\x2212\xE2EF" },
    { L'\x208C', L"\xE0CE\x003D\xE0CF" },
    { L'\x208C', L"\xE2EE\x003D\xE2EF" },
    { L'\x208D', L"\xE0CE\x0028\xE0CF" },
    { L'\x208D', L"\xE2EE\x0028\xE2EF" },
    { L'\x208E', L"\xE0CE\x0029\xE0CF" },
    { L'\x208E', L"\xE2EE\x0029\xE2EF" },
    { L'\x2090', L"\xE0CE\x0061\xE0CF" },
    { L'\x2090', L"\xE2EE\x0061\xE2EF" },
    { L'\x2091', L"\xE0CE\x0065\xE0CF" },
    { L'\x2091', L"\xE2EE\x0065\xE2EF" },
    { L'\x2092', L"\xE0CE\x006F\xE0CF" },
    { L'\x2092', L"\xE2EE\x006F\xE2EF" },
    { L'\x2093', L"\xE0CE\x0078\xE0CF" },
    { L'\x2093', L"\xE2EE\x0078\xE2EF" },
    { L'\x2094', L"\xE0CE\x0259\xE0CF" },
    { L'\x2094', L"\xE2EE\x0259\xE2EF" },
    { L'\x20AC', L"\x003D\xE0C4\x0043" },
    { L'\x20AC', L"\x0043\xE0BB" },
    { L'\x20AC', L"\x0043\xE0C4\x003D" },
    { L'\x20D2', L"\x203F\xE0B8" },
    { L'\x20D6', L"\x203F\xE07E" },
    { L'\x20D7', L"\x203F\xE07F" },
    { L'\x20DD', L"\x203F\xE0C0" },
    { L'\x20DE', L"\x203F\xE0C2" },
    { L'\x20DF', L"\x203F\xE0CA" },
    { L'\x20E0', L"\x203F\xE0CD" },
    { L'\x20E1', L"\x203F\xE08F" },
    { L'\x20E5', L"\x203F\xE0B5" },
    { L'\x20E6', L"\x203F\xE0BA" },
    { L'\x20E9', L"\x203F\xE090" },
    { L'\x20EA', L"\x203F\xE0BC" },
    { L'\x20EB', L"\x203F\xE0BD" },
    { L'\x20EE', L"\x203F\xE0A8" },
    { L'\x20EF', L"\x203F\xE0A9" },
    { L'\x2114', L"\x006C\xE0D2\x0062" },
    { L'\x2116', L"\x004E\xE0C4\x006F" },
    { L'\x214B', L"\xE0F9\x0026" },
    { L'\x214E', L"\xE0F9\x0046" },
    { L'\x2194', L"\x2190\xE0C4\x2192" },
    { L'\x2195', L"\x2191\xE0C4\x2193" },
    { L'\x219A', L"\x2190\xE037" },
    { L'\x219B', L"\x2192\xE037" },
    { L'\x219E', L"\x2190\xE0C4\x2190" },
    { L'\x21A0', L"\x2192\xE0C4\x2192" },
    { L'\x21AE', L"\x2190\xE0C4\x2192\xE037" },
    { L'\x21AE', L"\x2194\xE037" },
    { L'\x21CD', L"\x003C\xE0C4\x003D\xE037" },
    { L'\x21CD', L"\x003C\xE0C4\x2260" },
    { L'\x21CD', L"\x21D0\xE037" },
    { L'\x21CE', L"\x003C\xE0C4\x003D\xE0C4\x003E\xE037" },
    { L'\x21CE', L"\x21D0\xE0C4\x21D2\xE037" },
    { L'\x21CE', L"\x21D4\xE037" },
    { L'\x21CF', L"\x003D\xE0C4\x003E\xE037" },
    { L'\x21CF', L"\x21D2\xE037" },
    { L'\x21D0', L"\x003C\xE0C4\x003D" },
    { L'\x21D2', L"\x003D\xE0C4\x003E" },
    { L'\x21D4', L"\x003C\xE0C4\x003D\xE0C4\x003E" },
    { L'\x21F7', L"\x2190\xE0B8" },
    { L'\x21F8', L"\x2192\xE0B8" },
    { L'\x21F9', L"\x2190\xE0C4\x2192\xE0B8" },
    { L'\x21F9', L"\x2194\xE0B8" },
    { L'\x21FA', L"\x2190\xE0B8\xE0B8" },
    { L'\x21FB', L"\x2192\xE0B8\xE0B8" },
    { L'\x21FC', L"\x2190\xE0C4\x2192\xE0B8\xE0B8" },
    { L'\x21FC', L"\x2194\xE0B8\xE0B8" },
    { L'\x2209', L"\x2208\xE037" },
    { L'\x220C', L"\x220B\xE037" },
    { L'\x221E', L"\xE0FB\x0038" },
    { L'\x221E', L"\xE0FC\x0038" },
    { L'\x2238', L"\x2013\xE007" },
    { L'\x2241', L"\x007E\xE037" },
    { L'\x2242', L"\x007E\xE004" },
    { L'\x2243', L"\x2013\xE003" },
    { L'\x2245', L"\x003D\xE003" },
    { L'\x2248', L"\x007E\xE003" },
    { L'\x2249', L"\x2248\xE037" },
    { L'\x224B', L"\x2248\xE003" },
    { L'\x2250', L"\x003D\xE007" },
    { L'\x2259', L"\x003D\xE002" },
    { L'\x2260', L"\x003D\xE037" },
    { L'\x2261', L"\x003D\xE004" },
    { L'\x2261', L"\x003D\xE031" },
    { L'\x2262', L"\x2261\xE037" },
    { L'\x226A', L"\x003C\xE0C4\x003C" },
    { L'\x226B', L"\x003E\xE0C4\x003E" },
    { L'\x226C', L"\x0028\xE0C4\x0029" },
    { L'\x226E', L"\x003C\xE037" },
    { L'\x226F', L"\x003E\xE037" },
    { L'\x229C', L"\x003D\xE0C0" },
    { L'\x229D', L"\x2013\xE0C0" },
    { L'\x22EE', L"\x003A\xE007" },
    { L'\x2329', L"\x3008" },
    { L'\x232A', L"\x3009" },
    { L'\x2338', L"\x003D\xE0C2" },
    { L'\x2343', L"\x003C\xE0C2" },
    { L'\x2344', L"\x003E\xE0C2" },
    { L'\x2347', L"\x2190\xE0C2" },
    { L'\x2348', L"\x2192\xE0C2" },
    { L'\x2350', L"\x2191\xE0C2" },
    { L'\x2357', L"\x2193\xE0C2" },
    { L'\x2360', L"\x003A\xE0C2" },
    { L'\x236F', L"\x003D\xE037\xE0C2" },
    { L'\x2370', L"\x003F\xE0C2" },
    { L'\x23F4', L"\xE264" },
    { L'\x23F5', L"\xE265" },
    { L'\x2460', L"\x0031\xE0C0" },
    { L'\x2461', L"\x0032\xE0C0" },
    { L'\x2462', L"\x0033\xE0C0" },
    { L'\x2463', L"\x0034\xE0C0" },
    { L'\x2464', L"\x0035\xE0C0" },
    { L'\x2465', L"\x0036\xE0C0" },
    { L'\x2466', L"\x0037\xE0C0" },
    { L'\x2467', L"\x0038\xE0C0" },
    { L'\x2468', L"\x0039\xE0C0" },
    { L'\x2469', L"\x0031\x0030\xE0C1" },
    { L'\x246A', L"\x0031\x0031\xE0C1" },
    { L'\x246B', L"\x0031\x0032\xE0C1" },
    { L'\x246C', L"\x0031\x0033\xE0C1" },
    { L'\x246D', L"\x0031\x0034\xE0C1" },
    { L'\x246E', L"\x0031\x0035\xE0C1" },
    { L'\x246F', L"\x0031\x0036\xE0C1" },
    { L'\x2470', L"\x0031\x0037\xE0C1" },
    { L'\x2471', L"\x0031\x0038\xE0C1" },
    { L'\x2472', L"\x0031\x0039\xE0C1" },
    { L'\x2473', L"\x0032\x0030\xE0C1" },
    { L'\x24B6', L"\x0041\xE0C0" },
    { L'\x24B7', L"\x0042\xE0C0" },
    { L'\x24B8', L"\x0043\xE0C0" },
    { L'\x24B9', L"\x0044\xE0C0" },
    { L'\x24BA', L"\x0045\xE0C0" },
    { L'\x24BB', L"\x0046\xE0C0" },
    { L'\x24BC', L"\x0047\xE0C0" },
    { L'\x24BD', L"\x0048\xE0C0" },
    { L'\x24BE', L"\x0049\xE0C0" },
    { L'\x24BF', L"\x004A\xE0C0" },
    { L'\x24C0', L"\x004B\xE0C0" },
    { L'\x24C1', L"\x004C\xE0C0" },
    { L'\x24C2', L"\x004D\xE0C0" },
    { L'\x24C3', L"\x004E\xE0C0" },
    { L'\x24C4', L"\x004F\xE0C0" },
    { L'\x24C5', L"\x0050\xE0C0" },
    { L'\x24C6', L"\x0051\xE0C0" },
    { L'\x24C7', L"\x0052\xE0C0" },
    { L'\x24C8', L"\x0053\xE0C0" },
    { L'\x24C9', L"\x0054\xE0C0" },
    { L'\x24CA', L"\x0055\xE0C0" },
    { L'\x24CB', L"\x0056\xE0C0" },
    { L'\x24CC', L"\x0057\xE0C0" },
    { L'\x24CD', L"\x0058\xE0C0" },
    { L'\x24CE', L"\x0059\xE0C0" },
    { L'\x24CF', L"\x005A\xE0C0" },
    { L'\x24D0', L"\x0061\xE0C0" },
    { L'\x24D1', L"\x0062\xE0C0" },
    { L'\x24D2', L"\x0063\xE0C0" },
    { L'\x24D3', L"\x0064\xE0C0" },
    { L'\x24D4', L"\x0065\xE0C0" },
    { L'\x24D5', L"\x0066\xE0C0" },
    { L'\x24D6', L"\x0067\xE0C0" },
    { L'\x24D7', L"\x0068\xE0C0" },
    { L'\x24D8', L"\x0069\xE0C0" },
    { L'\x24D9', L"\x006A\xE0C0" },
    { L'\x24DA', L"\x006B\xE0C0" },
    { L'\x24DB', L"\x006C\xE0C0" },
    { L'\x24DC', L"\x006D\xE0C0" },
    { L'\x24DD', L"\x006E\xE0C0" },
    { L'\x24DE', L"\x006F\xE0C0" },
    { L'\x24DF', L"\x0070\xE0C0" },
    { L'\x24E0', L"\x0071\xE0C0" },
    { L'\x24E1', L"\x0072\xE0C0" },
    { L'\x24E2', L"\x0073\xE0C0" },
    { L'\x24E3', L"\x0074\xE0C0" },
    { L'\x24E4', L"\x0075\xE0C0" },
    { L'\x24E5', L"\x0076\xE0C0" },
    { L'\x24E6', L"\x0077\xE0C0" },
    { L'\x24E7', L"\x0078\xE0C0" },
    { L'\x24E8', L"\x0079\xE0C0" },
    { L'\x24E9', L"\x007A\xE0C0" },
    { L'\x24EA', L"\x0030\xE0C0" },
    { L'\x25A0', L"\x0070\x25A1" },
    { L'\x25A0', L"\x0076\x25FE" },
    { L'\x25A1', L"\x0023\xE0C2" },
    { L'\x25A1', L"\x0023\xE0C3" },
    { L'\x25A1', L"\x006F\x25A0" },
    { L'\x25A1', L"\x0076\x25FD" },
    { L'\x25C6', L"\x0070\x25C7" },
    { L'\x25C6', L"\x0076\xE285" },
    { L'\x25C7', L"\x0023\xE0CA" },
    { L'\x25C7', L"\x006F\x25C6" },
    { L'\x25C7', L"\x0076\xE286" },
    { L'\x25CB', L"\x006F\x25CF" },
    { L'\x25CB', L"\x0076\x26AA" },
    { L'\x25CF', L"\x0070\x25CB" },
    { L'\x25CF', L"\x0076\x26AB" },
    { L'\x25EF', L"\x0023\xE0C0" },
    { L'\x25EF', L"\x0023\xE0C1" },
    { L'\x25FD', L"\x006D\x25A1" },
    { L'\x25FD', L"\x006F\x25FE" },
    { L'\x25FE', L"\x006D\x25A0" },
    { L'\x25FE', L"\x0070\x25FD" },
    { L'\x26AA', L"\x006D\x25CB" },
    { L'\x26AA', L"\x006F\x26AB" },
    { L'\x26AB', L"\x006D\x25CF" },
    { L'\x26AB', L"\x0070\x26AA" },
    { L'\x27E6', L"\x005B\xE0C4\x005B" },
    { L'\x27E6', L"\x301A" },
    { L'\x27E7', L"\x005D\xE0C4\x005D" },
    { L'\x27E7', L"\x301B" },
    { L'\x27EA', L"\x2329\xE0C4\x2329" },
    { L'\x27EA', L"\x300A" },
    { L'\x27EA', L"\xE254" },
    { L'\x27EB', L"\x232A\xE0C4\x232A" },
    { L'\x27EB', L"\x300B" },
    { L'\x27EB', L"\xE255" },
    { L'\x27EC', L"\x3018" },
    { L'\x27EC', L"\xE25E" },
    { L'\x27ED', L"\x3019" },
    { L'\x27ED', L"\xE25F" },
    { L'\x2B73', L"\x2193\xE031" },
    { L'\x2C60', L"\x004C\xE0BB" },
    { L'\x2C61', L"\x006C\xE0BB" },
    { L'\x2C62', L"\x004C\xE034" },
    { L'\x2C63', L"\x0050\xE035" },
    { L'\x2C64', L"\x0052\xE022" },
    { L'\x2C65', L"\x0061\xE037" },
    { L'\x2C66', L"\x0074\xE037" },
    { L'\x2C67', L"\x0048\xE0A6" },
    { L'\x2C68', L"\x0068\xE0A6" },
    { L'\x2C69', L"\x004B\xE0A6" },
    { L'\x2C6A', L"\x006B\xE0A6" },
    { L'\x2C6B', L"\x005A\xE0A6" },
    { L'\x2C6C', L"\x007A\xE0A6" },
    { L'\x2C74', L"\x0076\xE0A5" },
    { L'\x2E32', L"\xE0F9\x002C" },
    { L'\x2E32', L"\xE282" },
    { L'\x2E35', L"\xE0F9\x003B" },
    { L'\x2E35', L"\xE250" },
    { L'\x2E40', L"\xE230" },
    { L'\xE008', L"\xE007\xE0C4\xE007" },
    { L'\xE00B', L"\xE001\xE0C4\xE001" },
    { L'\xE00E', L"\xE00D\xE0C4\xE00D" },
    { L'\xE00F', L"\xE000\xE0C4\xE000" },
    { L'\xE010', L"\xE006\xE007" },
    { L'\xE024', L"\xE023\xE0C4\xE023" },
    { L'\xE033', L"\xE031\xE0C4\xE031" },
    { L'\xE03F', L"\xE004\xE0C4\xE004" },
    { L'\xE048', L"\xE029\xE0C4\xE029" },
    { L'\xE04C', L"\xE003\xE0C4\xE003" },
    { L'\xE052', L"\xE007\xE011" },
    { L'\xE056', L"\xE055\xE0C4\xE02D" },
    { L'\xE05C', L"\xE0C7" },
    { L'\xE063', L"\xE0F6\x0061" },
    { L'\xE064', L"\xE0F6\x0065" },
    { L'\xE065', L"\xE0F6\x0069" },
    { L'\xE066', L"\xE0F6\x006F" },
    { L'\xE067', L"\xE0F6\x0075" },
    { L'\xE068', L"\xE0F6\x0063" },
    { L'\xE069', L"\xE0F6\x0064" },
    { L'\xE06A', L"\xE0F6\x0068" },
    { L'\xE06B', L"\xE0F6\x006D" },
    { L'\xE06C', L"\xE0F6\x0072" },
    { L'\xE06D', L"\xE0F6\x0074" },
    { L'\xE06E', L"\xE0F6\x0076" },
    { L'\xE06F', L"\xE0F6\x0078" },
    { L'\xE072', L"\xE007\xE0C4\xE000" },
    { L'\xE073', L"\xE007\xE0C4\xE001" },
    { L'\xE074', L"\xE002\xE0C4\xE000" },
    { L'\xE075', L"\xE002\xE0C4\xE001" },
    { L'\xE076', L"\xE00C\xE0C4\xE001" },
    { L'\xE077', L"\xE001\xE0C4\xE000" },
    { L'\xE078', L"\xE000\xE0C4\xE002" },
    { L'\xE079', L"\xE001\xE0C4\xE002" },
    { L'\xE07B', L"\xE00A\xE0C4\xE000" },
    { L'\xE07C', L"\xE00A\xE0C4\xE001" },
    { L'\xE07D', L"\xE0F6\x0028\x002D\x0029" },
    { L'\xE07D', L"\xE0F6\x0028\x2013\x0029" },
    { L'\xE07D', L"\xE0F6\x0028\xE004\x0029" },
    { L'\xE080', L"\xE0F6\x006B" },
    { L'\xE083', L"\xE000\xE0C4\xE007" },
    { L'\xE084', L"\xE001\xE0C4\xE007" },
    { L'\xE085', L"\xE013\xE0C4\xE001" },
    { L'\xE086', L"\xE013\xE0C4\xE001\xE0C4\xE001" },
    { L'\xE08B', L"\xE007\xE0C4\xE007\xE0C4\xE00A" },
    { L'\xE08B', L"\xE007\xE0C4\xE00A\xE0C4\xE007" },
    { L'\xE08B', L"\xE008\xE0C4\xE00A" },
    { L'\xE08B', L"\xE00A\xE0C4\xE007\xE0C4\xE007" },
    { L'\xE08B', L"\xE00A\xE0C4\xE008" },
    { L'\xE08C', L"\xE0F6\x0065\xE001" },
    { L'\xE08D', L"\xE0F6\x0065\xE004\xE001" },
    { L'\xE08E', L"\xE0F6\x006F\xE001" },
    { L'\xE091', L"\xE0F6\x0073" },
    { L'\xE092', L"\xE0F6\x0259" },
    { L'\xE093', L"\xE0F6\x006F\xE008" },
    { L'\xE094', L"\x002F\xE0C4\xE007\xE0C4\xE007\xE0C4\x002F" },
    { L'\xE094', L"\x002F\xE0C4\xE008\xE0C4\x002F" },
    { L'\xE095', L"\xE0F6\x0061\xE008" },
    { L'\xE096', L"\xE0F6\x0069\xE008" },
    { L'\xE097', L"\xE0F6\x0033" },
    { L'\xE098', L"\xE0F6\x0034" },
    { L'\xE099', L"\xE004\xE00D" },
    { L'\xE0AA', L"\xE028\xE028" },
    { L'\xE0BA', L"\xE0B8\xE0B8" },
    { L'\xE0BB', L"\xE035\xE035" },
    { L'\xE0BD', L"\xE037\xE037" },
    { L'\xE0BE', L"\xE0FA\xE034" },
    { L'\xE0D0', L"\xE05C\xE0C4\xE007" },
    { L'\xE0D1', L"\xE05C\xE0C4\xE004" },
    { L'\xE0D5', L"\xE05E\xE00D" },
    { L'\xE106', L"\x004F\xE0B8" },
    { L'\xE114', L"\x0053\xE037" },
    { L'\xE115', L"\x0073\xE037" },
    { L'\xE11B', L"\xE0F8\xE11D" },
    { L'\xE11B', L"\xE11C\xE004" },
    { L'\xE11C', L"\xE0F8\xE11E" },
    { L'\xE11D', L"\xE0F8\xE11B" },
    { L'\xE11E', L"\xE0F8\xE11C" },
    { L'\xE133', L"\x006D\xE021" },
    { L'\xE138', L"\x0068\xE035\xE08A" },
    { L'\xE138', L"\x0068\xE08A\xE035" },
    { L'\xE138', L"\x0266\xE035" },
    { L'\xE139', L"\x0068\xE035\xE08A\xE0A2" },
    { L'\xE139', L"\x0068\xE08A\xE035\xE0A2" },
    { L'\xE139', L"\x0068\xE08A\xE0A2\xE035" },
    { L'\xE139', L"\x0068\xE0A2\xE035\xE08A" },
    { L'\xE139', L"\x0068\xE0A2\xE08A\xE035" },
    { L'\xE139', L"\x0267\xE035" },
    { L'\xE13A', L"\xE0F9\x0057" },
    { L'\xE13B', L"\xE0F0\xE0F2\xE0F8\x004F\xE004" },
    { L'\xE13B', L"\xE0F2\xE0F8\x004F\xE004" },
    { L'\xE13B', L"\xE0F8\x03A9" },
    { L'\xE13E', L"\x1D09" },
    { L'\xE13F', L"\x1D1C" },
    { L'\xE13F', L"\xE0F8\x0055" },
    { L'\xE140', L"\x0044\xE0A2" },
    { L'\xE141', L"\x0064\xE0A2" },
    { L'\xE142', L"\x0054\xE0A2" },
    { L'\xE143', L"\x0074\xE0A2" },
    { L'\xE147', L"\xE0F9\xE146" },
    { L'\xE148', L"\xE0FA\x0036" },
    { L'\xE149', L"\x1D00" },
    { L'\xE149', L"\xE0F8\x0041" },
    { L'\xE14A', L"\xE0F9\x0052" },
    { L'\xE14C', L"\xE0FA\x0061" },
    { L'\xE152', L"\xE0CE\x03BC\xE0CF" },
    { L'\xE152', L"\xE0CE\xE0F2\x006D\xE0CF" },
    { L'\xE152', L"\xE2EE\x03BC\xE2EF" },
    { L'\xE153', L"\xE0CE\x03C3\xE0CF" },
    { L'\xE153', L"\xE0CE\xE0F2\x0073\xE0CF" },
    { L'\xE153', L"\xE2EE\x03C3\xE2EF" },
    { L'\xE153', L"\xE2EE\xE0F2\x0073\xE2EF" },
    { L'\xE154', L"\x1D07" },
    { L'\xE154', L"\xE0F8\x0045" },
    { L'\xE156', L"\x1D0B" },
    { L'\xE156', L"\xE0F8\x004B" },
    { L'\xE157', L"\xE0FC\x0057" },
    { L'\xE158', L"\xE0CE\x004B\xE0CF" },
    { L'\xE158', L"\xE2EE\x004B\xE2EF" },
    { L'\xE159', L"\xE0CE\x006B\xE0CF" },
    { L'\xE159', L"\xE2EE\x006B\xE2EF" },
    { L'\xE15B', L"\xE0F2\xE0F8\x0068" },
    { L'\xE15B', L"\xE0F8\x03C7" },
    { L'\xE15C', L"\xE0F8\x014B" },
    { L'\xE15D', L"\xE0C5\x0075\xE02F\xE0C6" },
    { L'\xE15D', L"\xE2EC\x0075\xE02F\xE2ED" },
    { L'\xE15E', L"\xE0C5\x0069\xE02F\xE0C6" },
    { L'\xE15E', L"\xE2EC\x0069\xE02F\xE2ED" },
    { L'\xE15F', L"\xE0F2\xE0F9\x0061" },
    { L'\xE15F', L"\xE0F9\x03B1" },
    { L'\xE160', L"\x1D1A" },
    { L'\xE160', L"\xE0F8\xE0F9\x0052" },
    { L'\xE160', L"\xE0F8\xE14A" },
    { L'\xE161', L"\x0053\xE0C4\x0053\xE0C4\x004B\xE0C4\x004A" },
    { L'\xE162', L"\x0072\xE0A2" },
    { L'\xE164', L"\xE0C5\x0071\xE0C6" },
    { L'\xE164', L"\xE2EC\x0071\xE2ED" },
    { L'\xE165', L"\xE0C5\x0063\xE00C\xE0C6" },
    { L'\xE165', L"\xE2EC\x0063\xE00C\xE2ED" },
    { L'\xE166', L"\xE0C5\x0073\xE00C\xE0C6" },
    { L'\xE166', L"\xE2EC\x0073\xE00C\xE2ED" },
    { L'\xE167', L"\xE0C5\x007A\xE00C\xE0C6" },
    { L'\xE167', L"\xE2EC\x007A\xE00C\xE2ED" },
    { L'\xE16A', L"\x0066\xE0A2" },
    { L'\xE16C', L"\xE0C5\x0259\xE028\xE0C6" },
    { L'\xE16C', L"\xE2EC\x0259\xE028\xE2ED" },
    { L'\xE16D', L"\xE0C5\x0061\xE02F\xE0C6" },
    { L'\xE16D', L"\xE2EC\x0061\xE02F\xE2ED" },
    { L'\xE16E', L"\xE0C5\x0065\xE001\xE023\xE0C6" },
    { L'\xE16E', L"\xE2EC\x0065\xE001\xE023\xE2ED" },
    { L'\xE16F', L"\xE0C5\x0065\xE011\xE023\xE0C6" },
    { L'\xE16F', L"\xE2EC\x0065\xE011\xE023\xE2ED" },
    { L'\xE170', L"\xE0C5\x0065\xE023\xE0C6" },
    { L'\xE170', L"\xE2EC\x0065\xE023\xE2ED" },
    { L'\xE171', L"\xE0C5\x0065\xE02D\xE0C6" },
    { L'\xE171', L"\xE2EC\x0065\xE02D\xE2ED" },
    { L'\xE172', L"\xE0C5\x0065\xE02F\xE0C6" },
    { L'\xE172', L"\xE2EC\x0065\xE02F\xE2ED" },
    { L'\xE173', L"\xE0C5\x0065\xE039\xE0C6" },
    { L'\xE173', L"\xE2EC\x0065\xE039\xE2ED" },
    { L'\xE174', L"\xE0C5\x0259\xE000\xE0C6" },
    { L'\xE174', L"\xE2EC\x0259\xE000\xE2ED" },
    { L'\xE175', L"\xE0C5\x0259\xE02F\xE0C6" },
    { L'\xE175', L"\xE2EC\x0259\xE02F\xE2ED" },
    { L'\xE176', L"\xE0C5\x0069\xE001\xE039\xE0C6" },
    { L'\xE176', L"\xE2EC\x0069\xE001\xE039\xE2ED" },
    { L'\xE177', L"\xE0C5\x0069\xE011\xE0C6" },
    { L'\xE177', L"\xE2EC\x0069\xE011\xE2ED" },
    { L'\xE178', L"\xE0C5\x0069\xE011\xE02F\xE0C6" },
    { L'\xE178', L"\xE2EC\x0069\xE011\xE02F\xE2ED" },
    { L'\xE179', L"\xE0C5\x006F\xE001\xE023\xE0C6" },
    { L'\xE179', L"\xE2EC\x006F\xE001\xE023\xE2ED" },
    { L'\xE17A', L"\xE0C5\x006F\xE011\xE023\xE0C6" },
    { L'\xE17A', L"\xE2EC\x006F\xE011\xE023\xE2ED" },
    { L'\xE17B', L"\xE0C5\x006F\xE023\xE0C6" },
    { L'\xE17B', L"\xE2EC\x006F\xE023\xE2ED" },
    { L'\xE17C', L"\xE0C5\x006F\xE02D\xE0C6" },
    { L'\xE17C', L"\xE2EC\x006F\xE02D\xE2ED" },
    { L'\xE17D', L"\xE0C5\x006F\xE02F\xE0C6" },
    { L'\xE17D', L"\xE2EC\x006F\xE02F\xE2ED" },
    { L'\xE17E', L"\xE0C5\x006F\xE025\xE0C6" },
    { L'\xE17E', L"\xE2EC\x006F\xE025\xE2ED" },
    { L'\xE17F', L"\xE0C5\x006F\xE039\xE0C6" },
    { L'\xE17F', L"\xE2EC\x006F\xE039\xE2ED" },
    { L'\xE180', L"\xE0C5\x0061\xE000\xE0C6" },
    { L'\xE180', L"\xE2EC\x0061\xE000\xE2ED" },
    { L'\xE181', L"\xE0C5\x0065\xE025\xE0C6" },
    { L'\xE181', L"\xE2EC\x0065\xE025\xE2ED" },
    { L'\xE182', L"\xE0C5\x0259\xE011\xE0C6" },
    { L'\xE182', L"\xE2EC\x0259\xE011\xE2ED" },
    { L'\xE183', L"\xE0C5\x00FE\xE0C6" },
    { L'\xE183', L"\xE2EC\x00FE\xE2ED" },
    { L'\xE184', L"\xE0C5\x0069\xE006\xE0C6" },
    { L'\xE184', L"\xE2EC\x0069\xE006\xE2ED" },
    { L'\xE190', L"\x203F\xE070" },
    { L'\xE191', L"\x203F\xE071" },
    { L'\xE192', L"\x0023\xE009" },
    { L'\xE192', L"\x203F\xE072" },
    { L'\xE193', L"\x203F\xE073" },
    { L'\xE194', L"\x203F\xE074" },
    { L'\xE195', L"\x203F\xE075" },
    { L'\xE196', L"\x203F\xE076" },
    { L'\xE197', L"\x203F\xE077" },
    { L'\xE198', L"\x203F\xE078" },
    { L'\xE199', L"\x203F\xE079" },
    { L'\xE19A', L"\x203F\xE07A" },
    { L'\xE19B', L"\x203F\xE07B" },
    { L'\xE19C', L"\x203F\xE07C" },
    { L'\xE19E', L"\x203F\xE083" },
    { L'\xE19F', L"\x203F\xE084" },
    { L'\xE1A0', L"\x203F\xE085" },
    { L'\xE1A1', L"\x203F\xE086" },
    { L'\xE1A2', L"\x203F\xE08B" },
    { L'\xE1A3', L"\x203F\xE094" },
    { L'\xE1A4', L"\x203F\xE004\xE00D" },
    { L'\xE1A4', L"\x203F\xE099" },
    { L'\xE1AA', L"\x203F\xE080" },
    { L'\xE1AB', L"\x203F\xE091" },
    { L'\xE1AC', L"\x203F\xE092" },
    { L'\xE1AD', L"\x203F\xE093" },
    { L'\xE1AE', L"\x203F\xE08C" },
    { L'\xE1AF', L"\x203F\xE08D" },
    { L'\xE1B0', L"\x203F\xE08E" },
    { L'\xE1B5', L"\x203F\xE0A0" },
    { L'\xE1B6', L"\x203F\xE0A1" },
    { L'\xE1B7', L"\x203F\xE0A3" },
    { L'\xE1B8', L"\x203F\xE0A5" },
    { L'\xE1BB', L"\x203F\xE0AA" },
    { L'\xE1C3', L"\x203F\xE0D4" },
    { L'\xE1C4', L"\x203F\xE05E\xE00D" },
    { L'\xE1C4', L"\x203F\xE0D5" },
    { L'\xE1C5', L"\x203F\xE08A" },
    { L'\xE1C6', L"\x203F\xE0A2" },
    { L'\xE1C7', L"\x203F\xE0A6" },
    { L'\xE1C8', L"\x203F\xE0D3" },
    { L'\xE1C9', L"\x203F\xE00C\xE0C4\xE00D" },
    { L'\xE1F0', L"\x0023\xE070" },
    { L'\xE1F1', L"\x0023\xE00F" },
    { L'\xE1F2', L"\x0023\xE011" },
    { L'\xE1F3', L"\x0023\xE039" },
    { L'\xE1F4', L"\x0023\xE006\xE006" },
    { L'\xE203', L"\x2013\xE000" },
    { L'\xE203', L"\xE200\xE000" },
    { L'\xE204', L"\xE201\xE000" },
    { L'\xE205', L"\x00D7\xE000" },
    { L'\xE205', L"\xE202\xE000" },
    { L'\xE206', L"\x2013\xE001" },
    { L'\xE206', L"\xE200\xE001" },
    { L'\xE207', L"\xE201\xE001" },
    { L'\xE208', L"\x00D7\xE001" },
    { L'\xE208', L"\xE202\xE001" },
    { L'\xE20D', L"\x2013\xE00F" },
    { L'\xE20D', L"\xE200\xE00F" },
    { L'\xE20E', L"\x2013\xE011" },
    { L'\xE20E', L"\xE200\xE011" },
    { L'\xE212', L"\xE201\xE00F" },
    { L'\xE21F', L"\x002B\xE011" },
    { L'\xE220', L"\x002D\xE000" },
    { L'\xE221', L"\x002D\xE001" },
    { L'\xE222', L"\x002D\xE00F" },
    { L'\xE223', L"\x002D\xE011" },
    { L'\xE225', L"\xE224\xE000" },
    { L'\xE226', L"\xE224\xE00F" },
    { L'\xE227', L"\xE201\xE00D" },
    { L'\xE228', L"\xE224\xE00D" },
    { L'\xE231', L"\x0030\xE035" },
    { L'\xE232', L"\x0023\xE0B1" },
    { L'\xE232', L"\x0023\xE0B4" },
    { L'\xE234', L"\x0030\xE037" },
    { L'\xE235', L"\x0030\xE0B5" },
    { L'\xE23C', L"\xE23B\xE0C4\x207A" },
    { L'\xE242', L"\x2190\xE037\xE037" },
    { L'\xE244', L"\x2192\xE037\xE037" },
    { L'\xE246', L"\x003E\xE0C4\x003D" },
    { L'\xE247', L"\x007E\xE008" },
    { L'\xE24B', L"\x2013\xE00D" },
    { L'\xE24C', L"\x007E\xE007" },
    { L'\xE24D', L"\x2013\xE088" },
    { L'\xE256', L"\x300C" },
    { L'\xE257', L"\x300D" },
    { L'\xE258', L"\x3010" },
    { L'\xE259', L"\x3011" },
    { L'\xE25A', L"\x3014" },
    { L'\xE25B', L"\x3015" },
    { L'\xE25C', L"\x3016" },
    { L'\xE25D', L"\x3017" },
    { L'\xE268', L"\x002F\xE0C4\x002F" },
    { L'\xE269', L"\x2013\xE037\xE037" },
    { L'\xE269', L"\x2013\xE0BD" },
    { L'\xE269', L"\x2013\xE0C4\x002F\xE0C4\x002F" },
    { L'\xE273', L"\x0029\xE0C4\x2192" },
    { L'\xE273', L"\x2192\xE0C4\x0029" },
    { L'\xE274', L"\x0021\xE0C4\x002C" },
    { L'\xE274', L"\x002C\xE0C4\x0021" },
    { L'\xE275', L"\x002C\xE0C4\x003F" },
    { L'\xE275', L"\x003F\xE0C4\x002C" },
    { L'\xE27C', L"\x2013\xE008\xE024" },
    { L'\xE280', L"\x003D\xE0B8" },
    { L'\xE281', L"\x003D\xE0BA" },
    { L'\xE285', L"\x006D\x25C6" },
    { L'\xE285', L"\x0070\xE286" },
    { L'\xE286', L"\x006D\x25C7" },
    { L'\xE28B', L"\x002B\xE0C0" },
    { L'\xE28C', L"\x00B1\xE0C0" },
    { L'\xE28D', L"\x2248\xE0C0" },
    { L'\xE28E', L"\x002F\xE0C0" },
    { L'\xE28F', L"\x2192\xE0C0" },
    { L'\xE2AA', L"\x002D\xE00D" },
    { L'\xE2AB', L"\x00D7\xE0C2" },
    { L'\xE2B3', L"\x00D7\xE016" },
    { L'\xE2B4', L"\x00D7\xE017" },
    { L'\xE2B5', L"\x00D7\xE02D" },
    { L'\xE2B6', L"\x00D7\xE023" },
    { L'\xE2B7', L"\x00D7\xE00D" },
    { L'\xE2B8', L"\x00D7\xE029" },
    { L'\xE2C2', L"\x2308\xE0C4\x2308" },
    { L'\xE2C3', L"\x2309\xE0C4\x2309" },
    { L'\xE2C4', L"\x230A\xE0C4\x230A" },
    { L'\xE2C5', L"\x230B\xE0C4\x230B" },
    { L'\xE2D8', L"\x203F\xE0B9" },
    { L'\xE2D9', L"\x203F\xE0BB" },
    { L'\xE2DE', L"\xE0D7" },
    { L'\xE2DF', L"\xE0D6" },
    { L'\xE2E1', L"\xE2E0\xE037" },
    { L'\xE2E3', L"\xE2E2\xE037" },
    { L'\xE2E5', L"\xE2E4\xE037" },
    { L'\xE2E7', L"\xE2E6\xE037" },
    { L'\xE2E9', L"\xE2E8\xE037" },
    { L'\xE2EB', L"\xE2EA\xE037" },
    { L'\xE2ED', L"\xE2EC\xE037" },
    { L'\xE2EF', L"\xE2EE\xE037" },
    { L'\xE2F0', L"\x203F\xE05C\x0032" },
    { L'\xE2F1', L"\x203F\xE05D\x0032" },
    { L'\xE2F2', L"\x203F\xE05E\x0032" },
    { L'\xE2F3', L"\x203F\xE05F\x0032" },
    { L'\xE2F4', L"\x203F\xE060\x0032" },
    { L'\xE2F5', L"\x203F\xE061\x0032" },
    { L'\xE2F6', L"\x203F\xE0D4\x0032" },
    { L'\xE2F7', L"\x203F\xE05E\xE00D\x0032" },
    { L'\xE2F7', L"\x203F\xE0D5\x0032" },
    { L'\xE2F8', L"\x203F\xE05C\x0034" },
    { L'\xE2F9', L"\x203F\xE05D\x0034" },
    { L'\xE2FA', L"\x203F\xE05E\x0034" },
    { L'\xE2FB', L"\x203F\xE05F\x0034" },
    { L'\xE2FC', L"\x203F\xE060\x0034" },
    { L'\xE2FD', L"\x203F\xE061\x0034" },
    { L'\xE2FE', L"\x203F\xE0D4\x0034" },
    { L'\xE2FF', L"\x203F\xE05E\xE00D\x0034" },
    { L'\xE2FF', L"\x203F\xE0D5\x0034" },
    { L'\xE300', L"\x0061\xE000\xE023" },
    { L'\xE301', L"\x0061\xE000\xE025" },
    { L'\xE302', L"\x0061\xE028\xE000\xE025" },
    { L'\xE303', L"\x0061\xE028\xE000" },
    { L'\xE304', L"\x0061\xE001\xE023" },
    { L'\xE305', L"\x0061\xE001\xE025" },
    { L'\xE306', L"\x0061\xE028\xE001\xE025" },
    { L'\xE307', L"\x0061\xE028\xE001" },
    { L'\xE308', L"\x0061\xE003\xE000" },
    { L'\xE309', L"\x0061\xE003\xE001" },
    { L'\xE30A', L"\x0061\xE003\xE023" },
    { L'\xE30B', L"\x0061\xE003\xE025" },
    { L'\xE30C', L"\x0061\xE028\xE003" },
    { L'\xE30D', L"\x0061\xE004\xE000" },
    { L'\xE30E', L"\x0061\xE004\xE001" },
    { L'\xE30F', L"\x0061\xE004\xE003" },
    { L'\xE310', L"\x0061\xE004\xE006" },
    { L'\xE311', L"\x0061\xE004\xE00A" },
    { L'\xE312', L"\x0061\xE004\xE025" },
    { L'\xE313', L"\x0061\xE006\xE025" },
    { L'\xE314', L"\x0061\xE027\xE006" },
    { L'\xE315', L"\x0061\xE028\xE006" },
    { L'\xE316', L"\x0061\xE007\xE000" },
    { L'\xE317', L"\x0061\xE007\xE001" },
    { L'\xE318', L"\x0061\xE007\xE003" },
    { L'\xE319', L"\x0061\xE007\xE00F" },
    { L'\xE31A', L"\x0061\xE007\xE011" },
    { L'\xE31B', L"\x0061\xE028\xE007" },
    { L'\xE31C', L"\x0061\xE008\xE000" },
    { L'\xE31D', L"\x0061\xE028\xE008\xE000" },
    { L'\xE31E', L"\x0061\xE008\xE001" },
    { L'\xE31F', L"\x0061\xE028\xE008\xE001" },
    { L'\xE320', L"\x0061\xE008\xE00F" },
    { L'\xE321', L"\x0061\xE008\xE00F\xE025" },
    { L'\xE322', L"\x0061\xE028\xE008\xE00F" },
    { L'\xE323', L"\x0061\xE008\xE011" },
    { L'\xE324', L"\x0061\xE028\xE008\xE011" },
    { L'\xE325', L"\x0061\xE008\xE025" },
    { L'\xE326', L"\x0061\xE028\xE008" },
    { L'\xE327', L"\x0061\xE00A\xE000" },
    { L'\xE328', L"\x0061\xE028\xE00A\xE004" },
    { L'\xE329', L"\x0061\xE028\xE00A\xE006" },
    { L'\xE32A', L"\x0061\xE00A\xE00F" },
    { L'\xE32B', L"\x0061\xE00A\xE011" },
    { L'\xE32C', L"\x0061\xE00B" },
    { L'\xE32D', L"\x0061\xE00D" },
    { L'\xE32E', L"\x0061\xE00F\xE025" },
    { L'\xE32F', L"\x0061\xE028\xE00F" },
    { L'\xE330', L"\x0061\xE011\xE023" },
    { L'\xE331', L"\x0061\xE011\xE025" },
    { L'\xE332', L"\x0061\xE028\xE011" },
    { L'\xE333', L"\x0061\xE064" },
    { L'\xE334', L"\x0061\xE028\xE064" },
    { L'\xE335', L"\x0061\xE072" },
    { L'\xE336', L"\x0061\xE073" },
    { L'\xE337', L"\x0061\xE074" },
    { L'\xE338', L"\x0061\xE077" },
    { L'\xE339', L"\x0061\xE07A" },
    { L'\xE33A', L"\x0061\xE07B" },
    { L'\xE33B', L"\x0061\xE07C" },
    { L'\xE33C', L"\x0061\xE07D" },
    { L'\xE33D', L"\x0061\xE028\xE023" },
    { L'\xE33E', L"\x0061\xE028\xE025" },
    { L'\xE33F', L"\x0061\xE02F" },
    { L'\xE340', L"\x0061\xE031" },
    { L'\xE341', L"\x0250\xE000" },
    { L'\xE342', L"\x0250\xE001" },
    { L'\xE343', L"\x028C\xE000" },
    { L'\xE344', L"\x0251\xE000" },
    { L'\xE345', L"\x0061\xE02E" },
    { L'\xE346', L"\x0061\xE0C4\x0065\xE000" },
    { L'\xE347', L"\x0061\xE0C4\x0065\xE006" },
    { L'\xE348', L"\x0061\xE008\xE002" },
    { L'\xE349', L"\x0061\xE004\xE023" },
    { L'\xE34A', L"\x0061\xE02D" },
    { L'\xE34B', L"\x0061\xE006\xE00D" },
    { L'\xE34C', L"\x0061\xE000\xE030" },
    { L'\xE34D', L"\x0061\xE001\xE030" },
    { L'\xE34E', L"\x0061\xE030" },
    { L'\xE34F', L"\x0251\xE000\xE030" },
    { L'\xE350', L"\x0251\xE001\xE030" },
    { L'\xE351', L"\x0251\xE030" },
    { L'\xE352', L"\x0251\xE003\xE000\xE030" },
    { L'\xE353', L"\x0251\xE003\xE001\xE030" },
    { L'\xE354', L"\x0251\xE003\xE030" },
    { L'\xE355', L"\x0252\xE000\xE030" },
    { L'\xE356', L"\x0252\xE001\xE030" },
    { L'\xE357', L"\x0252\xE030" },
    { L'\xE358', L"\x0252\xE003\xE000\xE030" },
    { L'\xE359', L"\x0252\xE003\xE001\xE030" },
    { L'\xE35A', L"\x0252\xE003\xE030" },
    { L'\xE35B', L"\x0061\xE003\xE000\xE030" },
    { L'\xE35C', L"\x0061\xE003\xE001\xE030" },
    { L'\xE35D', L"\x0061\xE003\xE030" },
    { L'\xE35E', L"\x0061\xE0C4\x0065\xE003\xE000" },
    { L'\xE35F', L"\x0061\xE0C4\x0065\xE003\xE001" },
    { L'\xE360', L"\x0061\xE0C4\x0065\xE003" },
    { L'\xE361', L"\x0061\xE028\xE004\xE000" },
    { L'\xE362', L"\x0061\xE004\xE087" },
    { L'\xE363', L"\x0061\xE004\xE088" },
    { L'\xE364', L"\x0061\xE004\xE089" },
    { L'\xE365', L"\x0061\xE007\xE006" },
    { L'\xE366', L"\x0061\xE028\xE007\xE006" },
    { L'\xE367', L"\x0061\xE028\xE072" },
    { L'\xE368', L"\x0061\xE087" },
    { L'\xE369', L"\x0061\xE088" },
    { L'\xE36A', L"\x0061\xE028\xE088" },
    { L'\xE36B', L"\x0061\xE089" },
    { L'\xE36C', L"\x0061\xE003\xE004" },
    { L'\xE36D', L"\x0061\xE028\xE083" },
    { L'\xE36E', L"\x0061\xE0C4\x0065\xE011" },
    { L'\xE36F', L"\x0061\xE083" },
    { L'\xE370', L"\x0061\xE000\xE01D" },
    { L'\xE371', L"\x0061\xE001\xE01D" },
    { L'\xE372', L"\x0061\xE003\xE000\xE01D" },
    { L'\xE373', L"\x0061\xE003\xE001\xE01D" },
    { L'\xE374', L"\x0061\xE003\xE01D" },
    { L'\xE375', L"\x0061\xE01D" },
    { L'\xE376', L"\x0061\xE00E" },
    { L'\xE377', L"\x0251\xE003\xE025" },
    { L'\xE378', L"\x0251\xE004\xE001" },
    { L'\xE379', L"\x0251\xE004\xE023" },
    { L'\xE37A', L"\x0251\xE004" },
    { L'\xE37B', L"\x0251\xE002" },
    { L'\xE37C', L"\x0251\xE055" },
    { L'\xE37D', L"\x1D00\xE001" },
    { L'\xE37E', L"\x1D00\xE02D" },
    { L'\xE37F', L"\x0251\xE001" },
    { L'\xE380', L"\x0251\xE004\xE003" },
    { L'\xE381', L"\x0061\xE028\xE073" },
    { L'\xE382', L"\x0061\xE013" },
    { L'\xE383', L"\x0250\xE02F" },
    { L'\xE384', L"\x0061\xE028\xE004\xE001" },
    { L'\xE385', L"\x0061\xE039" },
    { L'\xE386', L"\x0061\xE029" },
    { L'\xE387', L"\x0061\xE008\xE003" },
    { L'\xE388', L"\x0061\xE00A\xE004" },
    { L'\xE389', L"\x0061\xE00A\xE002" },
    { L'\xE38A', L"\x0061\xE008\xE00B" },
    { L'\xE38B', L"\x0061\xE008\xE006" },
    { L'\xE38C', L"\x0061\xE00C\xE004" },
    { L'\xE38D', L"\x0061\xE02F\xE023" },
    { L'\xE38E', L"\x0061\xE028\xE039" },
    { L'\xE38F', L"\x0061\xE028\xE00A" },
    { L'\xE390', L"\x0061\xE001\xE039" },
    { L'\xE391', L"\x0061\xE003\xE039" },
    { L'\xE392', L"\x0061\xE003\xE02F" },
    { L'\xE393', L"\x0061\xE004\xE039" },
    { L'\xE394', L"\x0061\xE028\xE004" },
    { L'\xE395', L"\x0061\xE002\xE026" },
    { L'\xE396', L"\x0061\xE028\xE002" },
    { L'\xE397', L"\x0061\xE000\xE039" },
    { L'\xE398', L"\x0061\xE004\xE02F" },
    { L'\xE399', L"\x0061\xE002\xE00A" },
    { L'\xE39A', L"\x0061\xE00B\xE039" },
    { L'\xE39B', L"\x0061\xE028\xE00B" },
    { L'\xE39C', L"\x0061\xE00F\xE039" },
    { L'\xE39D', L"\x0061\xE00B\xE023" },
    { L'\xE39E', L"\x0061\xE00F\xE023" },
    { L'\xE39F', L"\x0061\xE006\xE039" },
    { L'\xE3A0', L"\x0061\xE028\xE001\xE039" },
    { L'\xE3A1', L"\x0061\xE00C\xE039" },
    { L'\xE3A2', L"\x0061\xE007\xE023" },
    { L'\xE3A3', L"\x0061\xE028\xE07C" },
    { L'\xE3A4', L"\x0061\xE028\xE001\xE023" },
    { L'\xE3A5', L"\x0061\xE028\xE003\xE023" },
    { L'\xE3A6', L"\x0061\xE028\xE00A\xE003" },
    { L'\xE3A7', L"\x0061\xE028\xE011\xE023" },
    { L'\xE3A8', L"\x0061\xE028\xE00A\xE011" },
    { L'\xE3A9', L"\x0061\xE028\xE011\xE039" },
    { L'\xE3AA', L"\x0061\xE028\xE000\xE039" },
    { L'\xE3AB', L"\x0061\xE028\xE006\xE039" },
    { L'\xE3AC', L"\x0061\xE028\xE006\xE023" },
    { L'\xE3AD', L"\x0251\xE004\xE02F" },
    { L'\xE3AE', L"\x1D00\xE02F" },
    { L'\xE3AF', L"\x0061\xE014" },
    { L'\xE3B0', L"\x0061\xE02C" },
    { L'\xE3B1', L"\x0251\xE054" },
    { L'\xE3B2', L"\x0061\xE024" },
    { L'\xE3B3', L"\x0061\xE004\xE00D" },
    { L'\xE3B4', L"\x0061\xE008\xE023" },
    { L'\xE3B5', L"\x0061\xE008\xE031" },
    { L'\xE3B6', L"\x0061\xE008\xE024" },
    { L'\xE3B7', L"\x0061\xE006\xE00A" },
    { L'\xE3B8', L"\x0061\xE00F\xE011" },
    { L'\xE3B9', L"\x0061\xE011\xE039" },
    { L'\xE3BA', L"\x0061\xE00A\xE02F" },
    { L'\xE3BB', L"\x0061\xE063" },
    { L'\xE3BC', L"\x0061\xE065" },
    { L'\xE3BD', L"\x0061\xE066" },
    { L'\xE3BE', L"\x0061\xE067" },
    { L'\xE3BF', L"\x0061\xE06E" },
    { L'\xE3C0', L"\x0061\xE08B" },
    { L'\xE3C1', L"\x0250\xE004\xE003" },
    { L'\xE3C2', L"\x0061\xE004\xE011" },
    { L'\xE3C3', L"\x028C\xE001" },
    { L'\xE3C4', L"\x0061\xE004\xE002" },
    { L'\xE3C5', L"\x028C\xE00D" },
    { L'\xE3C6', L"\x0061\xE0AA\xE008" },
    { L'\xE3C7', L"\x0061\xE028\xE008\xE004" },
    { L'\xE3C8', L"\x0061\xE028\xE008\xE006" },
    { L'\xE3C9', L"\x0061\xE0C4\x0065\xE004\xE003" },
    { L'\xE3CA', L"\x0061\xE0C4\x0065\xE004\xE001" },
    { L'\xE3CB', L"\x0061\xE0C4\x0065\xE004\xE002" },
    { L'\xE3CC', L"\x0061\xE0C4\x0065\xE004\xE00D" },
    { L'\xE3CD', L"\x0061\xE0C4\x0065\xE004\xE011" },
    { L'\xE3CE', L"\x0061\xE0C4\x0065\xE006\xE00D" },
    { L'\xE3CF', L"\x028C\xE004\xE003" },
    { L'\xE3D0', L"\x028C\xE004\xE000" },
    { L'\xE3D1', L"\x028C\xE004\xE001" },
    { L'\xE3D2', L"\x028C\xE004\xE002" },
    { L'\xE3D3', L"\x028C\xE004\xE00D" },
    { L'\xE3D4', L"\x028C\xE004\xE011" },
    { L'\xE3D5', L"\x028C\xE006\xE00D" },
    { L'\xE3D6', L"\x0061\xE0C4\x0065\xE004\xE000" },
    { L'\xE3D7', L"\x0061\xE008\xE00C" },
    { L'\xE3D8', L"\x0061\xE00A\xE004\xE001" },
    { L'\xE3D9', L"\x0061\xE004\xE003\xE001" },
    { L'\xE3DA', L"\x0250\xE006" },
    { L'\xE3DB', L"\x0061\xE028\xE006\xE001" },
    { L'\xE3DC', L"\x0061\xE001\xE024" },
    { L'\xE3DD', L"\x0252\xE000" },
    { L'\xE3DE', L"\x0251\xE003\xE023" },
    { L'\xE3DF', L"\x0251\xE023" },
    { L'\xE3E0', L"\x0041\xE001\xE025" },
    { L'\xE3E1', L"\x0041\xE004\xE000" },
    { L'\xE3E2', L"\x0041\xE004\xE001" },
    { L'\xE3E3', L"\x0041\xE008\xE000" },
    { L'\xE3E4', L"\x0041\xE008\xE001" },
    { L'\xE3E5', L"\x0041\xE011\xE025" },
    { L'\xE3E6', L"\x0041\xE064" },
    { L'\xE3E7', L"\x0041\xE02D" },
    { L'\xE3E8', L"\x0041\xE00A\xE000" },
    { L'\xE3E9', L"\x0041\xE00E" },
    { L'\xE3EA', L"\x0041\xE008\xE024" },
    { L'\xE3EB', L"\x0041\xE065" },
    { L'\xE3EC', L"\x0041\xE066" },
    { L'\xE3ED', L"\x0041\xE06E" },
    { L'\xE3EE', L"\x0041\xE008\xE002" },
    { L'\xE3EF', L"\x0041\xE008\xE00C" },
    { L'\xE3F0', L"\x0041\xE00D" },
    { L'\xE3F1', L"\x0041\xE004\xE023" },
    { L'\xE3F2', L"\x0041\xE028\xE001" },
    { L'\xE3F3', L"\x0041\xE00B" },
    { L'\xE3F4', L"\x0041\xE003\xE023" },
    { L'\xE3F5', L"\x0041\xE004\xE003" },
    { L'\xE3F6', L"\x0041\xE000\xE023" },
    { L'\xE3F7', L"\x0041\xE001\xE023" },
    { L'\xE3F8', L"\x0041\xE0C4\x0045\xE00F" },
    { L'\xE3F9', L"\x0041\xE0C4\x0045\xE023" },
    { L'\xE3FA', L"\x0041\xE0C4\x0045\xE00B" },
    { L'\xE3FB', L"\x0041\xE0C4\x0045\xE011" },
    { L'\xE3FC', L"\x0041\xE0C4\x0045\xE003" },
    { L'\xE3FD', L"\x0041\xE0C4\x0045\xE00C" },
    { L'\xE3FE', L"\x0041\xE011\xE023" },
    { L'\xE3FF', L"\x0041\xE00F\xE025" },
    { L'\xE400', L"\x0065\xE000\xE023" },
    { L'\xE401', L"\x0065\xE000\xE023\xE02D" },
    { L'\xE402', L"\x0065\xE000\xE024" },
    { L'\xE403', L"\x0065\xE000\xE025" },
    { L'\xE404', L"\x0065\xE028\xE000" },
    { L'\xE405', L"\x0065\xE000\xE02D" },
    { L'\xE406', L"\x0065\xE000\xE039" },
    { L'\xE407', L"\x0065\xE001\xE023" },
    { L'\xE408', L"\x0065\xE001\xE023\xE02D" },
    { L'\xE409', L"\x0065\xE001\xE024" },
    { L'\xE40A', L"\x0065\xE001\xE025" },
    { L'\xE40B', L"\x0065\xE028\xE001" },
    { L'\xE40C', L"\x0065\xE001\xE02D" },
    { L'\xE40D', L"\x0065\xE001\xE039" },
    { L'\xE40E', L"\x0065\xE028\xE001\xE039" },
    { L'\xE40F', L"\x0065\xE002\xE004" },
    { L'\xE410', L"\x0065\xE002\xE006" },
    { L'\xE411', L"\x0065\xE002\xE011" },
    { L'\xE412', L"\x0065\xE028\xE002" },
    { L'\xE413', L"\x0065\xE002\xE039" },
    { L'\xE414', L"\x0065\xE003\xE000" },
    { L'\xE415', L"\x0065\xE003\xE001" },
    { L'\xE416', L"\x0065\xE003\xE023" },
    { L'\xE417', L"\x0065\xE027\xE003" },
    { L'\xE418', L"\x0065\xE028\xE003" },
    { L'\xE419', L"\x0065\xE003\xE039" },
    { L'\xE41A', L"\x0065\xE004\xE000\xE039" },
    { L'\xE41B', L"\x0065\xE004\xE001\xE023" },
    { L'\xE41C', L"\x0065\xE004\xE001\xE039" },
    { L'\xE41D', L"\x0065\xE004\xE006" },
    { L'\xE41E', L"\x0065\xE004\xE023" },
    { L'\xE41F', L"\x0065\xE004\xE025" },
    { L'\xE420', L"\x0065\xE028\xE004" },
    { L'\xE421', L"\x0065\xE004\xE02D" },
    { L'\xE422', L"\x0065\xE004\xE039" },
    { L'\xE423', L"\x0065\xE006\xE023" },
    { L'\xE424', L"\x0065\xE028\xE006" },
    { L'\xE425', L"\x0065\xE007\xE000" },
    { L'\xE426', L"\x0065\xE007\xE001" },
    { L'\xE427', L"\x0065\xE007\xE003" },
    { L'\xE428', L"\x0065\xE007\xE004" },
    { L'\xE429', L"\x0065\xE007\xE00F" },
    { L'\xE42A', L"\x0065\xE007\xE011" },
    { L'\xE42B', L"\x0065\xE007\xE023" },
    { L'\xE42C', L"\x0065\xE007\xE025" },
    { L'\xE42D', L"\x0065\xE028\xE007" },
    { L'\xE42E', L"\x0065\xE008\xE000" },
    { L'\xE42F', L"\x0065\xE008\xE001" },
    { L'\xE430', L"\x0065\xE008\xE004\xE001" },
    { L'\xE431', L"\x0065\xE008\xE006" },
    { L'\xE432', L"\x0065\xE008\xE00F" },
    { L'\xE433', L"\x0065\xE008\xE011" },
    { L'\xE434', L"\x0065\xE028\xE00B" },
    { L'\xE435', L"\x0065\xE00C\xE000" },
    { L'\xE436', L"\x0065\xE00C\xE001" },
    { L'\xE437', L"\x0065\xE00C\xE004" },
    { L'\xE438', L"\x0065\xE00C\xE004\xE001" },
    { L'\xE439', L"\x0065\xE00C\xE006" },
    { L'\xE43A', L"\x0065\xE00C\xE00B" },
    { L'\xE43B', L"\x0065\xE00C\xE00D" },
    { L'\xE43C', L"\x0065\xE00C\xE00F" },
    { L'\xE43D', L"\x0065\xE00C\xE011" },
    { L'\xE43E', L"\x0065\xE00D" },
    { L'\xE43F', L"\x0065\xE00D\xE023" },
    { L'\xE440', L"\x0065\xE028\xE00D" },
    { L'\xE441', L"\x0065\xE00F\xE016" },
    { L'\xE442', L"\x0065\xE00F\xE023" },
    { L'\xE443', L"\x0065\xE00F\xE024" },
    { L'\xE444', L"\x0065\xE00F\xE025" },
    { L'\xE445', L"\x0065\xE028\xE00F" },
    { L'\xE446', L"\x0065\xE00F\xE02D" },
    { L'\xE447', L"\x0065\xE00F\xE02F" },
    { L'\xE448', L"\x0065\xE00F\xE039" },
    { L'\xE449', L"\x0065\xE011\xE00F\xE039" },
    { L'\xE44A', L"\x0065\xE011\xE016" },
    { L'\xE44B', L"\x0065\xE011\xE023" },
    { L'\xE44C', L"\x0065\xE028\xE011\xE023" },
    { L'\xE44D', L"\x0065\xE011\xE024" },
    { L'\xE44E', L"\x0065\xE027\xE011" },
    { L'\xE44F', L"\x0065\xE028\xE011" },
    { L'\xE450', L"\x0065\xE011\xE02D" },
    { L'\xE451', L"\x0065\xE011\xE02F" },
    { L'\xE452', L"\x0065\xE011\xE039" },
    { L'\xE453', L"\x0065\xE070" },
    { L'\xE454', L"\x0065\xE071" },
    { L'\xE455', L"\x0065\xE028\xE071" },
    { L'\xE456', L"\x0065\xE073" },
    { L'\xE457', L"\x0065\xE077" },
    { L'\xE458', L"\x0065\xE07A" },
    { L'\xE459', L"\x0065\xE07D" },
    { L'\xE45A', L"\x0065\xE07E" },
    { L'\xE45B', L"\x0065\xE028\xE023" },
    { L'\xE45C', L"\x0065\xE023\xE02D" },
    { L'\xE45D', L"\x0065\xE024" },
    { L'\xE45E', L"\x0065\xE025" },
    { L'\xE45F', L"\x0065\xE02C" },
    { L'\xE460', L"\x0065\xE02F" },
    { L'\xE461', L"\x0065\xE031" },
    { L'\xE462', L"\x0065\xE039" },
    { L'\xE463', L"\x0065\xE028\xE039" },
    { L'\xE464', L"\x0065\xE0A0" },
    { L'\xE465', L"\x0065\xE028\xE008" },
    { L'\xE466', L"\x0259\xE000" },
    { L'\xE467', L"\x0259\xE001" },
    { L'\xE468', L"\x0259\xE028\xE001" },
    { L'\xE469', L"\x0259\xE002" },
    { L'\xE46A', L"\x0259\xE003" },
    { L'\xE46B', L"\x0259\xE003\xE000" },
    { L'\xE46C', L"\x0259\xE003\xE001" },
    { L'\xE46D', L"\x0259\xE003\xE023" },
    { L'\xE46E', L"\x0259\xE003\xE025" },
    { L'\xE46F', L"\x0259\xE004" },
    { L'\xE470', L"\x0259\xE006" },
    { L'\xE471', L"\x0259\xE007" },
    { L'\xE472', L"\x0259\xE00D" },
    { L'\xE473', L"\x0259\xE00F" },
    { L'\xE474', L"\x0259\xE00F\xE024" },
    { L'\xE475', L"\x0259\xE011" },
    { L'\xE476', L"\x0259\xE011\xE023" },
    { L'\xE477', L"\x0259\xE011\xE024" },
    { L'\xE478', L"\x0259\xE011\xE025" },
    { L'\xE479', L"\x0259\xE070" },
    { L'\xE47A', L"\x0259\xE07E" },
    { L'\xE47B', L"\x0259\xE023" },
    { L'\xE47C', L"\x0259\xE025" },
    { L'\xE47D', L"\x0259\xE028" },
    { L'\xE47E', L"\x0259\xE02F" },
    { L'\xE47F', L"\x0259\xE037" },
    { L'\xE480', L"\x025B\xE000" },
    { L'\xE481', L"\x025B\xE001" },
    { L'\xE482', L"\x025B\xE003" },
    { L'\xE483', L"\x025B\xE003\xE000" },
    { L'\xE484', L"\x025B\xE003\xE001" },
    { L'\xE485', L"\x025B\xE00D" },
    { L'\xE486', L"\x025B\xE00F" },
    { L'\xE487', L"\x025B\xE011" },
    { L'\xE488', L"\x025B\xE028" },
    { L'\xE489', L"\x044D\xE000" },
    { L'\xE48A', L"\x044D\xE001" },
    { L'\xE48B', L"\x044D\xE002" },
    { L'\xE48C', L"\x044D\xE004" },
    { L'\xE48D', L"\x044D\xE004\xE000" },
    { L'\xE48E', L"\x044D\xE004\xE001" },
    { L'\xE48F', L"\x044D\xE006" },
    { L'\xE490', L"\x0454\xE000" },
    { L'\xE491', L"\x0454\xE001" },
    { L'\xE492', L"\x0454\xE002" },
    { L'\xE493', L"\x0454\xE004" },
    { L'\xE494', L"\x0454\xE004\xE000" },
    { L'\xE495', L"\x0454\xE004\xE001" },
    { L'\xE496', L"\x0454\xE006" },
    { L'\xE497', L"\xE130\xE000" },
    { L'\xE498', L"\x0065\xE0A0\xE002" },
    { L'\xE499', L"\x01A8\xE000" },
    { L'\xE49A', L"\x01A8\xE001" },
    { L'\xE49B', L"\x0065\xE00C\xE004\xE000" },
    { L'\xE49C', L"\x0065\xE01E" },
    { L'\xE49D', L"\x0065\xE004\xE02C" },
    { L'\xE49E', L"\x0065\xE00A" },
    { L'\xE49F', L"\x0259\xE02C" },
    { L'\xE4A0', L"\x0259\xE02D" },
    { L'\xE4A1', L"\x025B\xE004" },
    { L'\xE4A2', L"\x025B\xE02F" },
    { L'\xE4A3', L"\x0065\xE000\xE01D" },
    { L'\xE4A4', L"\x0065\xE001\xE01D" },
    { L'\xE4A5', L"\x0065\xE01D" },
    { L'\xE4A6', L"\x0065\xE000\xE01E" },
    { L'\xE4A7', L"\x0065\xE001\xE01E" },
    { L'\xE4A8', L"\x0065\xE003\xE000\xE01E" },
    { L'\xE4A9', L"\x0065\xE003\xE001\xE01E" },
    { L'\xE4AA', L"\x0065\xE003\xE01E" },
    { L'\xE4AB', L"\x0065\xE004\xE003" },
    { L'\xE4AC', L"\x0065\xE006\xE00D" },
    { L'\xE4AD', L"\x0259\xE00B" },
    { L'\xE4AE', L"\x0259\xE031" },
    { L'\xE4AF', L"\x0259\xE035\xE031" },
    { L'\xE4B0', L"\x0259\xE035" },
    { L'\xE4B1', L"\x025B\xE031" },
    { L'\xE4B2', L"\x0259\xE000\xE030" },
    { L'\xE4B3', L"\x0259\xE001\xE030" },
    { L'\xE4B4', L"\x0259\xE030" },
    { L'\xE4B5', L"\x025B\xE000\xE030" },
    { L'\xE4B6', L"\x025B\xE001\xE030" },
    { L'\xE4B7', L"\x025B\xE030" },
    { L'\xE4B8', L"\x0065\xE000\xE030" },
    { L'\xE4B9', L"\x0065\xE001\xE030" },
    { L'\xE4BA', L"\x025B\xE025" },
    { L'\xE4BB', L"\x0258\xE030" },
    { L'\xE4BC', L"\x0065\xE003\xE000\xE030" },
    { L'\xE4BD', L"\x0065\xE003\xE001\xE030" },
    { L'\xE4BE', L"\x0065\xE003\xE030" },
    { L'\xE4BF', L"\x0259\xE003\xE000\xE030" },
    { L'\xE4C0', L"\x0259\xE003\xE001\xE030" },
    { L'\xE4C1', L"\x0259\xE003\xE030" },
    { L'\xE4C2', L"\x025B\xE003\xE000\xE030" },
    { L'\xE4C3', L"\x025B\xE003\xE001\xE030" },
    { L'\xE4C4', L"\x025B\xE003\xE030" },
    { L'\xE4C5', L"\x0065\xE063" },
    { L'\xE4C6', L"\x0065\xE064" },
    { L'\xE4C7', L"\x0259\xE00C" },
    { L'\xE4C8', L"\x025B\xE004\xE02C" },
    { L'\xE4C9', L"\x025B\xE004\xE02D" },
    { L'\xE4CA', L"\x025B\xE02C" },
    { L'\xE4CB', L"\x025B\xE02D" },
    { L'\xE4CC', L"\x0065\xE035" },
    { L'\xE4CD', L"\x025B\xE035" },
    { L'\xE4CE', L"\x0065\xE004\xE000\xE025" },
    { L'\xE4CF', L"\x0065\xE004\xE001\xE025" },
    { L'\xE4D0', L"\x0065\xE028\xE004\xE000" },
    { L'\xE4D1', L"\x0065\xE028\xE004\xE001" },
    { L'\xE4D2', L"\x0065\xE004\xE088" },
    { L'\xE4D3', L"\x0065\xE007\xE004\xE001" },
    { L'\xE4D4', L"\x0065\xE00B" },
    { L'\xE4D5', L"\x0065\xE088" },
    { L'\xE4D6', L"\x044D\xE004\xE088" },
    { L'\xE4D7', L"\x044D\xE088" },
    { L'\xE4D8', L"\x044D\xE089" },
    { L'\xE4D9', L"\x0454\xE028\xE001" },
    { L'\xE4DA', L"\x0454\xE004\xE088" },
    { L'\xE4DB', L"\x0454\xE088" },
    { L'\xE4DC', L"\x0454\xE028" },
    { L'\xE4DD', L"\x0065\xE02E" },
    { L'\xE4DE', L"\x0065\xE002\xE00C" },
    { L'\xE4DF', L"\x0454\xE028\xE000" },
    { L'\xE4E0', L"\x0045\xE000\xE023" },
    { L'\xE4E1', L"\x0045\xE027\xE000" },
    { L'\xE4E2', L"\x0045\xE001\xE023" },
    { L'\xE4E3', L"\x0045\xE027\xE002" },
    { L'\xE4E4', L"\x0045\xE027\xE003" },
    { L'\xE4E5', L"\x0045\xE028\xE003" },
    { L'\xE4E6', L"\x0045\xE027\xE004\xE000" },
    { L'\xE4E7', L"\x0045\xE004\xE006" },
    { L'\xE4E8', L"\x0045\xE027\xE004" },
    { L'\xE4E9', L"\x0045\xE007\xE003" },
    { L'\xE4EA', L"\x0045\xE011\xE023" },
    { L'\xE4EB', L"\x0045\xE073" },
    { L'\xE4EC', L"\x0045\xE025" },
    { L'\xE4ED', L"\x0045\xE0A0" },
    { L'\xE4EE', L"\x042D\xE000" },
    { L'\xE4EF', L"\x042D\xE001" },
    { L'\xE4F0', L"\x018F\xE035" },
    { L'\xE4F1', L"\x0404\xE000" },
    { L'\xE4F2', L"\x0404\xE001" },
    { L'\xE4F3', L"\x0045\xE002\xE004" },
    { L'\xE4F4', L"\x0045\xE002\xE00C" },
    { L'\xE4F5', L"\x018E\xE000" },
    { L'\xE4F6', L"\x018E\xE001" },
    { L'\xE4F7', L"\x018F\xE000" },
    { L'\xE4F8', L"\x018F\xE001" },
    { L'\xE4F9', L"\x0045\xE001\xE024" },
    { L'\xE4FA', L"\x0045\xE024" },
    { L'\xE4FB', L"\x0190\xE001" },
    { L'\xE4FC', L"\x0045\xE0C2" },
    { L'\xE4FD', L"\x042D\xE004" },
    { L'\xE4FE', L"\x0404\xE004" },
    { L'\xE4FF', L"\x0045\xE028\xE001" },
    { L'\xE500', L"\x0069\xE000\xE023" },
    { L'\xE501', L"\x0069\xE000\xE024" },
    { L'\xE502', L"\x0069\xE000\xE025" },
    { L'\xE503', L"\x0069\xE028\xE000" },
    { L'\xE504', L"\x0069\xE000\xE039" },
    { L'\xE505', L"\x0069\xE037\xE000" },
    { L'\xE506', L"\x0069\xE001\xE023" },
    { L'\xE507', L"\x0069\xE001\xE024" },
    { L'\xE508', L"\x0069\xE028\xE001" },
    { L'\xE509', L"\x0069\xE001\xE039" },
    { L'\xE50A', L"\x0069\xE037\xE001" },
    { L'\xE50B', L"\x0069\xE002\xE001" },
    { L'\xE50C', L"\x0069\xE002\xE023" },
    { L'\xE50D', L"\x0069\xE003\xE000" },
    { L'\xE50E', L"\x0069\xE003\xE001" },
    { L'\xE50F', L"\x0069\xE028\xE003" },
    { L'\xE510', L"\x0069\xE003\xE02F" },
    { L'\xE511', L"\x0069\xE004\xE000" },
    { L'\xE512', L"\x0069\xE004\xE001" },
    { L'\xE513', L"\x0069\xE004\xE006" },
    { L'\xE514', L"\x0069\xE004\xE00D" },
    { L'\xE515', L"\x0069\xE004\xE039" },
    { L'\xE516', L"\x0069\xE008\xE000" },
    { L'\xE517', L"\x0069\xE008\xE006" },
    { L'\xE518', L"\x0069\xE008\xE00F" },
    { L'\xE519', L"\x0069\xE008\xE011" },
    { L'\xE51A', L"\x0069\xE00B" },
    { L'\xE51B', L"\x0069\xE00D" },
    { L'\xE51C', L"\x0069\xE00F\xE011" },
    { L'\xE51D', L"\x0069\xE00F\xE024" },
    { L'\xE51E', L"\x0069\xE00F\xE025" },
    { L'\xE51F', L"\x0069\xE028\xE00F" },
    { L'\xE520', L"\x0069\xE00F\xE039" },
    { L'\xE521', L"\x0069\xE037\xE00F" },
    { L'\xE522', L"\x0069\xE011\xE002" },
    { L'\xE523', L"\x0069\xE011\xE023" },
    { L'\xE524', L"\x0069\xE011\xE024" },
    { L'\xE525', L"\x0069\xE011\xE039" },
    { L'\xE526', L"\x0069\xE037\xE011" },
    { L'\xE527', L"\x0069\xE07A" },
    { L'\xE528', L"\x0069\xE07D" },
    { L'\xE529', L"\x0069\xE024" },
    { L'\xE52A', L"\x0069\xE025" },
    { L'\xE52B', L"\x0069\xE026" },
    { L'\xE52C', L"\x0069\xE028\xE037" },
    { L'\xE52D', L"\x0069\xE02D" },
    { L'\xE52E', L"\x0069\xE02E" },
    { L'\xE52F', L"\x0069\xE02F" },
    { L'\xE530', L"\x0069\xE02F\xE030" },
    { L'\xE531', L"\x0069\xE031" },
    { L'\xE532', L"\x0069\xE039" },
    { L'\xE533', L"\x0069\xE037" },
    { L'\xE534', L"\x0131\xE023" },
    { L'\xE535', L"\x026A\xE000" },
    { L'\xE536', L"\x026A\xE001" },
    { L'\xE537', L"\x1D09\xE004" },
    { L'\xE538', L"\x0069\xE006\xE007" },
    { L'\xE539', L"\x0069\xE00F\xE02F" },
    { L'\xE53A', L"\x0069\xE02C" },
    { L'\xE53B', L"\x0069\xE035\xE000" },
    { L'\xE53C', L"\x0069\xE035\xE001" },
    { L'\xE53D', L"\x0069\xE000\xE01E" },
    { L'\xE53E', L"\x0069\xE001\xE01E" },
    { L'\xE53F', L"\x0069\xE01E" },
    { L'\xE540', L"\x0069\xE006\xE00D" },
    { L'\xE541', L"\x0069\xE000\xE030" },
    { L'\xE542', L"\x0069\xE001\xE030" },
    { L'\xE543', L"\x0069\xE02F\xE025" },
    { L'\xE544', L"\x026A\xE030" },
    { L'\xE545', L"\x0069\xE003\xE000\xE030" },
    { L'\xE546', L"\x0069\xE003\xE001\xE030" },
    { L'\xE547', L"\x0069\xE003\xE030" },
    { L'\xE548', L"\x0069\xE030\xE02F" },
    { L'\xE549', L"\x0069\xE011\xE02F" },
    { L'\xE54A', L"\x0069\xE064" },
    { L'\xE54B', L"\x0069\xE028\xE004\xE001" },
    { L'\xE54C', L"\x0069\xE004\xE088" },
    { L'\xE54D', L"\x0069\xE028\xE006" },
    { L'\xE54E', L"\x0069\xE08C" },
    { L'\xE54F', L"\x0069\xE08D" },
    { L'\xE550', L"\x0069\xE087" },
    { L'\xE551', L"\x0069\xE088" },
    { L'\xE552', L"\x0069\xE028\xE088" },
    { L'\xE553', L"\x0069\xE070" },
    { L'\xE554', L"\x0069\xE035\xE055" },
    { L'\xE555', L"\x0069\xE006\xE001" },
    { L'\xE556', L"\x0069\xE006\xE000" },
    { L'\xE557', L"\x0069\xE001\xE02F" },
    { L'\xE558', L"\x0069\xE001\xE025" },
    { L'\xE559', L"\x0069\xE054" },
    { L'\xE55A', L"\x0069\xE055" },
    { L'\xE55B', L"\x0069\xE004\xE003" },
    { L'\xE55C', L"\x0069\xE00F\xE023" },
    { L'\xE55D', L"\x0069\xE011\xE025" },
    { L'\xE55E', L"\x0069\xE004\xE00C" },
    { L'\xE55F', L"\x0069\xE004\xE011" },
    { L'\xE560', L"\x0069\xE028\xE004\xE011" },
    { L'\xE561', L"\x0069\xE004\xE002" },
    { L'\xE562', L"\x0131\xE02F" },
    { L'\xE563', L"\x0069\xE028\xE025" },
    { L'\xE564', L"\x0069\xE003\xE02D" },
    { L'\xE565', L"\x0069\xE001\xE031" },
    { L'\xE566', L"\x0069\xE004\xE087" },
    { L'\xE567', L"\x0069\xE004\xE024" },
    { L'\xE568', L"\x0069\xE003\xE023" },
    { L'\xE569', L"\x0131\xE028" },
    { L'\xE56A', L"\x0069\xE035\xE003" },
    { L'\xE56B', L"\x0069\xE072" },
    { L'\xE56C', L"\x0069\xE073" },
    { L'\xE56D', L"\x0069\xE007\xE001" },
    { L'\xE56E', L"\x0069\xE008\xE004\xE001" },
    { L'\xE56F', L"\x0069\xE004\xE007" },
    { L'\xE570', L"\x0069\xE00A" },
    { L'\xE571', L"\x0069\xE0AA" },
    { L'\xE572', L"\x0069\xE0AA\xE004" },
    { L'\xE573', L"\x0069\xE008\xE02E" },
    { L'\xE574', L"\x0069\xE028\xE008" },
    { L'\xE575', L"\x0069\xE028\xE002" },
    { L'\xE576', L"\x0069\xE003\xE02E" },
    { L'\xE577', L"\x0069\xE004\xE030" },
    { L'\xE578', L"\x026A\xE006" },
    { L'\xE579', L"\x0069\xE002\xE030" },
    { L'\xE57C', L"\x0069\xE000\xE031" },
    { L'\xE57D', L"\x0069\xE008\xE003" },
    { L'\xE57E', L"\x0069\xE008\xE00D" },
    { L'\xE57F', L"\x0069\xE003\xE039" },
    { L'\xE580', L"\x0069\xE004\xE00D\xE039" },
    { L'\xE581', L"\x0069\xE00D\xE039" },
    { L'\xE582', L"\x0069\xE028\xE004\xE00D" },
    { L'\xE583', L"\x0069\xE028\xE00D" },
    { L'\xE584', L"\x0069\xE028\xE004" },
    { L'\xE585', L"\x0069\xE004\xE00D\xE02F" },
    { L'\xE586', L"\x0069\xE00D\xE02F" },
    { L'\xE587', L"\x0069\xE000\xE02F" },
    { L'\xE588', L"\x0069\xE004\xE02F" },
    { L'\xE589', L"\x0069\xE006\xE02F" },
    { L'\xE58A', L"\x0069\xE011\xE001" },
    { L'\xE58B', L"\x0069\xE00F\xE011\xE02F" },
    { L'\xE58C', L"\x0069\xE0A9" },
    { L'\xE58D', L"\x0069\xE028\xE011" },
    { L'\xE58E', L"\x0069\xE002\xE039" },
    { L'\xE58E', L"\x006F\xE003\xE011" },
    { L'\xE58F', L"\x0069\xE011\xE00F\xE039" },
    { L'\xE590', L"\x0069\xE017" },
    { L'\xE591', L"\x0069\xE004\xE006\xE02F" },
    { L'\xE592', L"\x0131\xE025" },
    { L'\xE593', L"\x0069\xE035\xE024" },
    { L'\xE594', L"\x0069\xE006\xE006" },
    { L'\xE595', L"\x0069\xE00C\xE00C" },
    { L'\xE596', L"\x0069\xE013" },
    { L'\xE597', L"\x0069\xE035\xE011" },
    { L'\xE5D0', L"\x0049\xE003\xE02F" },
    { L'\xE5D1', L"\x0049\xE011\xE02F" },
    { L'\xE5D2', L"\x0049\xE00D\xE02F" },
    { L'\xE5D3', L"\x0049\xE00F\xE02F" },
    { L'\xE5D4', L"\x0049\xE000\xE02F" },
    { L'\xE5D5', L"\x0049\xE004\xE02F" },
    { L'\xE5D6', L"\x0049\xE006\xE02F" },
    { L'\xE5E0', L"\x0049\xE037\xE000" },
    { L'\xE5E1', L"\x0049\xE037\xE001" },
    { L'\xE5E2', L"\x0049\xE028\xE003" },
    { L'\xE5E3', L"\x0049\xE02F" },
    { L'\xE5E4', L"\x0049\xE037" },
    { L'\xE5E5', L"\x0049\xE001\xE024" },
    { L'\xE5E6', L"\x0049\xE024" },
    { L'\xE5E7', L"\x0049\xE00D" },
    { L'\xE5E8', L"\x0049\xE003\xE023" },
    { L'\xE5E9', L"\x0049\xE011\xE023" },
    { L'\xE5EA', L"\x0049\xE004\xE023" },
    { L'\xE5EB', L"\x0049\xE004\xE000" },
    { L'\xE5EC', L"\x0049\xE004\xE001" },
    { L'\xE5ED', L"\x0049\xE001\xE023" },
    { L'\xE5EE', L"\x0049\xE004\xE003" },
    { L'\xE5EF', L"\x0049\xE063" },
    { L'\xE5F0', L"\x0049\xE025" },
    { L'\xE5F1', L"\x0049\xE039" },
    { L'\xE5F2', L"\x0049\xE003\xE039" },
    { L'\xE5F3', L"\x0049\xE011\xE039" },
    { L'\xE5F4', L"\x0049\xE00D\xE039" },
    { L'\xE5F5', L"\x0049\xE00F\xE039" },
    { L'\xE5F6', L"\x0049\xE000\xE039" },
    { L'\xE5F7', L"\x0049\xE001\xE039" },
    { L'\xE5F8', L"\x0049\xE004\xE039" },
    { L'\xE5F9', L"\x0049\xE006\xE039" },
    { L'\xE5FA', L"\x0049\xE028\xE011" },
    { L'\xE5FB', L"\x0049\xE028\xE00D" },
    { L'\xE5FC', L"\x0049\xE028\xE000" },
    { L'\xE5FD', L"\x0049\xE028\xE001" },
    { L'\xE5FE', L"\x0049\xE028\xE004" },
    { L'\xE5FF', L"\x0049\xE028\xE006" },
    { L'\xE600', L"\x006F\xE000\xE023" },
    { L'\xE601', L"\x006F\xE037\xE000\xE023" },
    { L'\xE602', L"\x006F\xE000\xE024" },
    { L'\xE603', L"\x006F\xE000\xE025" },
    { L'\xE604', L"\x006F\xE028\xE000" },
    { L'\xE605', L"\x006F\xE000\xE02D" },
    { L'\xE606', L"\x006F\xE000\xE039" },
    { L'\xE607', L"\x006F\xE037\xE000" },
    { L'\xE608', L"\x006F\xE001\xE023" },
    { L'\xE609', L"\x006F\xE037\xE001\xE023" },
    { L'\xE60A', L"\x006F\xE001\xE024" },
    { L'\xE60B', L"\x006F\xE028\xE001" },
    { L'\xE60C', L"\x006F\xE001\xE02D" },
    { L'\xE60D', L"\x006F\xE001\xE02F" },
    { L'\xE60E', L"\x006F\xE001\xE039" },
    { L'\xE60F', L"\x006F\xE003\xE000" },
    { L'\xE610', L"\x006F\xE003\xE023" },
    { L'\xE611', L"\x006F\xE028\xE003\xE023" },
    { L'\xE612', L"\x006F\xE028\xE003" },
    { L'\xE613', L"\x006F\xE003\xE039" },
    { L'\xE614', L"\x006F\xE037\xE003" },
    { L'\xE615', L"\x006F\xE0B5\xE003" },
    { L'\xE616', L"\x006F\xE004\xE006" },
    { L'\xE617', L"\x006F\xE004\xE023" },
    { L'\xE618', L"\x006F\xE004\xE02D" },
    { L'\xE619', L"\x006F\xE004\xE039" },
    { L'\xE61A', L"\x006F\xE037\xE004" },
    { L'\xE61B', L"\x006F\xE006\xE023" },
    { L'\xE61C', L"\x006F\xE028\xE006" },
    { L'\xE61D', L"\x006F\xE007\xE000" },
    { L'\xE61E', L"\x006F\xE007\xE000\xE02F" },
    { L'\xE61F', L"\x006F\xE007\xE001" },
    { L'\xE620', L"\x006F\xE007\xE00F" },
    { L'\xE621', L"\x006F\xE007\xE011" },
    { L'\xE622', L"\x006F\xE007\xE023" },
    { L'\xE623', L"\x006F\xE028\xE007" },
    { L'\xE624', L"\x006F\xE007\xE02F" },
    { L'\xE625', L"\x006F\xE007\xE039" },
    { L'\xE626', L"\x006F\xE037\xE007" },
    { L'\xE627', L"\x006F\xE0B5\xE007" },
    { L'\xE628', L"\x006F\xE008\xE000" },
    { L'\xE629', L"\x006F\xE008\xE001" },
    { L'\xE62A', L"\x006F\xE008\xE002" },
    { L'\xE62B', L"\x006F\xE008\xE00F" },
    { L'\xE62C', L"\x006F\xE008\xE00F\xE023" },
    { L'\xE62D', L"\x006F\xE008\xE011" },
    { L'\xE62E', L"\x006F\xE008\xE023" },
    { L'\xE62F', L"\x006F\xE008\xE02F" },
    { L'\xE630', L"\x006F\xE028\xE00B" },
    { L'\xE631', L"\x006F\xE00C\xE004\xE001" },
    { L'\xE632', L"\x006F\xE00D" },
    { L'\xE633', L"\x006F\xE00D\xE023" },
    { L'\xE634', L"\x006F\xE028\xE00D" },
    { L'\xE635', L"\x006F\xE00F\xE023" },
    { L'\xE636', L"\x006F\xE00F\xE024" },
    { L'\xE637', L"\x006F\xE00F\xE025" },
    { L'\xE638', L"\x006F\xE028\xE00F" },
    { L'\xE639', L"\x006F\xE00F\xE02D" },
    { L'\xE63A', L"\x006F\xE00F\xE02F" },
    { L'\xE63B', L"\x006F\xE00F\xE039" },
    { L'\xE63C', L"\x006F\xE037\xE00F" },
    { L'\xE63D', L"\x006F\xE011\xE003\xE023" },
    { L'\xE63E', L"\x006F\xE011\xE023" },
    { L'\xE63F', L"\x006F\xE011\xE024" },
    { L'\xE640', L"\x006F\xE011\xE025" },
    { L'\xE641', L"\x006F\xE028\xE011" },
    { L'\xE642', L"\x006F\xE011\xE02D" },
    { L'\xE643', L"\x006F\xE011\xE02F" },
    { L'\xE644', L"\x006F\xE011\xE039" },
    { L'\xE645', L"\x006F\xE037\xE011" },
    { L'\xE646', L"\x006F\xE064" },
    { L'\xE647', L"\x006F\xE070" },
    { L'\xE648', L"\x006F\xE073" },
    { L'\xE649', L"\x006F\xE077" },
    { L'\xE64A', L"\x006F\xE07A" },
    { L'\xE64B', L"\x006F\xE07D" },
    { L'\xE64C', L"\x006F\xE07E" },
    { L'\xE64D', L"\x006F\xE028\xE023" },
    { L'\xE64E', L"\x006F\xE037\xE023" },
    { L'\xE64F', L"\x006F\xE024" },
    { L'\xE650', L"\x006F\xE025" },
    { L'\xE651', L"\x006F\xE02C" },
    { L'\xE652', L"\x006F\xE02D" },
    { L'\xE653', L"\x006F\xE02F" },
    { L'\xE654', L"\x006F\xE031" },
    { L'\xE655', L"\x006F\xE039" },
    { L'\xE656', L"\x0254\xE000" },
    { L'\xE657', L"\x0254\xE001" },
    { L'\xE658', L"\x0254\xE028\xE001" },
    { L'\xE659', L"\x0254\xE003" },
    { L'\xE65A', L"\x0254\xE003\xE000" },
    { L'\xE65B', L"\x0254\xE003\xE001" },
    { L'\xE65C', L"\x0254\xE00F" },
    { L'\xE65D', L"\x0254\xE011" },
    { L'\xE65E', L"\x0254\xE028" },
    { L'\xE65F', L"\x0277\xE000" },
    { L'\xE660', L"\x0277\xE001" },
    { L'\xE661', L"\x0277\xE002" },
    { L'\xE662', L"\x0277\xE004" },
    { L'\xE663', L"\x0277\xE004\xE000" },
    { L'\xE664', L"\x0277\xE004\xE001" },
    { L'\xE665', L"\x0277\xE006" },
    { L'\xE666', L"\xE131\xE000" },
    { L'\xE667', L"\xE131\xE001" },
    { L'\xE668', L"\xE131\xE002" },
    { L'\xE669', L"\xE131\xE004" },
    { L'\xE66A', L"\xE131\xE004\xE000" },
    { L'\xE66B', L"\xE131\xE004\xE001" },
    { L'\xE66C', L"\x006F\xE0C4\x0065\xE000" },
    { L'\xE66D', L"\x006F\xE0C4\x0065\xE001" },
    { L'\xE66E', L"\x006F\xE0C4\x0065\xE002" },
    { L'\xE66F', L"\x006F\xE0C4\x0065\xE004" },
    { L'\xE670', L"\x006F\xE0C4\x0065\xE004\xE001" },
    { L'\xE671', L"\x006F\xE0C4\x0065\xE006" },
    { L'\xE672', L"\x006F\xE0C4\x006F" },
    { L'\xE673', L"\x006F\xE0C4\x006F\xE001" },
    { L'\xE674', L"\x006F\xE00C\xE004\xE000" },
    { L'\xE675', L"\x006F\xE01E" },
    { L'\xE676', L"\x006F\xE02E" },
    { L'\xE677', L"\x006F\xE000\xE01E" },
    { L'\xE678', L"\xE131\xE006" },
    { L'\xE679', L"\x0254\xE004" },
    { L'\xE67A', L"\xE13B\xE004" },
    { L'\xE67B', L"\x006F\xE000\xE01D" },
    { L'\xE67C', L"\x006F\xE001\xE01D" },
    { L'\xE67D', L"\x006F\xE001\xE01E" },
    { L'\xE67E', L"\x006F\xE01D" },
    { L'\xE67F', L"\x006F\xE003\xE000\xE01E" },
    { L'\xE680', L"\x006F\xE003\xE001\xE01E" },
    { L'\xE681', L"\x006F\xE003\xE01E" },
    { L'\xE682', L"\x006F\xE006\xE00D" },
    { L'\xE683', L"\x0254\xE000\xE030" },
    { L'\xE684', L"\x0254\xE001\xE030" },
    { L'\xE685', L"\x0254\xE030" },
    { L'\xE686', L"\x006F\xE000\xE030" },
    { L'\xE687', L"\x006F\xE001\xE030" },
    { L'\xE688', L"\x006F\xE030" },
    { L'\xE689', L"\x0254\xE025" },
    { L'\xE68A', L"\x006F\xE003\xE000\xE030" },
    { L'\xE68B', L"\x006F\xE003\xE001\xE030" },
    { L'\xE68C', L"\x006F\xE003\xE030" },
    { L'\xE68D', L"\x0254\xE003\xE000\xE030" },
    { L'\xE68E', L"\x0254\xE003\xE001\xE030" },
    { L'\xE68F', L"\x0254\xE003\xE030" },
    { L'\xE690', L"\x006F\xE066" },
    { L'\xE691', L"\x006F\xE06E" },
    { L'\xE692', L"\x006F\xE0C4\x0065\xE028" },
    { L'\xE693', L"\x0254\xE035" },
    { L'\xE694', L"\x006F\xE028\xE004\xE001" },
    { L'\xE695', L"\x006F\xE004\xE088" },
    { L'\xE696', L"\x006F\xE004\xE089" },
    { L'\xE697', L"\x006F\xE006\xE001" },
    { L'\xE698', L"\x006F\xE007\xE004\xE001" },
    { L'\xE699', L"\x006F\xE087" },
    { L'\xE69A', L"\x006F\xE088" },
    { L'\xE69B', L"\xE131\xE028\xE001" },
    { L'\xE69C', L"\xE131\xE004\xE088" },
    { L'\xE69D', L"\xE131\xE008" },
    { L'\xE69E', L"\xE131\xE088" },
    { L'\xE69F', L"\xE131\xE028" },
    { L'\xE6A0', L"\x006F\xE0C4\x0065\xE028\xE000" },
    { L'\xE6A1', L"\x006F\xE0C4\x0065\xE028\xE001" },
    { L'\xE6A2', L"\x006F\xE0C4\x0065\xE004\xE000" },
    { L'\xE6A3', L"\x006F\xE0C4\x0065\xE028\xE004\xE001" },
    { L'\xE6A4', L"\x006F\xE0C4\x0065\xE088" },
    { L'\xE6A5', L"\x006F\xE0B8" },
    { L'\xE6A6', L"\x006F\xE0C4\x0065\xE008\xE006" },
    { L'\xE6A7', L"\x006F\xE037\xE004\xE000" },
    { L'\xE6A8', L"\x006F\xE004\xE000\xE02D" },
    { L'\xE6A9', L"\x006F\xE004\xE001\xE02D" },
    { L'\xE6AA', L"\xE13B\xE055" },
    { L'\xE6AB', L"\x006F\xE001\xE029" },
    { L'\xE6AC', L"\x006F\xE02F\xE023" },
    { L'\xE6AD', L"\x006F\xE006\xE039" },
    { L'\xE6AE', L"\x006F\xE028\xE001\xE023" },
    { L'\xE6AF', L"\x006F\xE028\xE001\xE039" },
    { L'\xE6B0', L"\x006F\xE028\xE003\xE039" },
    { L'\xE6B1', L"\x006F\xE0C4\x0065\xE007\xE006" },
    { L'\xE6B2', L"\x006F\xE0C4\x0065\xE003" },
    { L'\xE6B3', L"\x0254\xE028\xE000" },
    { L'\xE6B4', L"\x0254\xE006" },
    { L'\xE6B5', L"\x006F\xE028\xE039" },
    { L'\xE6B6', L"\x006F\xE028\xE004\xE039" },
    { L'\xE6B7', L"\x0254\xE02F" },
    { L'\xE6B8', L"\x006F\xE028\xE000\xE039" },
    { L'\xE6B9', L"\x006F\xE028\xE000\xE023" },
    { L'\xE6BA', L"\x006F\xE028\xE004\xE000" },
    { L'\xE6BB', L"\x006F\xE0C4\x0065\xE006\xE000" },
    { L'\xE6BC', L"\x006F\xE004\xE003" },
    { L'\xE6BD', L"\xE131\xE028\xE004\xE001" },
    { L'\xE6BE', L"\xE131\xE006\xE000" },
    { L'\xE6BF', L"\x006F\xE004\xE00D" },
    { L'\xE6C0', L"\x006F\xE008\xE011\xE023" },
    { L'\xE6C1', L"\x006F\xE029" },
    { L'\xE6C2', L"\x006F\xE028\xE002" },
    { L'\xE6C3', L"\x006F\xE028\xE004\xE011" },
    { L'\xE6C4', L"\x006F\xE004\xE007" },
    { L'\xE6C5', L"\x006F\xE008\xE031" },
    { L'\xE6C6', L"\x006F\xE008\xE024" },
    { L'\xE6C7', L"\x006F\xE008\xE003" },
    { L'\xE6C8', L"\x006F\xE00F\xE011" },
    { L'\xE6C9', L"\x006F\xE00F\xE011\xE024" },
    { L'\xE6CA', L"\x006F\xE0B5" },
    { L'\xE6CB', L"\xE131\xE006\xE001" },
    { L'\xE6CC', L"\x006F\xE004\xE00C" },
    { L'\xE6CD', L"\x006F\xE028\xE00C" },
    { L'\xE6CE', L"\x006F\xE00C\xE023" },
    { L'\xE6CF', L"\x006F\xE028\xE007\xE004" },
    { L'\xE6D0', L"\x006F\xE028\xE004\xE003" },
    { L'\xE6D1', L"\x006F\xE004\xE001\xE023" },
    { L'\xE6D2', L"\x006F\xE008\xE00C" },
    { L'\xE6D3', L"\x006F\xE008\xE004\xE001" },
    { L'\xE6D4', L"\x006F\xE028\xE008" },
    { L'\xE6D5', L"\x006F\xE028\xE008\xE004" },
    { L'\xE6D6', L"\x006F\xE028\xE008\xE001" },
    { L'\xE6D7', L"\x006F\xE028\xE008\xE003" },
    { L'\xE6D8', L"\x006F\xE008\xE001\xE023" },
    { L'\xE6D9', L"\x006F\xE013" },
    { L'\xE6DA', L"\x006F\xE00A\xE011" },
    { L'\xE6DB', L"\x006F\xE004\xE002" },
    { L'\xE6DC', L"\x006F\xE004\xE011" },
    { L'\xE6DD', L"\x006F\xE004\xE000\xE039" },
    { L'\xE6DE', L"\x006F\xE004\xE001\xE039" },
    { L'\xE6DF', L"\x006F\xE004\xE003\xE039" },
    { L'\xE6E0', L"\x004F\xE004\xE02C" },
    { L'\xE6E1', L"\x004F\xE008\xE001" },
    { L'\xE6E2', L"\x004F\xE011\xE023" },
    { L'\xE6E3', L"\x004F\xE064" },
    { L'\xE6E4', L"\x004F\xE025" },
    { L'\xE6E5', L"\x004F\xE02C" },
    { L'\xE6E6', L"\x004F\xE0B5" },
    { L'\xE6E7', L"\x004F\xE000\xE023" },
    { L'\xE6E8', L"\x004F\xE06E" },
    { L'\xE6E9', L"\xE145\xE001" },
    { L'\xE6EA', L"\x004F\xE001\xE024" },
    { L'\xE6EB', L"\x004F\xE024" },
    { L'\xE6EC', L"\x004F\xE001\xE023" },
    { L'\xE6ED', L"\x004F\xE008\xE024" },
    { L'\xE6EE', L"\x004F\xE065" },
    { L'\xE6EF', L"\x004F\xE067" },
    { L'\xE6F0', L"\x004F\xE008\xE002" },
    { L'\xE6F1', L"\x004F\xE008\xE00C" },
    { L'\xE6F2', L"\x004F\xE00D" },
    { L'\xE6F3', L"\x004F\xE02D" },
    { L'\xE6F4', L"\x004F\xE007\xE002" },
    { L'\xE6F5', L"\x004F\xE004\xE003" },
    { L'\xE6F6', L"\x004F\xE003\xE023" },
    { L'\xE6F7', L"\x004F\xE037\xE023" },
    { L'\xE6F8', L"\x004F\xE037\xE003" },
    { L'\xE6F9', L"\x004F\xE0C4\x0045\xE003" },
    { L'\xE6FA', L"\x004F\xE0C4\x0045\xE003\xE023" },
    { L'\xE6FB', L"\x004F\xE0C4\x0045\xE011" },
    { L'\xE6FC', L"\x004F\xE028\xE002" },
    { L'\xE6FD', L"\x004F\xE02F" },
    { L'\xE6FE', L"\x004F\xE003\xE039" },
    { L'\xE6FF', L"\x004F\xE000\xE039" },
    { L'\xE700', L"\x0075\xE000\xE024" },
    { L'\xE701', L"\x0075\xE028\xE000" },
    { L'\xE702', L"\x0075\xE000\xE02F" },
    { L'\xE703', L"\x0075\xE000\xE039" },
    { L'\xE704', L"\x0075\xE037\xE000" },
    { L'\xE705', L"\x0075\xE001\xE023" },
    { L'\xE706', L"\x0075\xE001\xE024" },
    { L'\xE707', L"\x0075\xE028\xE001" },
    { L'\xE708', L"\x0075\xE001\xE02F" },
    { L'\xE709', L"\x0075\xE001\xE039" },
    { L'\xE70A', L"\x0075\xE037\xE001" },
    { L'\xE70B', L"\x0075\xE002\xE023" },
    { L'\xE70C', L"\x0075\xE002\xE02F" },
    { L'\xE70D', L"\x0075\xE003\xE000" },
    { L'\xE70E', L"\x0075\xE028\xE003" },
    { L'\xE70F', L"\x0075\xE004\xE000" },
    { L'\xE710', L"\x0075\xE004\xE001" },
    { L'\xE711', L"\x0075\xE004\xE003" },
    { L'\xE712', L"\x0075\xE004\xE006" },
    { L'\xE713', L"\x0075\xE004\xE02F" },
    { L'\xE714', L"\x0075\xE007" },
    { L'\xE715', L"\x0075\xE007\xE001" },
    { L'\xE716', L"\x0075\xE007\xE003" },
    { L'\xE717', L"\x0075\xE007\xE004" },
    { L'\xE718', L"\x0075\xE007\xE00F" },
    { L'\xE719', L"\x0075\xE007\xE00F\xE025" },
    { L'\xE71A', L"\x0075\xE007\xE011" },
    { L'\xE71B', L"\x0075\xE007\xE025" },
    { L'\xE71C', L"\x0075\xE008\xE002" },
    { L'\xE71D', L"\x0075\xE008\xE00F" },
    { L'\xE71E', L"\x0075\xE008\xE011" },
    { L'\xE71F', L"\x0075\xE008\xE02F" },
    { L'\xE720', L"\x0075\xE00A\xE000" },
    { L'\xE721', L"\x0075\xE00A\xE001" },
    { L'\xE722', L"\x0075\xE00D" },
    { L'\xE723', L"\x0075\xE00F\xE024" },
    { L'\xE724', L"\x0075\xE037\xE00F" },
    { L'\xE725', L"\x0075\xE011\xE024" },
    { L'\xE726', L"\x0075\xE011\xE039" },
    { L'\xE727', L"\x0075\xE037\xE011" },
    { L'\xE728', L"\x0075\xE064" },
    { L'\xE729', L"\x0075\xE073" },
    { L'\xE72A', L"\x0075\xE077" },
    { L'\xE72B', L"\x0075\xE07A" },
    { L'\xE72C', L"\x0075\xE07C" },
    { L'\xE72D', L"\x0075\xE07D" },
    { L'\xE72E', L"\x0075\xE025" },
    { L'\xE72F', L"\x0075\xE02F" },
    { L'\xE730', L"\x0075\xE031" },
    { L'\xE731', L"\x0075\xE039" },
    { L'\xE732', L"\x0075\xE037" },
    { L'\xE733', L"\x1D1C\xE000" },
    { L'\xE734', L"\x0075\xE027\xE035" },
    { L'\xE735', L"\x0075\xE02C" },
    { L'\xE736', L"\x0075\xE000\xE01E" },
    { L'\xE737', L"\x0075\xE001\xE01E" },
    { L'\xE738', L"\x0075\xE01E" },
    { L'\xE739', L"\x0075\xE003\xE02F" },
    { L'\xE73A', L"\x0075\xE006\xE00D" },
    { L'\xE73B', L"\x0075\xE028\xE008" },
    { L'\xE73C', L"\x0075\xE000\xE030" },
    { L'\xE73D', L"\x0075\xE001\xE030" },
    { L'\xE73E', L"\x0075\xE02F\xE025" },
    { L'\xE73F', L"\x0075\xE02F\xE030" },
    { L'\xE740', L"\x0075\xE006\xE00F" },
    { L'\xE741', L"\x0075\xE00C\xE00F" },
    { L'\xE742', L"\x028A\xE030" },
    { L'\xE743', L"\x0075\xE003\xE000\xE030" },
    { L'\xE744', L"\x0075\xE003\xE001\xE030" },
    { L'\xE745', L"\x0075\xE003\xE030" },
    { L'\xE746', L"\x0075\xE030\xE02F" },
    { L'\xE747', L"\x0075\xE065" },
    { L'\xE748', L"\x0075\xE066" },
    { L'\xE749', L"\x0075\xE035\xE055" },
    { L'\xE74A', L"\x0075\xE028\xE004\xE001" },
    { L'\xE74B', L"\x0075\xE004\xE088" },
    { L'\xE74C', L"\x0075\xE00A\xE004\xE001" },
    { L'\xE74D', L"\x0075\xE088" },
    { L'\xE74E', L"\x0075\xE028\xE088" },
    { L'\xE74F', L"\x0075\xE011\xE023" },
    { L'\xE750', L"\x0075\xE000\xE025" },
    { L'\xE751', L"\x0075\xE027" },
    { L'\xE752', L"\x0075\xE004\xE00D" },
    { L'\xE753', L"\x0075\xE008\xE023" },
    { L'\xE754', L"\x0075\xE008\xE031" },
    { L'\xE755', L"\x0075\xE008\xE024" },
    { L'\xE756', L"\x0075\xE008\xE003" },
    { L'\xE757', L"\x0075\xE004\xE00C" },
    { L'\xE758', L"\x0075\xE002\xE001" },
    { L'\xE759', L"\x0075\xE008\xE004\xE001" },
    { L'\xE75A', L"\x0075\xE08C" },
    { L'\xE75B', L"\x0075\xE08E" },
    { L'\xE75C', L"\x0075\xE004\xE002" },
    { L'\xE75D', L"\x0075\xE004\xE025" },
    { L'\xE75E', L"\x0075\xE004\xE011" },
    { L'\xE75F', L"\x0075\xE067" },
    { L'\xE760', L"\x0075\xE06E" },
    { L'\xE761', L"\x0075\xE006\xE001" },
    { L'\xE762', L"\x0075\xE004\xE024" },
    { L'\xE763', L"\x0075\xE003\xE024" },
    { L'\xE764', L"\x0075\xE006\xE02F" },
    { L'\xE765', L"\x0075\xE001\xE025" },
    { L'\xE766', L"\x0075\xE004\xE087" },
    { L'\xE767', L"\x0075\xE087" },
    { L'\xE768', L"\x0075\xE00F\xE025" },
    { L'\xE769', L"\x0075\xE007\xE002" },
    { L'\xE76A', L"\x0075\xE094" },
    { L'\xE76B', L"\x0075\xE000\xE023" },
    { L'\xE76C', L"\x0075\xE003\xE023" },
    { L'\xE76D', L"\x0075\xE035\xE023" },
    { L'\xE76E', L"\x0075\xE007\xE000" },
    { L'\xE76F', L"\x0075\xE072" },
    { L'\xE770', L"\x0075\xE008\xE006" },
    { L'\xE771', L"\x0075\xE004\xE007" },
    { L'\xE772', L"\x0075\xE007\xE004\xE001" },
    { L'\xE773', L"\x0075\xE0AA" },
    { L'\xE774', L"\x0075\xE0AA\xE008" },
    { L'\xE775', L"\x0075\xE004\xE030" },
    { L'\xE777', L"\xE169\xE008" },
    { L'\xE778', L"\xE169\xE003" },
    { L'\xE779', L"\xE169\xE008\xE003" },
    { L'\xE77A', L"\x0075\xE0AA\xE003" },
    { L'\xE77B', L"\x0075\xE008\xE030" },
    { L'\xE77C', L"\x0075\xE004\xE039" },
    { L'\xE77D', L"\x0075\xE037\xE004" },
    { L'\xE77E', L"\x0075\xE008\xE004\xE024" },
    { L'\xE77F', L"\xE13F\xE02F" },
    { L'\xE780', L"\x0075\xE037\xE003" },
    { L'\xE781', L"\x0075\xE001\xE025\xE02F" },
    { L'\xE782', L"\x0075\xE070" },
    { L'\xE783', L"\x0075\xE008\xE00D" },
    { L'\xE784', L"\x0075\xE00D\xE039" },
    { L'\xE785', L"\x0075\xE003\xE039" },
    { L'\xE786', L"\x0075\xE004\xE00D\xE039" },
    { L'\xE787', L"\x0075\xE00F\xE039" },
    { L'\xE788', L"\x0075\xE006\xE039" },
    { L'\xE789', L"\x0075\xE008\xE004\xE00D" },
    { L'\xE78A', L"\x0075\xE011\xE02F" },
    { L'\xE78B', L"\x0075\xE004\xE00D\xE02F" },
    { L'\xE78C', L"\x0075\xE00D\xE02F" },
    { L'\xE78D', L"\x0075\xE00F\xE02F" },
    { L'\xE78E', L"\x0075\xE028\xE011" },
    { L'\xE78F', L"\x0075\xE028\xE004\xE00D" },
    { L'\xE790', L"\x0075\xE028\xE00D" },
    { L'\xE791', L"\x0075\xE028\xE00F" },
    { L'\xE792', L"\x0075\xE028\xE004" },
    { L'\xE793', L"\x0075\xE028\xE006" },
    { L'\xE794', L"\x0075\xE00A\xE00F" },
    { L'\xE795', L"\x0075\xE011\xE025" },
    { L'\xE796', L"\x0075\xE070\xE023" },
    { L'\xE797', L"\x0075\xE0A8" },
    { L'\xE798', L"\x0075\xE017" },
    { L'\xE799', L"\x0075\xE004\xE006\xE02F" },
    { L'\xE79A', L"\x0075\xE035\xE024" },
    { L'\xE79B', L"\x028A\xE02F" },
    { L'\xE79C', L"\x0075\xE007\xE00D" },
    { L'\xE79D', L"\x0075\xE013" },
    { L'\xE7E0', L"\x0055\xE000\xE039" },
    { L'\xE7E1', L"\x0055\xE001\xE039" },
    { L'\xE7E2', L"\x0055\xE028\xE003" },
    { L'\xE7E3', L"\x0055\xE004\xE003" },
    { L'\xE7E4', L"\x0055\xE064" },
    { L'\xE7E5', L"\x0055\xE02F" },
    { L'\xE7E6', L"\x0055\xE004\xE001" },
    { L'\xE7E7', L"\x0055\xE001\xE024" },
    { L'\xE7E8', L"\x0055\xE008\xE024" },
    { L'\xE7E9', L"\x0055\xE008\xE002" },
    { L'\xE7EA', L"\x0055\xE065" },
    { L'\xE7EB', L"\x0055\xE066" },
    { L'\xE7EC', L"\x0055\xE067" },
    { L'\xE7ED', L"\x0055\xE06E" },
    { L'\xE7EE', L"\x0055\xE00D" },
    { L'\xE7EF', L"\x0055\xE007\xE002" },
    { L'\xE7F0', L"\x0055\xE001\xE023" },
    { L'\xE7F1', L"\x0055\xE004\xE000" },
    { L'\xE7F2', L"\x0055\xE037" },
    { L'\xE7F3', L"\x0055\xE025" },
    { L'\xE7F4', L"\x0055\xE007" },
    { L'\xE7F5', L"\x0055\xE011\xE023" },
    { L'\xE7F6', L"\x0055\xE008\xE003" },
    { L'\xE7F7', L"\x0055\xE008\xE011" },
    { L'\xE7F8', L"\x0055\xE008\xE00F" },
    { L'\xE800', L"\x0079\xE004\xE006" },
    { L'\xE801', L"\x0079\xE006" },
    { L'\xE802', L"\x0079\xE00B" },
    { L'\xE803', L"\x0079\xE00D" },
    { L'\xE804', L"\x0079\xE00F" },
    { L'\xE805', L"\x0079\xE011" },
    { L'\xE806', L"\x0079\xE07A" },
    { L'\xE807', L"\x0079\xE028" },
    { L'\xE808', L"\x0079\xE02F" },
    { L'\xE809', L"\x0079\xE031" },
    { L'\xE80A', L"\x0079\xE004\xE00D" },
    { L'\xE80B', L"\x0079\xE064" },
    { L'\xE80C', L"\x0079\xE00F\xE025" },
    { L'\xE80D', L"\x0079\xE011\xE025" },
    { L'\xE80E', L"\x0079\xE004\xE000" },
    { L'\xE80F', L"\x0079\xE004\xE001" },
    { L'\xE810', L"\x0079\xE004\xE002" },
    { L'\xE811', L"\x0079\xE004\xE003" },
    { L'\xE812', L"\x0079\xE004\xE011" },
    { L'\xE813', L"\x0079\xE006\xE00D" },
    { L'\xE814', L"\x0079\xE025" },
    { L'\xE815', L"\x0079\xE013" },
    { L'\xE816', L"\x0079\xE065" },
    { L'\xE81D', L"\x0059\xE00D" },
    { L'\xE81E', L"\x0059\xE00F" },
    { L'\xE81F', L"\x0059\xE064" },
    { L'\xE840', L"\x044A\xE000" },
    { L'\xE841', L"\x044A\xE001" },
    { L'\xE842', L"\x044A\xE003" },
    { L'\xE843', L"\x044A\xE004" },
    { L'\xE844', L"\x044A\xE00F" },
    { L'\xE845', L"\x044A\xE011" },
    { L'\xE846', L"\x044A\xE025" },
    { L'\xE847', L"\x044A\xE02F" },
    { L'\xE848', L"\x044A\xE002" },
    { L'\xE849', L"\x044A\xE035" },
    { L'\xE84A', L"\x044A\xE00B" },
    { L'\xE84B', L"\x044A\xE00D" },
    { L'\xE84C', L"\x044A\xE088" },
    { L'\xE84D', L"\x044A\xE02C" },
    { L'\xE84E', L"\x044A\xE004\xE025" },
    { L'\xE84F', L"\x044A\xE006\xE025" },
    { L'\xE850', L"\x044A\xE02D" },
    { L'\xE851', L"\x044A\xE006" },
    { L'\xE852', L"\x044A\xE004\xE000" },
    { L'\xE853', L"\x044A\xE004\xE001" },
    { L'\xE854', L"\x044A\xE004\xE002" },
    { L'\xE855', L"\x044A\xE004\xE003" },
    { L'\xE856', L"\x044A\xE004\xE00D" },
    { L'\xE857', L"\x044A\xE004\xE011" },
    { L'\xE858', L"\x044A\xE006\xE00D" },
    { L'\xE859', L"\x044A\xE00D\xE0A8" },
    { L'\xE860', L"\x042A\xE000" },
    { L'\xE861', L"\x042A\xE001" },
    { L'\xE862', L"\x042A\xE025" },
    { L'\xE863', L"\x042A\xE02F" },
    { L'\xE864', L"\x042A\xE004" },
    { L'\xE865', L"\x042A\xE00F" },
    { L'\xE870', L"\x044B\xE000" },
    { L'\xE871', L"\x044B\xE001" },
    { L'\xE872', L"\x044B\xE025" },
    { L'\xE873', L"\x044B\xE023" },
    { L'\xE874', L"\x044B\xE00D" },
    { L'\xE875', L"\x044B\xE004" },
    { L'\xE878', L"\x042B\xE000" },
    { L'\xE879', L"\x042B\xE001" },
    { L'\xE87A', L"\x042B\xE004" },
    { L'\xE87B', L"\x042B\xE00D" },
    { L'\xE880', L"\x044C\xE000" },
    { L'\xE881', L"\x044C\xE001" },
    { L'\xE882', L"\x044C\xE003" },
    { L'\xE883', L"\x044C\xE004" },
    { L'\xE884', L"\x044C\xE00B" },
    { L'\xE885', L"\x044C\xE00F" },
    { L'\xE886', L"\x044C\xE011" },
    { L'\xE887', L"\x044C\xE025" },
    { L'\xE888', L"\x044C\xE02F" },
    { L'\xE889', L"\x044C\xE00D" },
    { L'\xE88A', L"\x044C\xE028\xE000" },
    { L'\xE88B', L"\x044C\xE028" },
    { L'\xE88C', L"\x044C\xE006" },
    { L'\xE88D', L"\x044C\xE02C" },
    { L'\xE88E', L"\x044C\xE004\xE000" },
    { L'\xE88F', L"\x044C\xE004\xE001" },
    { L'\xE890', L"\x044C\xE004\xE002" },
    { L'\xE891', L"\x044C\xE004\xE003" },
    { L'\xE892', L"\x044C\xE004\xE00D" },
    { L'\xE893', L"\x044C\xE004\xE011" },
    { L'\xE894', L"\x044C\xE006\xE00D" },
    { L'\xE895', L"\x044C\xE002" },
    { L'\xE896', L"\x044C\xE00D\xE0A8" },
    { L'\xE897', L"\x044C\xE004\xE025" },
    { L'\xE8A0', L"\x042C\xE025" },
    { L'\xE8A1', L"\x042C\xE02F" },
    { L'\xE8A2', L"\x042C\xE00F" },
    { L'\xE8B0', L"\x044E\xE000" },
    { L'\xE8B1', L"\x044E\xE001" },
    { L'\xE8B2', L"\x044E\xE00D" },
    { L'\xE8B3', L"\x044E\xE004" },
    { L'\xE8B8', L"\x042E\xE000" },
    { L'\xE8B9', L"\x042E\xE001" },
    { L'\xE8BA', L"\x042E\xE004" },
    { L'\xE8BB', L"\x042E\xE00D" },
    { L'\xE8C0', L"\x044F\xE000" },
    { L'\xE8C1', L"\x044F\xE001" },
    { L'\xE8C2', L"\x044F\xE00D" },
    { L'\xE8C3', L"\x044F\xE004" },
    { L'\xE8C8', L"\x042F\xE000" },
    { L'\xE8C9', L"\x042F\xE001" },
    { L'\xE8CA', L"\x042F\xE004" },
    { L'\xE8CB', L"\x042F\xE00D" },
    { L'\xE8D0', L"\x0463\xE000" },
    { L'\xE8D1', L"\x0463\xE001" },
    { L'\xE8D2', L"\x0463\xE004" },
    { L'\xE8D3', L"\x0463\xE00D" },
    { L'\xE8D8', L"\x0462\xE000" },
    { L'\xE8D9', L"\x0462\xE001" },
    { L'\xE8DA', L"\x0462\xE004" },
    { L'\xE8E0', L"\x046B\xE001" },
    { L'\xE900', L"\x0062\xE001" },
    { L'\xE901', L"\x0062\xE004" },
    { L'\xE902', L"\x0062\xE026" },
    { L'\xE903', L"\x0062\xE02C" },
    { L'\xE904', L"\x0062\xE035\xE02C" },
    { L'\xE905', L"\x0062\xE02D" },
    { L'\xE906', L"\x0062\xE0B2" },
    { L'\xE907', L"\x0062\xE025" },
    { L'\xE908', L"\x0062\xE027" },
    { L'\xE909', L"\x0062\xE02F" },
    { L'\xE90A', L"\x0062\xE030" },
    { L'\xE90B', L"\x0062\xE0B9" },
    { L'\xE90C', L"\x0062\xE015" },
    { L'\xE90C', L"\x0062\xE0C4\x2019" },
    { L'\xE90D', L"\x0062\xE00C" },
    { L'\xE911', L"\x0042\xE0C2" },
    { L'\xE912', L"\x0042\xE02C" },
    { L'\xE920', L"\x0063\xE001\xE004" },
    { L'\xE921', L"\x0063\xE001\xE031" },
    { L'\xE922', L"\x0063\xE004" },
    { L'\xE923', L"\x0063\xE00C\xE001" },
    { L'\xE924', L"\x0063\xE00C\xE004" },
    { L'\xE925', L"\x0063\xE00C\xE00D" },
    { L'\xE926', L"\x0063\xE00C\xE023" },
    { L'\xE927', L"\x0063\xE00C\xE025" },
    { L'\xE928', L"\x0063\xE027\xE00C" },
    { L'\xE929', L"\x0063\xE00C\xE031" },
    { L'\xE92A', L"\x0063\xE076" },
    { L'\xE92B', L"\x0063\xE023" },
    { L'\xE92C', L"\x0063\xE028" },
    { L'\xE92D', L"\x0063\xE031" },
    { L'\xE92E', L"\xE132\xE001" },
    { L'\xE92F', L"\xE132\xE00C" },
    { L'\xE930', L"\xE132\xE00C\xE001" },
    { L'\xE931', L"\x0063\xE001\xE023" },
    { L'\xE932', L"\x0063\xE003" },
    { L'\xE933', L"\x0063\xE00C\xE011" },
    { L'\xE934', L"\x0063\xE011" },
    { L'\xE935', L"\x0063\xE00B" },
    { L'\xE936', L"\x0063\xE00B\xE023" },
    { L'\xE937', L"\x0063\xE00C\xE00B" },
    { L'\xE938', L"\x0063\xE085" },
    { L'\xE939', L"\x0063\xE001\xE0C0" },
    { L'\xE93A', L"\x0063\xE00C\xE0C0" },
    { L'\xE93B', L"\x0063\xE07A" },
    { L'\xE93C', L"\x0063\xE015" },
    { L'\xE93C', L"\x0063\xE0C4\x2019" },
    { L'\xE93D', L"\x0063\xE00C\xE015" },
    { L'\xE93D', L"\x0063\xE00C\xE0C4\x2019" },
    { L'\xE93E', L"\x0063\xE000" },
    { L'\xE93F', L"\x0063\xE029" },
    { L'\xE940', L"\x0043\xE003" },
    { L'\xE941', L"\x0043\xE00C\xE023" },
    { L'\xE942', L"\x0043\xE028" },
    { L'\xE943', L"\x0043\xE029" },
    { L'\xE944', L"\x0043\xE00B" },
    { L'\xE945', L"\x0043\xE001\xE0C0" },
    { L'\xE946', L"\x0043\xE00C\xE0C0" },
    { L'\xE947', L"\x0043\xE025" },
    { L'\xE948', L"\x0043\xE02C" },
    { L'\xE949', L"\x0043\xE023" },
    { L'\xE94A', L"\x0043\xE00C\xE00D" },
    { L'\xE94B', L"\x0043\xE004" },
    { L'\xE94C', L"\x0043\xE02F" },
    { L'\xE94D', L"\x0043\xE00C\xE001" },
    { L'\xE950', L"\x0064\xE001" },
    { L'\xE951', L"\x0064\xE004" },
    { L'\xE952', L"\x0064\xE00C" },
    { L'\xE953', L"\x0064\xE025" },
    { L'\xE954', L"\x0064\xE02C" },
    { L'\xE955', L"\x0064\xE035\xE02C" },
    { L'\xE956', L"\x0064\xE035\xE02D" },
    { L'\xE957', L"\x0064\xE028" },
    { L'\xE958', L"\x0064\xE0B2" },
    { L'\xE959', L"\x0064\xE003" },
    { L'\xE95A', L"\x0064\xE011" },
    { L'\xE95B', L"\x0064\xE02F" },
    { L'\xE95C', L"\x0064\xE030" },
    { L'\xE95D', L"\x0064\xE0C4\x007A\xE025" },
    { L'\xE95E', L"\x0064\xE0C4\x007A\xE030" },
    { L'\xE95F', L"\x0064\xE0C4\x0292\xE00A" },
    { L'\xE960', L"\x0064\xE0C4\x0292\xE025" },
    { L'\xE961', L"\x0064\xE0C4\x0292\xE030" },
    { L'\xE962', L"\x0064\xE0A3" },
    { L'\xE963', L"\x0064\xE035\xE0C0" },
    { L'\xE964', L"\x0064\xE024" },
    { L'\xE965', L"\x0064\xE035\xE025" },
    { L'\xE966', L"\x0064\xE02E" },
    { L'\xE967', L"\x0064\xE039" },
    { L'\xE968', L"\x0064\xE035\xE026" },
    { L'\xE970', L"\x0394\xE029" },
    { L'\xE971', L"\x0044\xE035\xE0C0" },
    { L'\xE972', L"\x0044\xE02C" },
    { L'\xE973', L"\x0044\xE035\xE025" },
    { L'\xE980', L"\x0066\xE001" },
    { L'\xE981', L"\x0066\xE004" },
    { L'\xE982', L"\x0066\xE031" },
    { L'\xE983', L"\x0066\xE02E" },
    { L'\xE984', L"\x0066\xE02C" },
    { L'\xE985', L"\x0066\xE030" },
    { L'\xE986', L"\x0066\xE015" },
    { L'\xE986', L"\x0066\xE0C4\x2019" },
    { L'\xE987', L"\x03C6\xE015" },
    { L'\xE987', L"\x03C6\xE0C4\x2019" },
    { L'\xE988', L"\x0066\xE029" },
    { L'\xE989', L"\x0066\xE023" },
    { L'\xE98A', L"\x0066\xE025" },
    { L'\xE98B', L"\x0066\xE028" },
    { L'\xE98C', L"\x0066\xE007\xE023" },
    { L'\xE990', L"\x0046\xE023" },
    { L'\xE9A0', L"\x0067\xE003" },
    { L'\xE9A1', L"\x0067\xE02C" },
    { L'\xE9A2', L"\x0067\xE02D" },
    { L'\xE9A3', L"\x0067\xE031" },
    { L'\xE9A4', L"\x03B3\xE001" },
    { L'\xE9A5', L"\x03B3\xE082" },
    { L'\xE9A6', L"\x0067\xE011" },
    { L'\xE9A7', L"\x0067\xE02F" },
    { L'\xE9A8', L"\x0067\xE023" },
    { L'\xE9A9', L"\x0067\xE082\xE02C" },
    { L'\xE9AA', L"\x0067\xE00A" },
    { L'\xE9AB', L"\x0067\xE030" },
    { L'\xE9AC', L"\x0261\xE00A" },
    { L'\xE9AD', L"\x0261\xE025" },
    { L'\xE9AE', L"\x0261\xE02C" },
    { L'\xE9AF', L"\x0261\xE030" },
    { L'\xE9B0', L"\x0047\xE029" },
    { L'\xE9B1', L"\x0047\xE02C" },
    { L'\xE9B2', L"\x0047\xE000" },
    { L'\xE9B3', L"\x0047\xE023" },
    { L'\xE9C0', L"\x0068\xE000" },
    { L'\xE9C1', L"\x0068\xE001" },
    { L'\xE9C2', L"\x0068\xE004" },
    { L'\xE9C3', L"\x0068\xE024" },
    { L'\xE9C4', L"\x0068\xE025" },
    { L'\xE9C5', L"\x0068\xE02C" },
    { L'\xE9C6', L"\x0068\xE0B2" },
    { L'\xE9C7', L"\x0068\xE0B7" },
    { L'\xE9C8', L"\x03C7\xE001" },
    { L'\xE9C9', L"\x03C7\xE00C" },
    { L'\xE9CA', L"\x0068\xE006" },
    { L'\xE9CB', L"\x0068\xE015" },
    { L'\xE9CB', L"\x0068\xE0C4\x2019" },
    { L'\xE9CC', L"\x03C7\xE015" },
    { L'\xE9CC', L"\x03C7\xE0C4\x2019" },
    { L'\xE9CD', L"\x03C7\xE004" },
    { L'\xE9CE', L"\x03C7\xE011" },
    { L'\xE9CF', L"\x0068\xE00F" },
    { L'\xE9D0', L"\x0048\xE024" },
    { L'\xE9D1', L"\x0048\xE025" },
    { L'\xE9D2', L"\x0048\xE031" },
    { L'\xE9E0', L"\x006A\xE001" },
    { L'\xE9E1', L"\x006A\xE003" },
    { L'\xE9E2', L"\x006A\xE004" },
    { L'\xE9E3', L"\x006A\xE013" },
    { L'\xE9E4', L"\x006A\xE028" },
    { L'\xE9E5', L"\x006A\xE031" },
    { L'\xE9E6', L"\x006A\xE039" },
    { L'\xE9E7', L"\x006A\xE025" },
    { L'\xE9E8', L"\x006A\xE030" },
    { L'\xE9E9', L"\x006A\xE003\xE030" },
    { L'\xE9EA', L"\x006A\xE034" },
    { L'\xE9EB', L"\x006A\xE011" },
    { L'\xE9EC', L"\x006A\xE023" },
    { L'\xE9F0', L"\x004A\xE003" },
    { L'\xE9F1', L"\x004A\xE007" },
    { L'\xE9F2', L"\x004A\xE00C" },
    { L'\xE9F3', L"\x004A\xE023" },
    { L'\xEA00', L"\x006B\xE004" },
    { L'\xEA01', L"\x006B\xE0B2" },
    { L'\xEA02', L"\x006B\xE011" },
    { L'\xEA03', L"\x006B\xE006" },
    { L'\xEA04', L"\x006B\xE027" },
    { L'\xEA05', L"\x006B\xE029" },
    { L'\xEA06', L"\x006B\xE02C" },
    { L'\xEA07', L"\x006B\xE02E" },
    { L'\xEA08', L"\x006B\xE030" },
    { L'\xEA09', L"\x006B\xE054" },
    { L'\xEA0A', L"\x006B\xE02D" },
    { L'\xEA0B', L"\x006B\xE000" },
    { L'\xEA0C', L"\x006B\xE025" },
    { L'\xEA0D', L"\x006B\xE007" },
    { L'\xEA0E', L"\x006B\xE003" },
    { L'\xEA0F', L"\x006B\xE028" },
    { L'\xEA10', L"\x004B\xE027" },
    { L'\xEA11', L"\x004B\xE0C2" },
    { L'\xEA12', L"\x004B\xE082" },
    { L'\xEA13', L"\x004B\xE035" },
    { L'\xEA20', L"\x006C\xE000\xE025" },
    { L'\xEA21', L"\x006C\xE001\xE025" },
    { L'\xEA22', L"\x006C\xE037\xE001\xE025" },
    { L'\xEA23', L"\x006C\xE002" },
    { L'\xEA24', L"\x006C\xE002\xE025" },
    { L'\xEA25', L"\x006C\xE003" },
    { L'\xEA26', L"\x006C\xE027\xE003" },
    { L'\xEA27', L"\x006C\xE004" },
    { L'\xEA28', L"\x006C\xE004\xE001\xE025" },
    { L'\xEA29', L"\x006C\xE004\xE025" },
    { L'\xEA2A', L"\x006C\xE037\xE004\xE025" },
    { L'\xEA2B', L"\x006C\xE006\xE025" },
    { L'\xEA2C', L"\x006C\xE037\xE006\xE025" },
    { L'\xEA2D', L"\x006C\xE00B" },
    { L'\xEA2E', L"\x006C\xE00F\xE025" },
    { L'\xEA2F', L"\x006C\xE037\xE011\xE025" },
    { L'\xEA30', L"\x006C\xE01C" },
    { L'\xEA31', L"\x006C\xE025" },
    { L'\xEA32', L"\x006C\xE037\xE025" },
    { L'\xEA33', L"\x006C\xE02F" },
    { L'\xEA34', L"\x006C\xE039" },
    { L'\xEA35', L"\x006C\xE0A0" },
    { L'\xEA36', L"\x006C\xE0A0\xE025" },
    { L'\xEA37', L"\x006C\xE0B3" },
    { L'\xEA38', L"\x006C\xE001\xE029" },
    { L'\xEA39', L"\x006C\xE029" },
    { L'\xEA3A', L"\x029F\xE029" },
    { L'\xEA3B', L"\x03BB\xE029" },
    { L'\xEA3C', L"\x028E\xE025" },
    { L'\xEA3D', L"\x006C\xE030" },
    { L'\xEA3E', L"\x006C\xE030\xE029" },
    { L'\xEA3F', L"\x006C\xE037\xE029" },
    { L'\xEA40', L"\x006C\xE037\xE001\xE029" },
    { L'\xEA41', L"\x006C\xE034\xE029" },
    { L'\xEA42', L"\x006C\xE034\xE001\xE029" },
    { L'\xEA43', L"\x006C\xE004\xE054" },
    { L'\xEA44', L"\x006C\xE054" },
    { L'\xEA45', L"\x006C\xE02F\xE025" },
    { L'\xEA46', L"\x006C\xE000" },
    { L'\xEA47', L"\x006C\xE037\xE000" },
    { L'\xEA48', L"\x006C\xE037\xE001" },
    { L'\xEA49', L"\x006C\xE011" },
    { L'\xEA4A', L"\x006C\xE011\xE025" },
    { L'\xEA4B', L"\x006C\xE006\xE001\xE025" },
    { L'\xEA4C', L"\x006C\xE00B\xE025" },
    { L'\xEA4D', L"\x006C\xE0A3" },
    { L'\xEA4E', L"\x006C\xE003\xE025" },
    { L'\xEA4F', L"\x006C\xE00D\xE025" },
    { L'\xEA50', L"\x004C\xE0A0" },
    { L'\xEA51', L"\x004C\xE0C2" },
    { L'\xEA52', L"\x004C\xE025" },
    { L'\xEA53', L"\x004C\xE02F" },
    { L'\xEA60', L"\x006D\xE000" },
    { L'\xEA61', L"\x006D\xE000\xE025" },
    { L'\xEA62', L"\x006D\xE001\xE025" },
    { L'\xEA63', L"\x006D\xE002" },
    { L'\xEA64', L"\x006D\xE003" },
    { L'\xEA65', L"\x006D\xE004" },
    { L'\xEA66', L"\x006D\xE004\xE001\xE025" },
    { L'\xEA67', L"\x006D\xE004\xE025" },
    { L'\xEA68', L"\x006D\xE006\xE007" },
    { L'\xEA69', L"\x006D\xE008" },
    { L'\xEA6A', L"\x006D\xE011" },
    { L'\xEA6B', L"\x006D\xE025" },
    { L'\xEA6C', L"\x006D\xE026" },
    { L'\xEA6D', L"\x006D\xE028" },
    { L'\xEA6E', L"\x006D\xE02D" },
    { L'\xEA6F', L"\x006D\xE031" },
    { L'\xEA70', L"\x006D\xE039" },
    { L'\xEA71', L"\x006D\xE0A2\xE025" },
    { L'\xEA71', L"\x0271\xE025" },
    { L'\xEA72', L"\x006D\xE029" },
    { L'\xEA73', L"\x006D\xE0A2\xE029" },
    { L'\xEA73', L"\x0271\xE029" },
    { L'\xEA74', L"\x006D\xE0A2\xE00A" },
    { L'\xEA74', L"\x0271\xE00A" },
    { L'\xEA75', L"\x006D\xE030" },
    { L'\xEA76', L"\x006D\xE030\xE029" },
    { L'\xEA77', L"\x006D\xE0A2\xE030" },
    { L'\xEA77', L"\x0271\xE030" },
    { L'\xEA78', L"\x006D\xE0A2\xE030\xE029" },
    { L'\xEA78', L"\x0271\xE030\xE029" },
    { L'\xEA79', L"\x006D\xE015" },
    { L'\xEA79', L"\x006D\xE0C4\x2019" },
    { L'\xEA7A', L"\x006D\xE00F" },
    { L'\xEA7B', L"\x006D\xE006\xE025" },
    { L'\xEA7C', L"\x006D\xE006\xE001\xE025" },
    { L'\xEA7D', L"\x006D\xE00B\xE025" },
    { L'\xEA7E', L"\x006D\xE011\xE025" },
    { L'\xEA7F', L"\x006D\xE003\xE025" },
    { L'\xEA80', L"\x004D\xE002" },
    { L'\xEA81', L"\x004D\xE003" },
    { L'\xEA82', L"\x004D\xE025" },
    { L'\xEA83', L"\x004D\xE029" },
    { L'\xEA84', L"\x004D\xE0C2" },
    { L'\xEA90', L"\x006E\xE000\xE025" },
    { L'\xEA91', L"\x006E\xE001\xE023" },
    { L'\xEA92', L"\x006E\xE001\xE025" },
    { L'\xEA93', L"\x006E\xE001\xE02D" },
    { L'\xEA94', L"\x006E\xE002" },
    { L'\xEA95', L"\x006E\xE027\xE002" },
    { L'\xEA96', L"\x006E\xE027\xE003" },
    { L'\xEA97', L"\x006E\xE004" },
    { L'\xEA98', L"\x006E\xE004\xE001\xE025" },
    { L'\xEA99', L"\x006E\xE004\xE025" },
    { L'\xEA9A', L"\x006E\xE006\xE007" },
    { L'\xEA9B', L"\x006E\xE008" },
    { L'\xEA9C', L"\x006E\xE00F\xE025" },
    { L'\xEA9D', L"\x006E\xE011" },
    { L'\xEA9E', L"\x006E\xE025" },
    { L'\xEA9F', L"\x006E\xE027" },
    { L'\xEAA0', L"\x006E\xE028" },
    { L'\xEAA1', L"\x006E\xE02C" },
    { L'\xEAA2', L"\x006E\xE039" },
    { L'\xEAA3', L"\x006E\xE0A0" },
    { L'\xEAA4', L"\x006E\xE0A2\xE001" },
    { L'\xEAA4', L"\x014B\xE001" },
    { L'\xEAA5', L"\x006E\xE0A2\xE004\xE025" },
    { L'\xEAA5', L"\x014B\xE004\xE025" },
    { L'\xEAA6', L"\x006E\xE0A2\xE025" },
    { L'\xEAA6', L"\x014B\xE025" },
    { L'\xEAA7', L"\xE105\xE025" },
    { L'\xEAA8', L"\x006E\xE00D" },
    { L'\xEAA9', L"\x006E\xE001\xE029" },
    { L'\xEAAA', L"\x006E\xE029" },
    { L'\xEAAB', L"\x006E\xE021\xE029" },
    { L'\xEAAB', L"\x0272\xE029" },
    { L'\xEAAC', L"\x006E\xE0A2\xE029" },
    { L'\xEAAC', L"\x014B\xE029" },
    { L'\xEAAD', L"\x006E\xE0A2\xE00A" },
    { L'\xEAAD', L"\x014B\xE00A" },
    { L'\xEAAE', L"\x006E\xE021\xE00A" },
    { L'\xEAAE', L"\x0272\xE00A" },
    { L'\xEAAF', L"\x006E\xE021\xE025" },
    { L'\xEAAF', L"\x0272\xE025" },
    { L'\xEAB0', L"\x006E\xE030" },
    { L'\xEAB1', L"\x006E\xE030\xE029" },
    { L'\xEAB2', L"\x006E\xE0A2\xE030" },
    { L'\xEAB2', L"\x014B\xE030" },
    { L'\xEAB3', L"\x006E\xE0A2\xE030\xE029" },
    { L'\xEAB3', L"\x014B\xE030\xE029" },
    { L'\xEAB4', L"\x006E\xE021\xE030" },
    { L'\xEAB4', L"\x0272\xE030" },
    { L'\xEAB5', L"\x006E\xE021\xE030\xE029" },
    { L'\xEAB5', L"\x0272\xE030\xE029" },
    { L'\xEAB6', L"\xE105\xE000" },
    { L'\xEAB7', L"\x006E\xE02F" },
    { L'\xEAB8', L"\x006E\xE015" },
    { L'\xEAB8', L"\x006E\xE0C4\x2019" },
    { L'\xEAB9', L"\x006E\xE0A2\xE015" },
    { L'\xEAB9', L"\x006E\xE0A2\xE0C4\x2019" },
    { L'\xEAB9', L"\x014B\xE015" },
    { L'\xEAB9', L"\x014B\xE0C4\x2019" },
    { L'\xEABA', L"\x006E\xE006\xE025" },
    { L'\xEABB', L"\x006E\xE006\xE001\xE025" },
    { L'\xEABC', L"\x006E\xE00B\xE025" },
    { L'\xEABD', L"\x006E\xE002\xE025" },
    { L'\xEABE', L"\x006E\xE003\xE025" },
    { L'\xEABF', L"\x006E\xE011\xE025" },
    { L'\xEAC0', L"\x004E\xE004\xE025" },
    { L'\xEAC1', L"\x004E\xE025" },
    { L'\xEAC2', L"\x004E\xE0A2\xE025" },
    { L'\xEAC2', L"\x014A\xE025" },
    { L'\xEAC3', L"\xE135\xE025" },
    { L'\xEAC4', L"\x004E\xE029" },
    { L'\xEAC5', L"\x004E\xE02C" },
    { L'\xEAD0', L"\x0070\xE003" },
    { L'\xEAD1', L"\x0070\xE004" },
    { L'\xEAD2', L"\x0070\xE011" },
    { L'\xEAD3', L"\x0070\xE031" },
    { L'\xEAD4', L"\x0070\xE006" },
    { L'\xEAD5', L"\x0070\xE02D" },
    { L'\xEAD6', L"\x0070\xE00C" },
    { L'\xEAD7', L"\x0070\xE02C" },
    { L'\xEAD8', L"\x0070\xE030" },
    { L'\xEAD9', L"\x0070\xE07A" },
    { L'\xEADA', L"\x0070\xE015" },
    { L'\xEADA', L"\x0070\xE0C4\x2019" },
    { L'\xEADB', L"\x0070\xE023" },
    { L'\xEAE0', L"\x0050\xE0B9" },
    { L'\xEAE1', L"\x0050\xE023" },
    { L'\xEAE2', L"\x0050\xE003" },
    { L'\xEAF0', L"\x0071\xE001" },
    { L'\xEAF1', L"\x0071\xE007" },
    { L'\xEAF2', L"\x0071\xE080" },
    { L'\xEAF3', L"\x0071\xE035" },
    { L'\xEAF4', L"\x0071\xE023" },
    { L'\xEAFE', L"\x0051\xE063" },
    { L'\xEAFF', L"\x0051\xE023" },
    { L'\xEB00', L"\x0072\xE000" },
    { L'\xEB01', L"\x0072\xE000\xE025" },
    { L'\xEB02', L"\x0072\xE001\xE025" },
    { L'\xEB03', L"\x0072\xE002" },
    { L'\xEB04', L"\x0072\xE002\xE025" },
    { L'\xEB05', L"\x0072\xE003" },
    { L'\xEB06', L"\x0072\xE003\xE025" },
    { L'\xEB07', L"\x0072\xE004" },
    { L'\xEB08', L"\x0072\xE004\xE001\xE025" },
    { L'\xEB09', L"\x0072\xE004\xE025" },
    { L'\xEB0A', L"\x0072\xE007\xE025" },
    { L'\xEB0B', L"\x0072\xE007\xE00F\xE025" },
    { L'\xEB0C', L"\x0072\xE00B" },
    { L'\xEB0D', L"\x0072\xE00C\xE001" },
    { L'\xEB0E', L"\x0072\xE00C\xE02D" },
    { L'\xEB0F', L"\x0072\xE00C\xE02F" },
    { L'\xEB10', L"\x0072\xE00F\xE025" },
    { L'\xEB11', L"\x0072\xE011\xE025" },
    { L'\xEB12', L"\x0072\xE076" },
    { L'\xEB13', L"\x0072\xE076\xE02D" },
    { L'\xEB14', L"\x0072\xE076\xE02F" },
    { L'\xEB15', L"\x0072\xE025" },
    { L'\xEB16', L"\x0072\xE00C\xE001\xE02D" },
    { L'\xEB17', L"\x0072\xE02C" },
    { L'\xEB18', L"\x0072\xE02D" },
    { L'\xEB19', L"\x0280\xE000" },
    { L'\xEB1A', L"\x0280\xE001" },
    { L'\xEB1B', L"\x0280\xE011" },
    { L'\xEB1C', L"\x0280\xE025" },
    { L'\xEB1D', L"\x0072\xE00D" },
    { L'\xEB1E', L"\x0072\xE00D\xE025" },
    { L'\xEB1F', L"\x0072\xE029" },
    { L'\xEB20', L"\x0072\xE006" },
    { L'\xEB21', L"\x0072\xE02F" },
    { L'\xEB22', L"\x027E\xE029" },
    { L'\xEB23', L"\x027E\xE030" },
    { L'\xEB24', L"\x027E\xE030\xE029" },
    { L'\xEB25', L"\x0072\xE000\xE029" },
    { L'\xEB26', L"\x0072\xE001\xE029" },
    { L'\xEB27', L"\x027E\xE000\xE029" },
    { L'\xEB28', L"\x027E\xE001\xE029" },
    { L'\xEB29', L"\x0072\xE066" },
    { L'\xEB2A', L"\x0281\xE000" },
    { L'\xEB2B', L"\x0072\xE004\xE001" },
    { L'\xEB2C', L"\x0072\xE054" },
    { L'\xEB2D', L"\x0072\xE007\xE011" },
    { L'\xEB2E', L"\x0072\xE007\xE00F" },
    { L'\xEB2F', L"\x0072\xE015" },
    { L'\xEB2F', L"\x0072\xE0C4\x2019" },
    { L'\xEB30', L"\x0052\xE004" },
    { L'\xEB31', L"\x0052\xE004\xE025" },
    { L'\xEB32', L"\x0052\xE025" },
    { L'\xEB33', L"\x0052\xE027" },
    { L'\xEB34', L"\x0052\xE00D" },
    { L'\xEB35', L"\x0052\xE000" },
    { L'\xEB36', L"\x0052\xE003" },
    { L'\xEB37', L"\x0052\xE0C2" },
    { L'\xEB40', L"\x0073\xE000" },
    { L'\xEB41', L"\x0073\xE004" },
    { L'\xEB42', L"\x0073\xE00C\xE000" },
    { L'\xEB43', L"\x0073\xE00C\xE001" },
    { L'\xEB44', L"\x0073\xE00C\xE004" },
    { L'\xEB45', L"\x0073\xE00C\xE00D" },
    { L'\xEB46', L"\x0073\xE00C\xE023" },
    { L'\xEB47', L"\x0073\xE00C\xE031" },
    { L'\xEB48', L"\x0073\xE076" },
    { L'\xEB49', L"\x0073\xE025" },
    { L'\xEB4A', L"\x0073\xE031" },
    { L'\xEB4B', L"\x017F\xE0A2\xE007" },
    { L'\xEB4B', L"\x0283\xE007" },
    { L'\xEB4C', L"\x03C3\xE000" },
    { L'\xEB4D', L"\x03C3\xE001" },
    { L'\xEB4E', L"\x03C3\xE003" },
    { L'\xEB4F', L"\x03C3\xE003\xE000" },
    { L'\xEB50', L"\x03C3\xE003\xE001" },
    { L'\xEB51', L"\x0073\xE003" },
    { L'\xEB52', L"\x0073\xE011" },
    { L'\xEB53', L"\x0073\xE00C\xE011" },
    { L'\xEB54', L"\x0073\xE00B" },
    { L'\xEB55', L"\x017F\xE0A2\xE004" },
    { L'\xEB55', L"\x0283\xE004" },
    { L'\xEB56', L"\x0073\xE00F" },
    { L'\xEB57', L"\x0073\xE00C\xE00F" },
    { L'\xEB58', L"\x0073\xE02D" },
    { L'\xEB59', L"\x017F\xE001" },
    { L'\xEB5A', L"\x0073\xE02C" },
    { L'\xEB5B', L"\x0073\xE030" },
    { L'\xEB5C', L"\x017F\xE00C" },
    { L'\xEB5D', L"\x017F\xE0A2\xE00C" },
    { L'\xEB5D', L"\x0283\xE00C" },
    { L'\xEB5E', L"\x017F\xE0A2\xE02C" },
    { L'\xEB5E', L"\x0283\xE02C" },
    { L'\xEB5F', L"\x017F\xE0A2\xE030" },
    { L'\xEB5F', L"\x0283\xE030" },
    { L'\xEB60', L"\x0053\xE028" },
    { L'\xEB61', L"\x0053\xE039" },
    { L'\xEB62', L"\x0053\xE0A1" },
    { L'\xEB63', L"\x0053\xE0B3" },
    { L'\xEB63', L"\xE282\xE0C4\x0053" },
    { L'\xEB64', L"\x0053\xE0B6" },
    { L'\xEB64', L"\x201A\xE0C4\x0053" },
    { L'\xEB65', L"\x0053\xE029" },
    { L'\xEB66', L"\x0053\xE00C\xE0C0" },
    { L'\xEB67', L"\x0053\xE0C2" },
    { L'\xEB68', L"\x0053\xE025" },
    { L'\xEB69', L"\x0053\xE02C" },
    { L'\xEB6A', L"\x0053\xE0B0" },
    { L'\xEB6A', L"\x2019\xE0C4\x0053" },
    { L'\xEB6B', L"\x0053\xE00C\xE00D" },
    { L'\xEB6C', L"\x0053\xE00C\xE023" },
    { L'\xEB6D', L"\x0053\xE00D" },
    { L'\xEB70', L"\x0074\xE001" },
    { L'\xEB71', L"\x0074\xE004" },
    { L'\xEB72', L"\x0074\xE00C" },
    { L'\xEB73', L"\x0074\xE011" },
    { L'\xEB74', L"\x0074\xE025" },
    { L'\xEB75', L"\x0074\xE030" },
    { L'\xEB76', L"\x03B8\xE025" },
    { L'\xEB77', L"\x0074\xE015\xE004" },
    { L'\xEB77', L"\x0074\xE05E\x2019" },
    { L'\xEB77', L"\x0074\xE0C4\x2019\xE004" },
    { L'\xEB78', L"\x0074\xE02C" },
    { L'\xEB79', L"\x0074\xE0C4\x0073\xE02C" },
    { L'\xEB7A', L"\x0074\xE0C4\x0073\xE030" },
    { L'\xEB7B', L"\x0074\xE0C4\x017F\xE0A2\xE02C" },
    { L'\xEB7B', L"\x0074\xE0C4\x0283\xE02C" },
    { L'\xEB7C', L"\x0074\xE0C4\x017F\xE0A2\xE030" },
    { L'\xEB7C', L"\x0074\xE0C4\x0283\xE030" },
    { L'\xEB7D', L"\x0074\xE002" },
    { L'\xEB7E', L"\x0074\xE0A3" },
    { L'\xEB7F', L"\x0074\xE028" },
    { L'\xEB80', L"\x0076\xE000" },
    { L'\xEB81', L"\x0076\xE001" },
    { L'\xEB82', L"\x0076\xE002" },
    { L'\xEB83', L"\x0076\xE004" },
    { L'\xEB84', L"\x0076\xE01C" },
    { L'\xEB85', L"\x0076\xE02C" },
    { L'\xEB86', L"\x0076\xE02D" },
    { L'\xEB87', L"\x0076\xE031" },
    { L'\xEB88', L"\x0076\xE0B3" },
    { L'\xEB89', L"\x0076\xE025" },
    { L'\xEB8A', L"\x0076\xE028" },
    { L'\xEB8B', L"\x0076\xE030" },
    { L'\xEB8C', L"\x0076\xE064" },
    { L'\xEB8D', L"\x0076\xE066" },
    { L'\xEB8E', L"\x0076\xE06E" },
    { L'\xEB8F', L"\x0076\xE08A\xE025" },
    { L'\xEB8F', L"\x028B\xE025" },
    { L'\xEB90', L"\x0076\xE08A\xE030" },
    { L'\xEB90', L"\x028B\xE030" },
    { L'\xEB91', L"\x0076\xE008" },
    { L'\xEB92', L"\x0076\xE015" },
    { L'\xEB92', L"\x0076\xE0C4\x2019" },
    { L'\xEB93', L"\x0076\xE037" },
    { L'\xEB94', L"\x0076\xE091" },
    { L'\xEB95', L"\x0076\xE011" },
    { L'\xEB96', L"\x0076\xE00A" },
    { L'\xEB97', L"\x0076\xE007\xE023" },
    { L'\xEB98', L"\x0076\xE02F" },
    { L'\xEB99', L"\x0076\xE006" },
    { L'\xEBA0', L"\x0056\xE000" },
    { L'\xEBA1', L"\x0056\xE001" },
    { L'\xEBA2', L"\x0056\xE002" },
    { L'\xEBA3', L"\x0056\xE004" },
    { L'\xEBA4', L"\x0056\xE004\xE006" },
    { L'\xEBA5', L"\x0056\xE006" },
    { L'\xEBA6', L"\x0056\xE00B" },
    { L'\xEBA7', L"\x0056\xE00F" },
    { L'\xEBA8', L"\x0056\xE011" },
    { L'\xEBA9', L"\x0056\xE07A" },
    { L'\xEBAA', L"\x0056\xE064" },
    { L'\xEBAB', L"\x0056\xE066" },
    { L'\xEBAC', L"\x0056\xE070" },
    { L'\xEBAD', L"\x0056\xE071" },
    { L'\xEBAE', L"\x0056\xE025" },
    { L'\xEBAF', L"\x0056\xE028" },
    { L'\xEBB0', L"\x0077\xE003" },
    { L'\xEBB1', L"\x0077\xE004" },
    { L'\xEBB2', L"\x0077\xE02D" },
    { L'\xEBB3', L"\x0077\xE031" },
    { L'\xEBB4', L"\x0077\xE025" },
    { L'\xEBB5', L"\x0077\xE030" },
    { L'\xEBB6', L"\x028D\xE030" },
    { L'\xEBB7', L"\x0077\xE064" },
    { L'\xEBB8', L"\x0077\xE066" },
    { L'\xEBB9', L"\x0077\xE015" },
    { L'\xEBB9', L"\x0077\xE0C4\x2019" },
    { L'\xEBBA', L"\x0077\xE067" },
    { L'\xEBBB', L"\x0077\xE06E" },
    { L'\xEBBC', L"\x0057\xE064" },
    { L'\xEBBD', L"\x0057\xE067" },
    { L'\xEBBE', L"\x0057\xE066" },
    { L'\xEBBF', L"\x0057\xE06E" },
    { L'\xEBC0', L"\x0078\xE000" },
    { L'\xEBC1', L"\x0078\xE001" },
    { L'\xEBC2', L"\x0078\xE004" },
    { L'\xEBC3', L"\x0078\xE00C" },
    { L'\xEBC4', L"\x0078\xE011" },
    { L'\xEBC5', L"\x0078\xE031" },
    { L'\xEBC6', L"\x0078\xE02C" },
    { L'\xEBC7', L"\x0078\xE030" },
    { L'\xEBC8', L"\x0078\xE023" },
    { L'\xEBC9', L"\x0078\xE015" },
    { L'\xEBC9', L"\x0078\xE0C4\x2019" },
    { L'\xEBCA', L"\x0078\xE006" },
    { L'\xEBCB', L"\x0078\xE03F" },
    { L'\xEBCF', L"\x0058\xE001" },
    { L'\xEBD0', L"\x007A\xE000" },
    { L'\xEBD1', L"\x007A\xE004" },
    { L'\xEBD2', L"\x007A\xE007\xE02D" },
    { L'\xEBD3', L"\x007A\xE00F" },
    { L'\xEBD4', L"\x007A\xE00C\xE001" },
    { L'\xEBD5', L"\x007A\xE00C\xE004" },
    { L'\xEBD6', L"\x007A\xE00C\xE00D" },
    { L'\xEBD7', L"\x007A\xE00C\xE025" },
    { L'\xEBD8', L"\x007A\xE00C\xE02C" },
    { L'\xEBD9', L"\x007A\xE00C\xE02D" },
    { L'\xEBDA', L"\x007A\xE00C\xE031" },
    { L'\xEBDB', L"\x007A\xE011" },
    { L'\xEBDC', L"\x007A\xE076" },
    { L'\xEBDD', L"\x007A\xE028" },
    { L'\xEBDE', L"\x007A\xE02C" },
    { L'\xEBDF', L"\x007A\xE02D" },
    { L'\xEBE0', L"\x007A\xE0B0" },
    { L'\xEBE0', L"\x2019\xE0C4\x007A" },
    { L'\xEBE1', L"\x0292\xE001" },
    { L'\xEBE2', L"\x0292\xE002" },
    { L'\xEBE3', L"\x0292\xE00C\xE001" },
    { L'\xEBE4', L"\x0292\xE00C\xE00D" },
    { L'\xEBE5', L"\x0292\xE011" },
    { L'\xEBE6', L"\x0292\xE076" },
    { L'\xEBE7', L"\x0292\xE00D" },
    { L'\xEBE8', L"\x007A\xE003" },
    { L'\xEBE9', L"\x0292\xE00C\xE011" },
    { L'\xEBEA', L"\x0292\xE035\xE00C" },
    { L'\xEBEB', L"\x0292\xE035" },
    { L'\xEBEC', L"\x007A\xE00C\xE011" },
    { L'\xEBED', L"\x0292\xE035\xE00C\xE011" },
    { L'\xEBEE', L"\x007A\xE008" },
    { L'\xEBEF', L"\x007A\xE02F" },
    { L'\xEBF0', L"\x005A\xE0B0" },
    { L'\xEBF0', L"\x2019\xE0C4\x005A" },
    { L'\xEBF1', L"\x01B7\xE002" },
    { L'\xEBF2', L"\x005A\xE00C\xE02C" },
    { L'\xEBF3', L"\x0417\xE00C" },
    { L'\xEBF4', L"\x005A\xE00C\xE0C0" },
    { L'\xEBF5', L"\x01B7\xE00B" },
    { L'\xEBF6', L"\x0417\xE001" },
    { L'\xEBF7', L"\x01B7\xE001" },
    { L'\xEBF8', L"\x005A\xE028" },
    { L'\xEBF9', L"\x01B7\xE00C\xE00D" },
    { L'\xEBFA', L"\x005A\xE00C\xE023" },
    { L'\xEBFB', L"\x005A\xE025" },
    { L'\xEBFC', L"\x005A\xE00C\xE00D" },
    { L'\xEC00', L"\x0061\xE061\x0069" },
    { L'\xEC01', L"\x0061\xE05C\x0069\xE02F" },
    { L'\xEC02', L"\x0061\xE061\xE0C5\x0069\xE02F\xE0C6" },
    { L'\xEC03', L"\x0061\x02D0\xE05C\x0069\xE02F" },
    { L'\xEC04', L"\x0061\x003A\xE05C\x0069\xE02F" },
    { L'\xEC05', L"\x0061\xE000\xE05C\x0069\xE02F" },
    { L'\xEC06', L"\x0061\xE001\xE05C\x0069\xE02F" },
    { L'\xEC07', L"\x0061\xE025\x02D0\xE05C\x006E" },
    { L'\xEC08', L"\x0061\xE025\x003A\xE05C\x006E" },
    { L'\xEC09', L"\x0061\xE061\x006F" },
    { L'\xEC0A', L"\x0061\xE05C\x006F" },
    { L'\xEC0B', L"\x0061\xE000\xE05C\x006F" },
    { L'\xEC0C', L"\x0061\xE001\xE05C\x006F" },
    { L'\xEC0D', L"\x0061\xE008\xE05C\x006F" },
    { L'\xEC0E', L"\x0061\xE008\xE000\xE05C\x006F" },
    { L'\xEC0F', L"\x0061\x02D0\xE05C\x0075\xE02F" },
    { L'\xEC10', L"\x0061\x003A\xE05C\x0075\xE02F" },
    { L'\xEC11', L"\x0061\xE025\x02D0\xE05C\x0075\xE02F" },
    { L'\xEC12', L"\x0061\xE025\x003A\xE05C\x0075\xE02F" },
    { L'\xEC13', L"\x0061\xE05C\x0069" },
    { L'\xEC14', L"\x0061\xE05C\x0075" },
    { L'\xEC15', L"\x0061\xE061\x0072" },
    { L'\xEC16', L"\x0061\xE001\xE025\xE05C\x0072" },
    { L'\xEC17', L"\x0061\xE05E\x0061" },
    { L'\xEC18', L"\x0061\xE0D0\x0075" },
    { L'\xEC19', L"\x0061\xE008\xE0D0\x0075" },
    { L'\xEC1A', L"\x0061\xE00A\xE061\x0061" },
    { L'\xEC1B', L"\x0061\xE061\x006E" },
    { L'\xEC1C', L"\x0061\xE00A\xE061\x0069" },
    { L'\xEC1D', L"\x0061\xE00A\xE061\x0061\xE001" },
    { L'\xEC1E', L"\x0061\xE061\x0069\xE001" },
    { L'\xEC1F', L"\x0061\xE061\x006D" },
    { L'\xEC20', L"\x0061\xE061\x0075\xE001" },
    { L'\xEC21', L"\x0061\xE061\x0075\xE008" },
    { L'\xEC22', L"\x0061\xE008\xE061\x0061" },
    { L'\xEC23', L"\x0061\xE008\xE061\x0075" },
    { L'\xEC24', L"\x0061\xE05C\x0061" },
    { L'\xEC25', L"\x0061\xE05C\x006E" },
    { L'\xEC26', L"\x0061\xE008\xE05C\x0075\xE008" },
    { L'\xEC27', L"\x0061\xE061\x0075\xE02F" },
    { L'\xEC28', L"\x0061\xE00A\xE061\x0075\xE02F" },
    { L'\xEC29', L"\x0061\xE001\xE05C\x0072" },
    { L'\xEC2A', L"\x0061\xE061\x0069\xE02F" },
    { L'\xEC2B', L"\x0061\xE011\xE025\xE05C\x0072" },
    { L'\xEC2C', L"\x0061\xE00A\xE061\x0072" },
    { L'\xEC60', L"\x0041\xE0D0\x0075" },
    { L'\xEC61', L"\x0041\xE008\xE0D0\x0075" },
    { L'\xEC62', L"\x0041\xE00A\xE061\x0061" },
    { L'\xEC63', L"\x0041\xE061\x006E" },
    { L'\xEC80', L"\x0065\xE061\xE0C5\x0061\xE0C6" },
    { L'\xEC81', L"\x0065\xE061\x0061\xE008" },
    { L'\xEC82', L"\x0065\xE05C\x0061\xE008" },
    { L'\xEC83', L"\x0065\xE001\xE05C\x0061\xE023" },
    { L'\xEC84', L"\x0065\xE039\xE061\x0259" },
    { L'\xEC85', L"\x0065\xE05C\x0069\xE02F" },
    { L'\xEC86', L"\x0065\x02D0\xE05C\x0069\xE02F" },
    { L'\xEC87', L"\x0065\x003A\xE05C\x0069\xE02F" },
    { L'\xEC88', L"\x0065\xE000\xE05C\x0069\xE02F" },
    { L'\xEC89', L"\x0065\xE000\x02D0\xE05C\x0069\xE02F" },
    { L'\xEC8A', L"\x0065\xE000\x003A\xE05C\x0069\xE02F" },
    { L'\xEC8B', L"\x0065\xE001\xE05C\x0069\xE02F" },
    { L'\xEC8C', L"\x0065\xE023\xE05C\x0069\xE02F" },
    { L'\xEC8D', L"\x0065\xE0C8\xE0C5\x0069\xE0C6\x0259" },
    { L'\xEC8E', L"\x0065\xE0C8\x006A\x0259" },
    { L'\xEC8F', L"\x0065\xE05C\x006C" },
    { L'\xEC90', L"\x0065\xE061\x006F" },
    { L'\xEC91', L"\x0065\xE05C\x006F" },
    { L'\xEC92', L"\x0065\xE05C\x0072" },
    { L'\xEC93', L"\xE0C5\x0259\xE028\xE0C6\xE05C\x0061" },
    { L'\xEC93', L"\xE2EC\x0259\xE028\xE2ED\xE05C\x0061" },
    { L'\xEC94', L"\xE0C5\x0259\xE028\xE0C6\xE05C\x0061\xE001" },
    { L'\xEC94', L"\xE2EC\x0259\xE028\xE2ED\xE05C\x0061\xE001" },
    { L'\xEC95', L"\xE0C5\x0259\xE028\xE0C6\xE05C\x0061\xE003" },
    { L'\xEC95', L"\xE2EC\x0259\xE028\xE2ED\xE05C\x0061\xE003" },
    { L'\xEC96', L"\x0259\xE061\x0072" },
    { L'\xEC97', L"\x0259\xE05C\x0072" },
    { L'\xEC98', L"\xE0C5\x0259\xE0C6\xE061\x0072" },
    { L'\xEC98', L"\xE2EC\x0259\xE2ED\xE061\x0072" },
    { L'\xEC99', L"\x0259\xE05C\x0072\xE001" },
    { L'\xEC9A', L"\xE0C5\x0259\xE0C6\xE05C\x0072\xE003" },
    { L'\xEC9A', L"\xE2EC\x0259\xE2ED\xE05C\x0072\xE003" },
    { L'\xEC9B', L"\x0259\xE000\xE05C\x0072" },
    { L'\xEC9C', L"\x025B\xE028\xE05C\x006A\xE028" },
    { L'\xEC9D', L"\x0065\xE05C\x0061\xE001\xE023" },
    { L'\xEC9E', L"\x0065\xE000\xE05C\x0061" },
    { L'\xEC9F', L"\x0065\xE05C\x0061\xE023" },
    { L'\xECA0', L"\x0065\xE000\xE05C\x0061\xE023" },
    { L'\xECA1', L"\x0065\xE05C\x0061\xE001" },
    { L'\xECA2', L"\x0065\xE02D\xE061\x0065\xE039" },
    { L'\xECA3', L"\x0065\xE061\x0069\xE02F" },
    { L'\xECA4', L"\x0065\xE039\xE061\x0069\xE02F" },
    { L'\xECA5', L"\xE0C5\x0259\xE028\xE0C6\xE05C\x0061\xE000" },
    { L'\xECA5', L"\xE2EC\x0259\xE028\xE2ED\xE05C\x0061\xE000" },
    { L'\xECA6', L"\x0065\xE061\xE0C5\x0069\xE0C6" },
    { L'\xECA7', L"\x0065\xE061\x0069" },
    { L'\xECA8', L"\x0065\xE0D0\x0069" },
    { L'\xECA9', L"\x0065\xE0D0\x0075" },
    { L'\xECAA', L"\x0065\xE05C\xE000\x006C" },
    { L'\xECAB', L"\x0065\xE05C\xE001\x006C" },
    { L'\xECAC', L"\x0065\xE05C\xE002\x006C" },
    { L'\xECAD', L"\x0065\xE05C\xE003\x006C" },
    { L'\xECAE', L"\x0065\xE05C\xE004\x006C" },
    { L'\xECAF', L"\x0065\xE05C\xE006\x006C" },
    { L'\xECB0', L"\x0065\xE05C\xE00B\x006C" },
    { L'\xECB1', L"\x0065\xE05C\xE00D\x006C" },
    { L'\xECB2', L"\x0065\xE05C\xE011\x006C" },
    { L'\xECB3', L"\x0065\xE05C\xE000\x0072" },
    { L'\xECB4', L"\x0065\xE05C\xE001\x0072" },
    { L'\xECB5', L"\x0065\xE05C\xE002\x0072" },
    { L'\xECB6', L"\x0065\xE05C\xE003\x0072" },
    { L'\xECB7', L"\x0065\xE05C\xE004\x0072" },
    { L'\xECB8', L"\x0065\xE05C\xE006\x0072" },
    { L'\xECB9', L"\x0065\xE05C\xE00B\x0072" },
    { L'\xECBA', L"\x0065\xE05C\xE00D\x0072" },
    { L'\xECBB', L"\x0065\xE05C\xE011\x0072" },
    { L'\xECBC', L"\x0065\xE061\x0069\xE008" },
    { L'\xECBD', L"\x0259\xE001\xE05C\x0072" },
    { L'\xECBE', L"\xE0C5\x0259\xE0C6\xE05C\x0072\xE000\xE025" },
    { L'\xECBE', L"\xE2EC\x0259\xE2ED\xE05C\x0072\xE000\xE025" },
    { L'\xECBF', L"\xE0C5\x0259\xE0C6\xE05C\x0072\xE025" },
    { L'\xECBF', L"\xE2EC\x0259\xE2ED\xE05C\x0072\xE025" },
    { L'\xECC0', L"\x0065\xE061\x0061" },
    { L'\xECC1', L"\x0065\xE061\x0061\xE001" },
    { L'\xECC2', L"\x0065\xE061\x0072" },
    { L'\xECC3', L"\x0065\xE003\xE061\x0065\xE011" },
    { L'\xECC4', L"\x0065\xE004\xE061\x0069" },
    { L'\xECC5', L"\x0065\xE05C\x0061" },
    { L'\xECC6', L"\x0065\xE05C\x0069" },
    { L'\xECC7', L"\x0065\xE05C\x006F\xE008" },
    { L'\xECC8', L"\x0259\xE05C\x006E" },
    { L'\xECC9', L"\x0065\xE061\xE0CE\x0061\xE0CF" },
    { L'\xECC9', L"\x0065\xE061\xE2EE\x0061\xE2EF" },
    { L'\xECCA', L"\x0065\xE023\xE061\x0069\xE02F" },
    { L'\xECCB', L"\xE0C5\x0259\xE0C6\xE05C\x0061" },
    { L'\xECCC', L"\x0065\xE061\x0075\xE02F" },
    { L'\xECCD', L"\x0065\xE023\xE061\x0075\xE02F" },
    { L'\xECCE', L"\x0065\xE039\xE061\x0075\xE02F" },
    { L'\xECCF', L"\x0065\xE023\xE061\xE0C5\x0069\xE0C6" },
    { L'\xECCF', L"\x0065\xE023\xE061\xE2EC\x0069\xE2ED" },
    { L'\xECD0', L"\x0065\xE039\xE061\xE0C5\x0259\xE0C6" },
    { L'\xECD0', L"\x0065\xE039\xE061\xE2EC\x0259\xE2ED" },
    { L'\xECE0', L"\x0045\xE05C\x004C" },
    { L'\xECE1', L"\x0045\xE05C\x0052" },
    { L'\xECE2', L"\x0045\xE0D0\x0069" },
    { L'\xECE3', L"\x0045\xE0D0\x0075" },
    { L'\xED00', L"\x0069\xE05C\x0061\xE003\xE023" },
    { L'\xED01', L"\x0069\xE02F\xE05C\x0061\xE023" },
    { L'\xED02', L"\x0069\xE060\x0065" },
    { L'\xED03', L"\x0069\xE061\x0065" },
    { L'\xED04', L"\x0069\xE05C\x0065" },
    { L'\xED05', L"\xE0C5\x0069\xE0C6\xE061\x0065" },
    { L'\xED05', L"\xE2EC\x0069\xE2ED\xE061\x0065" },
    { L'\xED06', L"\xE0C5\x0069\xE0C6\xE05C\x0065" },
    { L'\xED06', L"\xE2EC\x0069\xE2ED\xE05C\x0065" },
    { L'\xED07', L"\x0069\xE05C\x0065\xE000" },
    { L'\xED08', L"\x0069\xE05C\x0065\xE000\xE023" },
    { L'\xED09', L"\x0069\xE05C\x0065\xE001" },
    { L'\xED0A', L"\xE0C5\x0069\xE0C6\xE05C\x0065\xE001" },
    { L'\xED0A', L"\xE2EC\x0069\xE2ED\xE05C\x0065\xE001" },
    { L'\xED0B', L"\x0069\xE05C\x0065\xE001\xE023" },
    { L'\xED0C', L"\x0069\xE05C\x0065\xE003" },
    { L'\xED0D', L"\x0069\xE05C\x0065\xE003\xE025" },
    { L'\xED0E', L"\x0069\xE061\x0065\xE023" },
    { L'\xED0F', L"\xE0C5\x0069\xE0C6\xE061\x0065\xE023" },
    { L'\xED0F', L"\xE2EC\x0069\xE2ED\xE061\x0065\xE023" },
    { L'\xED10', L"\x0069\xE05C\x0065\xE023" },
    { L'\xED11', L"\x0069\xE061\x0065\xE039" },
    { L'\xED12', L"\x0069\xE000\xE05C\x0065" },
    { L'\xED13', L"\x0069\xE000\xE05C\x0065\xE023" },
    { L'\xED14', L"\x0069\xE000\xE05C\x0065\xE028" },
    { L'\xED15', L"\x0069\xE001\xE05C\x0065\xE023" },
    { L'\xED16', L"\x0069\xE02F\xE05C\x0065" },
    { L'\xED17', L"\x0069\xE02F\xE061\x0065\xE000\xE023" },
    { L'\xED18', L"\x0069\xE02F\xE05C\x0065\xE000\xE023" },
    { L'\xED19', L"\x0069\xE02F\xE061\x0065\xE039" },
    { L'\xED1A', L"\x0069\xE061\x0259" },
    { L'\xED1B', L"\x0069\xE05C\x0259" },
    { L'\xED1C', L"\x0069\x02D0\xE05C\x0259" },
    { L'\xED1D', L"\x0069\x003A\xE05C\x0259" },
    { L'\xED1E', L"\x0069\xE000\xE05C\x0259" },
    { L'\xED1F', L"\x0069\xE000\x02D0\xE05C\x0259" },
    { L'\xED20', L"\x0069\xE000\x003A\xE05C\x0259" },
    { L'\xED21', L"\x0069\xE001\xE05C\x0259" },
    { L'\xED22', L"\x0069\xE001\x02D0\xE05C\x0259" },
    { L'\xED23', L"\x0069\xE001\x003A\xE05C\x0259" },
    { L'\xED24', L"\x0069\xE05C\x0069\xE02F" },
    { L'\xED25', L"\x0069\x02D0\xE05C\x0069\xE02F" },
    { L'\xED26', L"\x0069\x003A\xE05C\x0069\xE02F" },
    { L'\xED27', L"\x0069\xE05C\x006F" },
    { L'\xED28', L"\x0069\xE05C\x0079" },
    { L'\xED29', L"\xE0C5\x0069\xE0C6\xE061\x044A" },
    { L'\xED29', L"\xE2EC\x0069\xE2ED\xE061\x044A" },
    { L'\xED2A', L"\x0069\xE05C\xE0C5\x0065\xE0C6" },
    { L'\xED2A', L"\x0069\xE05C\xE2EC\x0065\xE2ED" },
    { L'\xED2B', L"\xE0C5\x0069\xE02F\xE0C6\xE05C\x0065\xE001" },
    { L'\xED2B', L"\xE2EC\x0069\xE02F\xE2ED\xE05C\x0065\xE001" },
    { L'\xED2C', L"\x0069\xE039\xE061\xE0C5\x0069\xE0C6" },
    { L'\xED2C', L"\x0069\xE039\xE061\xE2EC\x0069\xE2ED" },
    { L'\xED2D', L"\x0069\xE061\x0069\xE02F" },
    { L'\xED2E', L"\x0069\xE05C\x0065\xE003\xE023" },
    { L'\xED2F', L"\x0069\xE061\xE0C5\x0069\xE02F\xE0C6" },
    { L'\xED2F', L"\x0069\xE061\xE2EC\x0069\xE02F\xE2ED" },
    { L'\xED30', L"\x0131\xE05C\x0065" },
    { L'\xED31', L"\x0069\xE061\x0061" },
    { L'\xED32', L"\x0069\xE02F\xE061\x0061" },
    { L'\xED33', L"\x0069\xE02F\xE061\x006F" },
    { L'\xED34', L"\x0069\xE05F\x0259" },
    { L'\xED35', L"\x0069\xE061\x0065\xE02F" },
    { L'\xED36', L"\x0069\xE02F\xE061\x0065\xE023" },
    { L'\xED37', L"\xE0C5\x0069\xE0C6\xE05C\x0065\xE023" },
    { L'\xED37', L"\xE2EC\x0069\xE2ED\xE05C\x0065\xE023" },
    { L'\xED38', L"\x0069\xE061\x0075\xE02F" },
    { L'\xED39', L"\x0069\xE060\x0259" },
    { L'\xED3A', L"\x0069\xE05C\x006A" },
    { L'\xED3B', L"\x0069\xE05C\x0061" },
    { L'\xED3C', L"\x0069\xE02F\xE061\x0065" },
    { L'\xED3D', L"\xE0C5\x0069\xE02F\xE0C6\xE061\x0065\xE039" },
    { L'\xED3D', L"\xE2EC\x0069\xE02F\xE2ED\xE061\x0065\xE039" },
    { L'\xED3E', L"\x0069\xE02F\xE061\x0259" },
    { L'\xED3F', L"\x0069\xE061\xE0C5\x0069\xE0C6" },
    { L'\xED3F', L"\x0069\xE061\xE2EC\x0069\xE2ED" },
    { L'\xED40', L"\x0069\xE061\xE0C5\x0259\xE0C6" },
    { L'\xED40', L"\x0069\xE061\xE2EC\x0259\xE2ED" },
    { L'\xED41', L"\x0069\xE061\x0069" },
    { L'\xED42', L"\xE0C5\x0069\xE0C6\xE061\x0065\xE039" },
    { L'\xED42', L"\xE2EC\x0069\xE2ED\xE061\x0065\xE039" },
    { L'\xED43', L"\xE0C5\x0069\xE02F\xE0C6\xE061\x0065" },
    { L'\xED43', L"\xE2EC\x0069\xE02F\xE2ED\xE061\x0065" },
    { L'\xED44', L"\xE0C5\x0069\xE0C6\xE061\x0065\xE02D" },
    { L'\xED44', L"\xE2EC\x0069\xE2ED\xE061\x0065\xE02D" },
    { L'\xED45', L"\x0069\xE061\x0065\xE02D" },
    { L'\xED46', L"\x0069\xE061\xE0C5\x0065\xE0C6" },
    { L'\xED46', L"\x0069\xE061\xE2EC\x0065\xE2ED" },
    { L'\xED47', L"\xE0C5\x0069\xE0C6\xE061\x0065\xE001\xE023" },
    { L'\xED47', L"\xE2EC\x0069\xE2ED\xE061\x0065\xE001\xE023" },
    { L'\xED48', L"\xE0C5\x0069\xE0C6\xE061\x0065\xE007" },
    { L'\xED48', L"\xE2EC\x0069\xE2ED\xE061\x0065\xE007" },
    { L'\xED49', L"\x0069\xE02F\xE061\x0065\xE007" },
    { L'\xED4A', L"\x0069\xE061\xE0C5\x0065\xE023\xE0C6" },
    { L'\xED4A', L"\x0069\xE061\xE2EC\x0065\xE023\xE2ED" },
    { L'\xED4B', L"\x0069\xE02F\xE061\xE0C5\x0069\xE0C6" },
    { L'\xED4B', L"\x0069\xE02F\xE061\xE2EC\x0069\xE2ED" },
    { L'\xED70', L"\x0049\xE05C\x006A" },
    { L'\xED80', L"\x006F\xE061\xE0C5\x0061\xE0C6" },
    { L'\xED80', L"\x006F\xE061\xE2EC\x0061\xE2ED" },
    { L'\xED81', L"\x006F\xE05C\x0061\xE000\xE025" },
    { L'\xED82', L"\x006F\xE05C\x0061\xE003\xE025" },
    { L'\xED83', L"\x006F\xE05C\x0061\xE025" },
    { L'\xED84', L"\x006F\xE05C\x0069\xE02F" },
    { L'\xED85', L"\x006F\xE000\xE05C\x0069\xE02F" },
    { L'\xED86', L"\x006F\xE001\xE05C\x0069\xE02F" },
    { L'\xED87', L"\x006F\xE05C\x006C" },
    { L'\xED88', L"\x006F\xE008\xE05C\x006F" },
    { L'\xED89', L"\x006F\xE008\xE000\xE05C\x006F" },
    { L'\xED8A', L"\x006F\xE05C\x0072" },
    { L'\xED8B', L"\x006F\xE05C\x0052" },
    { L'\xED8C', L"\x006F\xE061\xE0C5\x0075\xE0C6" },
    { L'\xED8D', L"\x006F\xE061\x0075\xE02F" },
    { L'\xED8E', L"\x006F\xE05C\x0075\xE02F" },
    { L'\xED8F', L"\x006F\x02D0\xE05C\x0075\xE02F" },
    { L'\xED90', L"\x006F\x003A\xE05C\x0075\xE02F" },
    { L'\xED91', L"\x006F\xE000\xE05C\x0075\xE02F" },
    { L'\xED92', L"\x006F\xE001\xE05C\x0075\xE02F" },
    { L'\xED93', L"\x006F\xE023\xE05C\x0075\xE02F" },
    { L'\xED94', L"\x006F\xE023\x02D0\xE05C\x0075\xE02F" },
    { L'\xED95', L"\x006F\xE023\x003A\xE05C\x0075\xE02F" },
    { L'\xED96', L"\x006F\xE037\xE05C\x0075\xE037" },
    { L'\xED97', L"\x006F\xE0C9\xE0C5\x0075\xE0C6\x0259" },
    { L'\xED98', L"\x006F\xE0C8\x0077\x0259" },
    { L'\xED99', L"\x006F\xE05C\x0061\xE001" },
    { L'\xED9A', L"\x006F\xE061\x0061" },
    { L'\xED9B', L"\x006F\xE05C\x0061\xE023" },
    { L'\xED9C', L"\x006F\xE039\xE061\x0075\xE02F" },
    { L'\xED9D', L"\x006F\xE05C\x0079" },
    { L'\xED9E', L"\x006F\xE05D\x006F" },
    { L'\xED9F', L"\x006F\xE05E\x006F" },
    { L'\xEDA1', L"\x006F\xE05E\x0075" },
    { L'\xEDA2', L"\x006F\xE05C\xE000\x006C" },
    { L'\xEDA3', L"\x006F\xE05C\xE001\x006C" },
    { L'\xEDA4', L"\x006F\xE05C\xE002\x006C" },
    { L'\xEDA5', L"\x006F\xE05C\xE003\x006C" },
    { L'\xEDA6', L"\x006F\xE05C\xE004\x006C" },
    { L'\xEDA7', L"\x006F\xE05C\xE006\x006C" },
    { L'\xEDA8', L"\x006F\xE05C\xE00B\x006C" },
    { L'\xEDA9', L"\x006F\xE05C\xE00D\x006C" },
    { L'\xEDAA', L"\x006F\xE05C\xE011\x006C" },
    { L'\xEDAB', L"\x006F\xE05C\xE000\x0072" },
    { L'\xEDAC', L"\x006F\xE05C\xE001\x0072" },
    { L'\xEDAD', L"\x006F\xE05C\xE002\x0072" },
    { L'\xEDAE', L"\x006F\xE05C\xE003\x0072" },
    { L'\xEDAF', L"\x006F\xE05C\xE004\x0072" },
    { L'\xEDB0', L"\x006F\xE05C\xE006\x0072" },
    { L'\xEDB1', L"\x006F\xE05C\xE00B\x0072" },
    { L'\xEDB2', L"\x006F\xE05C\xE00D\x0072" },
    { L'\xEDB3', L"\x006F\xE05C\xE011\x0072" },
    { L'\xEDB4', L"\x006F\xE061\x0075" },
    { L'\xEDB5', L"\x006F\xE060\x0252" },
    { L'\xEDB6', L"\x006F\xE028\xE060\x0259" },
    { L'\xEDB7', L"\xE131\xE060\x006F" },
    { L'\xEDB8', L"\x006F\xE061\x0061\xE001" },
    { L'\xEDB9', L"\x006F\xE001\xE061\x0061" },
    { L'\xEDBA', L"\x006F\xE028\xE061\x0061" },
    { L'\xEDBB', L"\x006F\xE061\x0065\xE011" },
    { L'\xEDBC', L"\x006F\xE061\x0069" },
    { L'\xEDBD', L"\x006F\xE05C\x0061" },
    { L'\xEDBE', L"\x006F\xE05C\x0061\xE003" },
    { L'\xEDBF', L"\x006F\xE003\xE05C\x0061\xE003" },
    { L'\xEDC0', L"\x006F\xE028\xE05C\x0061" },
    { L'\xEDC1', L"\x006F\xE028\xE061\x0069" },
    { L'\xEDC2', L"\x006F\xE003\xE061\x0065\xE011" },
    { L'\xEDC3', L"\x006F\xE05C\x004C" },
    { L'\xEDC4', L"\x006F\xE039\xE05C\x0075" },
    { L'\xEDC5', L"\x006F\xE05C\x0075" },
    { L'\xEDC6', L"\x006F\xE05C\x0065" },
    { L'\xEDC7', L"\x006F\x02D0\xE05C\x0061\xE025" },
    { L'\xEDC8', L"\x006F\x003A\xE05C\x0061\xE025" },
    { L'\xEDC9', L"\x006F\xE023\xE061\x0075\xE02F" },
    { L'\xEDCA', L"\x006F\xE039\xE061\x0075" },
    { L'\xEDE0', L"\x004F\xE05C\x004C" },
    { L'\xEDE1', L"\x004F\xE05C\x0052" },
    { L'\xEDE2', L"\x004F\xE0C4\xE001\x0065" },
    { L'\xEDE3', L"\x004F\xE0C4\xE006\x0065" },
    { L'\xEDE4', L"\x004F\xE061\x0061" },
    { L'\xEDE5', L"\x004F\xE061\x0069" },
    { L'\xEDE6', L"\x004F\xE05C\x0061" },
    { L'\xEDE7', L"\x004F\xE05C\x0069" },
    { L'\xEDE8', L"\x004F\xE008\xE05C\x0069" },
    { L'\xEDE9', L"\x004F\xE028\xE061\x0061" },
    { L'\xEDEA', L"\x004F\xE028\xE05C\x0061" },
    { L'\xEDEB', L"\x004F\xE039\xE05C\x0075" },
    { L'\xEE00', L"\x0075\xE05C\x0061" },
    { L'\xEE01', L"\x0075\xE02F\xE05C\x0061" },
    { L'\xEE02', L"\x0075\xE02F\xE05C\x0061\xE023" },
    { L'\xEE03', L"\x0075\xE061\x0259" },
    { L'\xEE04', L"\x0075\xE05C\x0259" },
    { L'\xEE05', L"\x0075\x02D0\xE05C\x0259" },
    { L'\xEE06', L"\x0075\x003A\xE05C\x0259" },
    { L'\xEE07', L"\x0075\xE000\xE05C\x0259" },
    { L'\xEE08', L"\x0075\xE000\x02D0\xE05C\x0259" },
    { L'\xEE09', L"\x0075\xE000\x003A\xE05C\x0259" },
    { L'\xEE0A', L"\x0075\xE001\xE05C\x0259" },
    { L'\xEE0B', L"\x0075\xE001\x02D0\xE05C\x0259" },
    { L'\xEE0C', L"\x0075\xE001\x003A\xE05C\x0259" },
    { L'\xEE0D', L"\x0075\xE02F\xE05C\x0259" },
    { L'\xEE0E', L"\x0075\xE05E\x006F" },
    { L'\xEE0F', L"\x0075\xE061\x006F" },
    { L'\xEE10', L"\x0075\xE05C\x006F" },
    { L'\xEE11', L"\x0075\xE061\xE0C5\x006F\xE0C6" },
    { L'\xEE12', L"\xE0C5\x0075\xE0C6\xE05C\x006F" },
    { L'\xEE12', L"\xE2EC\x0075\xE2ED\xE05C\x006F" },
    { L'\xEE13', L"\x0075\xE05C\x006F\xE000" },
    { L'\xEE14', L"\x0075\xE05C\x006F\xE001" },
    { L'\xEE15', L"\x0075\xE05C\x006F\xE001\xE023" },
    { L'\xEE16', L"\x0075\xE05C\x006F\xE003" },
    { L'\xEE17', L"\x0075\xE061\x006F\xE023" },
    { L'\xEE18', L"\x0075\xE05C\x006F\xE023" },
    { L'\xEE19', L"\x0075\xE061\x006F\xE039" },
    { L'\xEE1A', L"\xE0C5\x0075\xE0C6\xE05C\x006F\xE003" },
    { L'\xEE1A', L"\xE2EC\x0075\xE2ED\xE05C\x006F\xE003" },
    { L'\xEE1B', L"\x0075\xE000\xE05C\x006F" },
    { L'\xEE1C', L"\x0075\xE000\xE05C\x006F\xE023" },
    { L'\xEE1D', L"\x0075\xE000\xE05C\x006F\xE028" },
    { L'\xEE1E', L"\x0075\xE001\xE05C\x006F" },
    { L'\xEE1F', L"\x0075\xE003\xE05C\x006F" },
    { L'\xEE20', L"\x0075\xE02F\xE05C\x006F" },
    { L'\xEE21', L"\xE0C5\x0075\xE02F\xE0C6\xE05C\x006F" },
    { L'\xEE21', L"\xE2EC\x0075\xE02F\xE2ED\xE05C\x006F" },
    { L'\xEE22', L"\xE0C5\x0075\xE02F\xE0C6\xE05C\x006F\xE001" },
    { L'\xEE22', L"\xE2EC\x0075\xE02F\xE2ED\xE05C\x006F\xE001" },
    { L'\xEE23', L"\x0075\xE02F\xE05C\x006F\xE023" },
    { L'\xEE24', L"\x0075\xE05C\x0075\xE02F" },
    { L'\xEE25', L"\x0075\x02D0\xE061\x0075\xE02F" },
    { L'\xEE26', L"\x0075\x003A\xE061\x0075\xE02F" },
    { L'\xEE27', L"\x0075\x02D0\xE05C\x0075\xE02F" },
    { L'\xEE28', L"\x0075\x003A\xE05C\x0075\xE02F" },
    { L'\xEE29', L"\x0075\xE02F\xE061\x006F" },
    { L'\xEE2A', L"\x0075\xE02F\xE05F\x0069" },
    { L'\xEE2B', L"\x0075\xE05F\x0069\xE02F" },
    { L'\xEE2C', L"\x0075\xE05F\x006F" },
    { L'\xEE2D', L"\x0075\xE061\x0061" },
    { L'\xEE2E', L"\x0075\xE02F\xE061\x0061" },
    { L'\xEE2F', L"\x0075\xE02F\xE061\x006F\xE039" },
    { L'\xEE30', L"\x0075\xE05C\x006F\xE000\xE023" },
    { L'\xEE31', L"\xE0C5\x0075\xE0C6\xE05C\x006F\xE000" },
    { L'\xEE31', L"\xE2EC\x0075\xE2ED\xE05C\x006F\xE000" },
    { L'\xEE32', L"\x0075\xE037\xE05C\x0069" },
    { L'\xEE33', L"\x0075\xE05C\x0079" },
    { L'\xEE34', L"\x0075\xE061\x0075\xE02F" },
    { L'\xEE35', L"\x0075\xE061\xE0C5\x0061\xE0C6" },
    { L'\xEE36', L"\x0075\xE05C\x0061\xE000" },
    { L'\xEE37', L"\x0075\xE05C\x006F\xE003\xE023" },
    { L'\xEE38', L"\x0075\xE037\xE05C\x0131" },
    { L'\xEE39', L"\x0075\xE05C\x0061\xE023" },
    { L'\xEE3A', L"\x0075\xE05C\x0061\xE025" },
    { L'\xEE3B', L"\x0075\xE02F\xE061\x0061" },
    { L'\xEE3C', L"\x0075\xE061\xE0C5\x0075\xE02F\xE0C6" },
    { L'\xEE3C', L"\x0075\xE061\xE2EC\x0075\xE02F\xE2ED" },
    { L'\xEE3D', L"\x0075\xE0C8\xE0C5\x0069\xE02F\xE0C6\x0061\xE008" },
    { L'\xEE3D', L"\x0075\xE0C8\xE2EC\x0069\xE02F\xE2ED\x0061\xE008" },
    { L'\xEE3E', L"\x0075\xE05C\x0065" },
    { L'\xEE3F', L"\x0075\xE05C\x0069" },
    { L'\xEE40', L"\x0075\xE011\xE05C\x006F" },
    { L'\xEE41', L"\x0075\xE011\xE05C\x0259" },
    { L'\xEE42', L"\x0075\xE061\x0065" },
    { L'\xEE43', L"\xE0C5\x0075\xE0C6\xE061\x006F\xE023" },
    { L'\xEE43', L"\xE2EC\x0075\xE2ED\xE061\x006F\xE023" },
    { L'\xEE44', L"\x0075\xE02F\xE061\x006F\xE023" },
    { L'\xEE45', L"\xE0C5\x0075\xE02F\xE0C6\xE061\x006F\xE023" },
    { L'\xEE45', L"\xE2EC\x0075\xE02F\xE2ED\xE061\x006F\xE023" },
    { L'\xEE46', L"\x0075\xE061\xE0C5\x006F\xE023\xE0C6" },
    { L'\xEE46', L"\x0075\xE061\xE2EC\x006F\xE023\xE2ED" },
    { L'\xEE47', L"\x0075\xE037\xE05C\x006F" },
    { L'\xEE48', L"\x0075\xE05C\x044B" },
    { L'\xEE49', L"\x0075\xE061\xE0C5\x0069\xE02F\xE0C6" },
    { L'\xEE49', L"\x0075\xE061\xE2EC\x0069\xE02F\xE2ED" },
    { L'\xEE4A', L"\x0075\xE02F\xE061\x006F\xE025" },
    { L'\xEE4B', L"\xE0C5\x0075\xE0C6\xE061\x0061\xE025" },
    { L'\xEE4B', L"\xE2EC\x0075\xE2EC\xE061\x0061\xE025" },
    { L'\xEE4C', L"\xE0C5\x0075\xE02F\xE0C6\xE061\x0061" },
    { L'\xEE4C', L"\xE2EC\x0075\xE02F\xE2ED\xE061\x0061" },
    { L'\xEE4D', L"\xE0C5\x0075\xE02F\xE0C6\xE061\x006F\xE039" },
    { L'\xEE4D', L"\xE2EC\x0075\xE02F\xE2ED\xE061\x006F\xE039" },
    { L'\xEE4E', L"\xE0C5\x0075\xE0C6\xE061\x006F\xE039" },
    { L'\xEE4E', L"\xE2EC\x0075\xE2ED\xE061\x006F\xE039" },
    { L'\xEE4F', L"\x0075\xE061\x0061\xE025" },
    { L'\xEE50', L"\x0075\xE061\xE0C5\x0259\xE0C6" },
    { L'\xEE50', L"\x0075\xE061\xE2EC\x0259\xE2ED" },
    { L'\xEE51', L"\x0075\xE02F\xE061\x0259" },
    { L'\xEE52', L"\x0075\xE008\xE061\x0069\xE02F" },
    { L'\xEE53', L"\xE0C5\x0075\xE02F\xE0C6\xE061\x0061\xE025" },
    { L'\xEE53', L"\xE2EC\x0075\xE02F\xE2ED\xE061\x0061\xE025" },
    { L'\xEE54', L"\xE0C5\x0075\xE0C6\xE061\x0061" },
    { L'\xEE54', L"\xE2EC\x0075\xE2ED\xE061\x0061" },
    { L'\xEE55', L"\x0075\xE061\x0061\xE023" },
    { L'\xEE56', L"\x0075\xE02F\xE061\x0061\xE008" },
    { L'\xEE7D', L"\x0079\xE061\x0065" },
    { L'\xEE7E', L"\x0079\xE05C\x006F" },
    { L'\xEE7F', L"\x0079\xE05C\x0075" },
    { L'\xEE80', L"\x044A\xE05C\x006C" },
    { L'\xEE81', L"\x044A\xE05C\x0072" },
    { L'\xEE82', L"\x044A\xE05C\x0052" },
    { L'\xEE83', L"\x044C\xE05C\x006C" },
    { L'\xEE84', L"\x044C\xE05C\x0072" },
    { L'\xEE85', L"\x044C\xE05C\x0052" },
    { L'\xEE86', L"\x044A\xE05C\xE000\x006C" },
    { L'\xEE87', L"\x044A\xE05C\xE001\x006C" },
    { L'\xEE88', L"\x044A\xE05C\xE002\x006C" },
    { L'\xEE89', L"\x044A\xE05C\xE003\x006C" },
    { L'\xEE8A', L"\x044A\xE05C\xE004\x006C" },
    { L'\xEE8B', L"\x044A\xE05C\xE006\x006C" },
    { L'\xEE8C', L"\x044A\xE05C\xE00B\x006C" },
    { L'\xEE8D', L"\x044A\xE05C\xE00D\x006C" },
    { L'\xEE8E', L"\x044A\xE05C\xE011\x006C" },
    { L'\xEE8F', L"\x044A\xE05C\xE000\x0072" },
    { L'\xEE90', L"\x044A\xE05C\xE001\x0072" },
    { L'\xEE91', L"\x044A\xE05C\xE002\x0072" },
    { L'\xEE92', L"\x044A\xE05C\xE003\x0072" },
    { L'\xEE93', L"\x044A\xE05C\xE004\x0072" },
    { L'\xEE94', L"\x044A\xE05C\xE006\x0072" },
    { L'\xEE95', L"\x044A\xE05C\xE00B\x0072" },
    { L'\xEE96', L"\x044A\xE05C\xE00D\x0072" },
    { L'\xEE97', L"\x044A\xE05C\xE011\x0072" },
    { L'\xEE98', L"\x044C\xE05C\xE000\x006C" },
    { L'\xEE99', L"\x044C\xE05C\xE001\x006C" },
    { L'\xEE9A', L"\x044C\xE05C\xE002\x006C" },
    { L'\xEE9B', L"\x044C\xE05C\xE003\x006C" },
    { L'\xEE9C', L"\x044C\xE05C\xE004\x006C" },
    { L'\xEE9D', L"\x044C\xE05C\xE006\x006C" },
    { L'\xEE9E', L"\x044C\xE05C\xE00B\x006C" },
    { L'\xEE9F', L"\x044C\xE05C\xE00D\x006C" },
    { L'\xEEA0', L"\x0079\xE05C\x0065" },
    { L'\xEEA1', L"\x044C\xE05C\xE011\x006C" },
    { L'\xEEA2', L"\x044C\xE05C\xE000\x0072" },
    { L'\xEEA3', L"\x044C\xE05C\xE001\x0072" },
    { L'\xEEA4', L"\x044C\xE05C\xE002\x0072" },
    { L'\xEEA5', L"\x044C\xE05C\xE003\x0072" },
    { L'\xEEA6', L"\x044C\xE05C\xE004\x0072" },
    { L'\xEEA7', L"\x044C\xE05C\xE006\x0072" },
    { L'\xEEA8', L"\x044C\xE05C\xE00B\x0072" },
    { L'\xEEA9', L"\x044C\xE05C\xE00D\x0072" },
    { L'\xEEAA', L"\x044C\xE05C\xE011\x0072" },
    { L'\xEEB0', L"\x042A\xE05C\x0052" },
    { L'\xEEB1', L"\x042C\xE05C\x0052" },
    { L'\xEEB2', L"\x042A\xE05C\x004C" },
    { L'\xEEB3', L"\x042C\xE05C\x004C" },
    { L'\xEEC0', L"\x0063\xE00C\xE05C\x0063\xE00C" },
    { L'\xEEC1', L"\x0064\xE05C\x006C" },
    { L'\xEEC2', L"\x0064\xE05E\x007A" },
    { L'\xEEC3', L"\x0064\xE061\x007A" },
    { L'\xEEC4', L"\x0064\xE05E\x007A\xE00C" },
    { L'\xEEC5', L"\x0073\xE05C\x0073" },
    { L'\xEEC6', L"\x0073\x2019\xE05C\x0073" },
    { L'\xEEC7', L"\x0073\xE00C\xE05C\x0074\xE001" },
    { L'\xEEC8', L"\x0074\xE05C\x006A" },
    { L'\xEEC9', L"\x0074\xE061\x0073" },
    { L'\xEECA', L"\x0074\xE05C\x0073" },
    { L'\xEECB', L"\x0074\x2019\xE05C\x0073\xE00C" },
    { L'\xEECC', L"\x0074\xE05C\x017F\xE0A2" },
    { L'\xEECC', L"\x0074\xE05C\x0283" },
    { L'\xEECD', L"\x007A\xE05C\x007A" },
    { L'\xEECE', L"\x007A\xE00C\xE05C\x0064\xE001" },
    { L'\xEECF', L"\x0064\x2019\xE061\x007A" },
    { L'\xEED0', L"\x0063\xE060\x0065" },
    { L'\xEED1', L"\x0063\xE060\x006F" },
    { L'\xEED2', L"\x0074\xE05C\x0255" },
    { L'\xEED3', L"\x0063\xE05F\x0068" },
    { L'\xEED4', L"\x0064\xE05F\x007A" },
    { L'\xEED5', L"\x0064\xE05F\x007A\xE001" },
    { L'\xEED6', L"\x0064\xE05F\x007A\xE00C" },
    { L'\xEED7', L"\x0064\xE05F\x0292" },
    { L'\xEED8', L"\x006A\xE05F\x0061" },
    { L'\xEED9', L"\x006A\xE05F\x0061\xE008" },
    { L'\xEEDA', L"\x006A\xE05F\x0065" },
    { L'\xEEDB', L"\x006A\xE05F\x0065\xE028" },
    { L'\xEEDC', L"\x006A\xE05F\x0069" },
    { L'\xEEDD', L"\x006A\xE05F\x006F\xE028" },
    { L'\xEEDE', L"\x006A\xE05F\x0075" },
    { L'\xEEDF', L"\x006A\xE05F\x0075\xE008" },
    { L'\xEEE0', L"\x006B\xE05F\x0073" },
    { L'\xEEE1', L"\x006B\xE05F\x0078" },
    { L'\xEEE2', L"\x006C\xE05F\x006A" },
    { L'\xEEE3', L"\x006E\xE05F\x0067" },
    { L'\xEEE4', L"\x006E\xE0A2\xE05F\x0067" },
    { L'\xEEE4', L"\x014B\xE05F\x0067" },
    { L'\xEEE5', L"\x006E\xE05F\x006A" },
    { L'\xEEE6', L"\x0070\xE05F\x0066" },
    { L'\xEEE7', L"\x0070\xE05F\x0068" },
    { L'\xEEE8', L"\x0070\xE05F\x0073" },
    { L'\xEEE9', L"\x0073\xE00C\xE05F\x0063\xE00C" },
    { L'\xEEEA', L"\x0073\xE00C\xE05F\x0074" },
    { L'\xEEEB', L"\x0074\xE05F\x0068" },
    { L'\xEEEC', L"\x0074\xE05F\x0073" },
    { L'\xEEED', L"\x0074\xE05F\x0073\xE001" },
    { L'\xEEEE', L"\x0074\xE05F\x017F\xE0A2" },
    { L'\xEEEE', L"\x0074\xE05F\x0283" },
    { L'\xEEEF', L"\x0062\xE05C\x0076" },
    { L'\xEEF0', L"\x0070\xE061\x0066" },
    { L'\xEEF1', L"\x0070\xE05C\x0066" },
    { L'\xEEF2', L"\x0064\xE05C\x0292" },
    { L'\xEEF3', L"\x0063\xE05C\x0068" },
    { L'\xEEF4', L"\x006E\xE061\x0067" },
    { L'\xEEF5', L"\x0073\xE05C\x0068" },
    { L'\xEEF6', L"\x0074\xE05C\x0068" },
    { L'\xEEF7', L"\x0073\xE061\x0072" },
    { L'\xEEF8', L"\x1D0B\xE05C\x029C" },
    { L'\xEEF9', L"\x007A\xE05C\x0068" },
    { L'\xEEFA', L"\x006A\xE061\x0067" },
    { L'\xEEFB', L"\x006E\xE05C\x0067" },
    { L'\xEEFC', L"\x0067\xE05C\x006C" },
    { L'\xEEFD', L"\x0067\xE061\x006E" },
    { L'\xEEFE', L"\x0072\xE061\x0259" },
    { L'\xEF00', L"\x0263\xE025" },
    { L'\xEF01', L"\x0263\xE030" },
    { L'\xEF02', L"\x0067\xE054" },
    { L'\xEF03', L"\x0261\xE054" },
    { L'\xEF04', L"\x03B3\xE011" },
    { L'\xEF05', L"\x0067\xE015" },
    { L'\xEF05', L"\x0067\xE0C4\x2019" },
    { L'\xEF06', L"\x03B3\xE015" },
    { L'\xEF06', L"\x03B3\xE0C4\x2019" },
    { L'\xEF07', L"\x0067\xE000" },
    { L'\xEF08', L"\x0067\xE007\xE023" },
    { L'\xEF09', L"\x0067\xE028" },
    { L'\xEF0A', L"\x0067\xE02E" },
    { L'\xEF0B', L"\x0067\xE025" },
    { L'\xEF0C', L"\x03B3\xE003" },
    { L'\xEF10', L"\x007A\xE00B" },
    { L'\xEF11', L"\x007A\xE025" },
    { L'\xEF12', L"\x007A\xE030" },
    { L'\xEF13', L"\x0292\xE00A" },
    { L'\xEF14', L"\x0292\xE025" },
    { L'\xEF15', L"\x0292\xE030" },
    { L'\xEF16', L"\x0437\xE00C" },
    { L'\xEF17', L"\x007A\xE013" },
    { L'\xEF18', L"\x0292\xE00B" },
    { L'\xEF19', L"\x007A\xE00C\xE0C0" },
    { L'\xEF1A', L"\x007A\xE00C\xE02F" },
    { L'\xEF1B', L"\x007A\xE006\xE00C" },
    { L'\xEF1C', L"\x007A\xE015" },
    { L'\xEF1C', L"\x007A\xE0C4\x2019" },
    { L'\xEF1D', L"\x0292\xE015" },
    { L'\xEF1D', L"\x0292\xE0C4\x2019" },
    { L'\xEF1E', L"\x007A\xE00C\xE015" },
    { L'\xEF1E', L"\x007A\xE00C\xE0C4\x2019" },
    { L'\xEF1F', L"\x0292\xE00C\xE015" },
    { L'\xEF1F', L"\x0292\xE00C\xE0C4\x2019" },
    { L'\xEF20', L"\x0295\xE025" },
    { L'\xEF21', L"\x0295\xE030" },
    { L'\xEF30', L"\x0073\xE00C\xE0C0" },
    { L'\xEF31', L"\x0073\xE013" },
    { L'\xEF32', L"\x0073\xE014" },
    { L'\xEF33', L"\x0073\xE085" },
    { L'\xEF34', L"\x0073\xE086" },
    { L'\xEF35', L"\x0073\xE054" },
    { L'\xEF36', L"\x0073\xE015" },
    { L'\xEF36', L"\x0073\xE0C4\x2019" },
    { L'\xEF37', L"\x0073\xE00C\xE015" },
    { L'\xEF37', L"\x0073\xE00C\xE0C4\x2019" },
    { L'\xEF38', L"\x0073\xE0B0" },
    { L'\xEF38', L"\x2019\xE0C4\x0073" },
    { L'\xEF39', L"\x017F\xE0B0" },
    { L'\xEF39', L"\x2019\xE0C4\x017F" },
    { L'\xEF3A', L"\x0283\xE0B0" },
    { L'\xEF3A', L"\x2019\xE0C4\x0283" },
    { L'\xEF3B', L"\x00DF\xE004" },
    { L'\xEF3C', L"\x00DF\xE007" },
    { L'\xEF3D', L"\x00DF\xE00C" },
    { L'\xEF3E', L"\x0073\xE008" },
    { L'\xEF3F', L"\x0073\xE029" },
    { L'\xEF40', L"\x0056\xE02C" },
    { L'\xEF41', L"\x0056\xE004\xE001" },
    { L'\xEF42', L"\x0056\xE004\xE006\xE001" },
    { L'\xEF43', L"\x0056\xE004\xE003" },
    { L'\xEF44', L"\x0056\xE00D" },
    { L'\xEF45', L"\x0056\xE065" },
    { L'\xEF46', L"\x0056\xE00A" },
    { L'\xEF47', L"\x0056\xE02F" },
    { L'\xEF48', L"\x0056\xE004\xE00D" },
    { L'\xEF49', L"\x0056\xE004\xE002" },
    { L'\xEF4A', L"\x0056\xE004\xE00B" },
    { L'\xEF4B', L"\x0056\xE004\xE011" },
    { L'\xEF4C', L"\x0056\xE006\xE00F" },
    { L'\xEF4D', L"\x0056\xE006\xE000" },
    { L'\xEF4E', L"\x0056\xE006\xE00D" },
    { L'\xEF4F', L"\x0056\xE007" },
    { L'\xEF50', L"\x006B\xE001\xE025" },
    { L'\xEF51', L"\x006B\xE015" },
    { L'\xEF51', L"\x006B\xE0C4\x2019" },
    { L'\xEF52', L"\x006B\xE082" },
    { L'\xEF53', L"\x006B\xE035" },
    { L'\xEF58', L"\x0056\xE01C" },
    { L'\xEF59', L"\x0056\xE016" },
    { L'\xEF5A', L"\x0056\xE017" },
    { L'\xEF5B', L"\x0056\xE031" },
    { L'\xEF5C', L"\x0056\xE008" },
    { L'\xEF5D', L"\x0056\xE039" },
    { L'\xEF5E', L"\x0056\xE02D" },
    { L'\xEF5F', L"\x0056\xE024" },
    { L'\xEF60', L"\x0280\xE015" },
    { L'\xEF60', L"\x0280\xE0C4\x2019" },
    { L'\xEF61', L"\x0072\xE004\xE000\xE025" },
    { L'\xEF62', L"\x0072\xE011\xE00F" },
    { L'\xEF63', L"\x0072\xE00F\xE011" },
    { L'\xEF64', L"\x0072\xE004\xE00D" },
    { L'\xEF65', L"\x0072\xE00A\xE00F" },
    { L'\xEF66', L"\x0072\xE00A\xE011" },
    { L'\xEF67', L"\x0072\xE006\xE025" },
    { L'\xEF68', L"\x0072\xE006\xE001\xE025" },
    { L'\xEF69', L"\x0072\xE00B\xE025" },
    { L'\xEF6A', L"\x0072\xE027" },
    { L'\xEF6B', L"\x0280\xE02E" },
    { L'\xEF6C', L"\x0072\xE093\xE023" },
    { L'\xEF6D', L"\x0072\xE028" },
    { L'\xEF6E', L"\x0072\xE00A" },
    { L'\xEF6F', L"\x0072\xE02E" },
    { L'\xEF70', L"\x0437\xE001" },
    { L'\xEF71', L"\x007A\xE00C\xE023" },
    { L'\xEF72', L"\x0292\xE001\xE02C" },
    { L'\xEF73', L"\x0292\xE00C\xE02C" },
    { L'\xEF74', L"\x0292\xE00C\xE023" },
    { L'\xEF75', L"\x0292\xE023" },
    { L'\xEF76', L"\x007A\xE068" },
    { L'\xEF77', L"\x007A\xE006" },
    { L'\xEF78', L"\x0292\xE02D" },
    { L'\xEF79', L"\x0292\xE001\xE02D" },
    { L'\xEF7A', L"\x0292\xE00C\xE02D" },
    { L'\xEF7B', L"\x0292\xE00C\xE00D\xE02D" },
    { L'\xEF7C', L"\x01B7\xE02D" },
    { L'\xEF7D', L"\x01B7\xE001\xE02D" },
    { L'\xEF7E', L"\x01B7\xE00C\xE02D" },
    { L'\xEF7F', L"\x01B7\xE00C\xE00D\xE02D" },
    { L'\xEF80', L"\x006D\xE002\xE025" },
    { L'\xEF81', L"\x006D\xE00D\xE025" },
    { L'\xEF82', L"\x026F\xE023" },
    { L'\xEF83', L"\x026F\xE004\xE006" },
    { L'\xEF84', L"\x026F\xE039" },
    { L'\xEF85', L"\x006D\xE00F\xE025" },
    { L'\xEF90', L"\x006E\xE00D\xE025" },
    { L'\xEF91', L"\x006E\xE064" },
    { L'\xEF92', L"\x006E\xE004\xE023" },
    { L'\xEF93', L"\x006E\xE00A" },
    { L'\xEF94', L"\x014B\xE003" },
    { L'\xEF95', L"\x014B\xE007" },
    { L'\xEF96', L"\x014B\xE008" },
    { L'\xEF97', L"\x006E\xE013" },
    { L'\xEF98', L"\xE105\xE000\xE025" },
    { L'\xEF99', L"\x006E\xE02E" },
    { L'\xEFA0', L"\x0077\xE006" },
    { L'\xEFA1', L"\x0077\xE028" },
    { L'\xEFA2', L"\x0077\xE02C" },
    { L'\xEFAF', L"\x0057\xE00A" },
    { L'\xEFB0', L"\x0063\xE025" },
    { L'\xEFB1', L"\x0063\xE02C" },
    { L'\xEFB2', L"\x0063\xE006" },
    { L'\xEFB3', L"\x0063\xE064" },
    { L'\xEFC0', L"\x03C7\xE007" },
    { L'\xEFC1', L"\x0068\xE030" },
    { L'\xEFC2', L"\x0068\xE007\xE023" },
    { L'\xEFC3', L"\x03C7\xE002" },
    { L'\xEFC4', L"\x03C7\xE003" },
    { L'\xEFD0', L"\x03BB\xE025" },
    { L'\xEFD1', L"\x006C\xE004\xE00C\xE023" },
    { L'\xEFD2', L"\x006C\xE037\xE000\xE025" },
    { L'\xEFD3', L"\x006C\xE037\xE002\xE025" },
    { L'\xEFD4', L"\x006C\xE007" },
    { L'\xEFD5', L"\x006C\xE028" },
    { L'\xEFD6', L"\x006C\xE0BE" },
    { L'\xEFD7', L"\x006C\xE004\xE006\xE025" },
    { L'\xEFD8', L"\x006C\xE006\xE023" },
    { L'\xEFD9', L"\x006C\xE02E" },
    { L'\xEFDA', L"\x006C\xE004\xE00D\xE025" },
    { L'\xEFDB', L"\x006C\xE037\xE023" },
    { L'\xEFDC', L"\x006c\xE02A" },
    { L'\xEFDD', L"\x006C\xE037\xE00F\xE025" },
    { L'\xEFDE', L"\x006C\xE002\xE026" },
    { L'\xEFE0', L"\x0073\xE028" },
    { L'\xEFE1', L"\x0073\xE0A3" },
    { L'\xEFE2', L"\x03C3\xE00C" },
    { L'\xEFE3', L"\x017F\xE004" },
    { L'\xEFE4', L"\x0073\xE006" },
    { L'\xEFE5', L"\x0073\xE02F" },
    { L'\xEFE6', L"\x0073\xE00C\xE02C" },
    { L'\xEFEC', L"\x004F\xE0C4\x004C\xE0C4\x0041" },
    { L'\xEFED', L"\x041E\xE0C4\x041B\xE0C4\x0410" },
    { L'\xEFEE', L"\x0049\xE0C4\x0053\xE0C4\x004A" },
    { L'\xEFEE', L"\x005B\xE0C4\x0049\xE0C4\x0053\xE0C4\x004A" },
    { L'\xEFEF', L"\x0053\xE0C4\x004C\xE0C4\x0041" },
    { L'\xEFF0', L"\x0074\xE02E" },
    { L'\xEFF1', L"\x0074\xE0C4\x0073\xE02E" },
    { L'\xEFF2', L"\x0074\xE0C4\x017F\xE0A2\xE02E" },
    { L'\xEFF2', L"\x0074\xE0C4\x0283\xE02E" },
    { L'\xEFF3', L"\x0074\xE0C4\x0063\xE0A5\xE02E" },
    { L'\xEFF3', L"\x0074\xE0C4\x0255\xE02E" },
    { L'\xEFF4', L"\x0074\xE006" },
    { L'\xEFF5', L"\x0074\xE003" },
    { L'\xEFF6', L"\x0074\xE001\xE02C" },
    { L'\xEFF9', L"\x0054\xE001" },
    { L'\xF100', L"\x0430\xE000" },
    { L'\xF101', L"\x0430\xE001" },
    { L'\xF102', L"\x0430\xE002" },
    { L'\xF103', L"\x0430\xE004" },
    { L'\xF104', L"\x0430\xE008\xE004" },
    { L'\xF105', L"\x0430\xE023" },
    { L'\xF106', L"\x0430\xE004\xE006" },
    { L'\xF107', L"\x0430\xE006\xE001" },
    { L'\xF108', L"\x0430\xE008\xE001" },
    { L'\xF109', L"\x0430\xE00C" },
    { L'\xF10A', L"\x0430\xE004\xE001" },
    { L'\xF10B', L"\x0430\xE00A\xE004" },
    { L'\xF10C', L"\x0430\xE00A\xE001" },
    { L'\xF10D', L"\x0430\xE00F" },
    { L'\xF10E', L"\x0430\xE011" },
    { L'\xF10F', L"\x0430\xE00D" },
    { L'\xF110', L"\x0430\xE00A" },
    { L'\xF111', L"\x0430\xE028" },
    { L'\xF112', L"\x0430\xE003" },
    { L'\xF113', L"\x0430\xE025" },
    { L'\xF114', L"\x0430\xE008\xE006" },
    { L'\xF115', L"\x0430\xE004\xE024" },
    { L'\xF116', L"\x0430\xE00F\xE024" },
    { L'\xF117', L"\x0430\xE011\xE024" },
    { L'\xF118', L"\x0430\xE07A" },
    { L'\xF119', L"\x0430\xE00A\xE011" },
    { L'\xF140', L"\x0410\xE000" },
    { L'\xF141', L"\x0410\xE001" },
    { L'\xF142', L"\x0410\xE004" },
    { L'\xF143', L"\x0410\xE00F" },
    { L'\xF144', L"\x0410\xE004\xE001" },
    { L'\xF145', L"\x0410\xE011" },
    { L'\xF146', L"\x0410\xE023" },
    { L'\xF147', L"\x0410\xE00A" },
    { L'\xF148', L"\x0410\xE028" },
    { L'\xF149', L"\x0410\xE00D" },
    { L'\xF150', L"\x0435\xE001" },
    { L'\xF151', L"\x0435\xE002" },
    { L'\xF152', L"\x0435\xE002\xE001\xE004" },
    { L'\xF153', L"\x0435\xE002\xE007" },
    { L'\xF154', L"\x0435\xE004" },
    { L'\xF155', L"\x0435\xE007" },
    { L'\xF156', L"\x0435\xE008\xE001" },
    { L'\xF157', L"\x0435\xE00C" },
    { L'\xF158', L"\x0435\xE023" },
    { L'\xF159', L"\x0435\xE025" },
    { L'\xF15A', L"\x0435\xE000\xE023" },
    { L'\xF15B', L"\x0435\xE001\xE023" },
    { L'\xF15C', L"\x0435\xE002\xE001" },
    { L'\xF15D', L"\x0435\xE004\xE006" },
    { L'\xF15E', L"\x0435\xE004\xE023" },
    { L'\xF15F', L"\x0435\xE00F\xE023" },
    { L'\xF160', L"\x0435\xE011\xE023" },
    { L'\xF161', L"\x0435\xE008\xE000" },
    { L'\xF162', L"\x0435\xE004\xE001" },
    { L'\xF163', L"\x0435\xE007\xE001" },
    { L'\xF164', L"\x0435\xE00F" },
    { L'\xF165', L"\x0435\xE011" },
    { L'\xF166', L"\x0435\xE00D" },
    { L'\xF167', L"\x0435\xE028" },
    { L'\xF168', L"\x0435\xE008\xE004" },
    { L'\xF169', L"\x0435\xE00F\xE039" },
    { L'\xF16A', L"\x0435\xE006\xE023" },
    { L'\xF16B', L"\x0435\xE003\xE023" },
    { L'\xF16C', L"\x0435\xE011\xE039" },
    { L'\xF16D', L"\x0435\xE028\xE006" },
    { L'\xF16E', L"\x0435\xE028\xE011" },
    { L'\xF16F', L"\x0435\xE028\xE004" },
    { L'\xF170', L"\x0435\xE028\xE00F" },
    { L'\xF171', L"\x0435\xE008\xE00D" },
    { L'\xF172', L"\x0435\xE002\xE000" },
    { L'\xF1A0', L"\x0415\xE001" },
    { L'\xF1A1', L"\x0415\xE004" },
    { L'\xF1A2', L"\x0415\xE008\xE000" },
    { L'\xF1A3', L"\x0415\xE008\xE001" },
    { L'\xF1A4', L"\x0415\xE00F" },
    { L'\xF1A5', L"\x0415\xE011" },
    { L'\xF1A6', L"\x0415\xE023" },
    { L'\xF1A7', L"\x0415\xE028" },
    { L'\xF1A8', L"\x0415\xE008\xE004" },
    { L'\xF1A9', L"\x0415\xE00D" },
    { L'\xF1AA', L"\x0415\xE008\xE00D" },
    { L'\xF1AB', L"\x0404\xE00D" },
    { L'\xF1AC', L"\x042D\xE00D" },
    { L'\xF1B0', L"\x0438\xE001" },
    { L'\xF1B1', L"\x0438\xE006\xE02D" },
    { L'\xF1B2', L"\x0438\xE00C" },
    { L'\xF1B3', L"\x0456\xE001" },
    { L'\xF1B4', L"\x0456\xE003" },
    { L'\xF1B5', L"\x0456\xE02F" },
    { L'\xF1B6', L"\x0456\xE008\xE000" },
    { L'\xF1B7', L"\x0456\xE008\xE001" },
    { L'\xF1B8', L"\x0438\xE004\xE001" },
    { L'\xF1B9', L"\x0438\xE02F" },
    { L'\xF1BA', L"\x0456\xE02D" },
    { L'\xF1BB', L"\x0438\xE02D" },
    { L'\xF1BC', L"\x0438\xE00F" },
    { L'\xF1BD', L"\x0438\xE011" },
    { L'\xF1BE', L"\x0438\xE00D" },
    { L'\xF1BF', L"\x0456\xE008\xE00D" },
    { L'\xF1C0', L"\x0438\xE00A" },
    { L'\xF1C1', L"\x0456\xE004" },
    { L'\xF1C2', L"\x0456\xE000" },
    { L'\xF1C3', L"\x0456\xE002" },
    { L'\xF1C4', L"\x0456\xE00F" },
    { L'\xF1C5', L"\x0438\xE002" },
    { L'\xF1C6', L"\x0438\xE064" },
    { L'\xF1C7', L"\x0438\xE008\xE004" },
    { L'\xF1C8', L"\x0438\xE003" },
    { L'\xF1F0', L"\x0418\xE001" },
    { L'\xF1F1', L"\x0418\xE002" },
    { L'\xF1F2', L"\x0406\xE008\xE000" },
    { L'\xF1F3', L"\x0406\xE008\xE001" },
    { L'\xF1F4', L"\x0418\xE00F" },
    { L'\xF1F5', L"\x0418\xE011" },
    { L'\xF1F6', L"\x0406\xE02F" },
    { L'\xF1F7', L"\x0418\xE00A" },
    { L'\xF1F8', L"\x0406\xE004" },
    { L'\xF1F9', L"\x0418\xE00D" },
    { L'\xF200', L"\x043E\xE000" },
    { L'\xF201', L"\x043E\xE001" },
    { L'\xF202', L"\x043E\xE002" },
    { L'\xF203', L"\x043E\xE002\xE001" },
    { L'\xF204', L"\x043E\xE002\xE007" },
    { L'\xF205', L"\x043E\xE004" },
    { L'\xF206', L"\x043E\xE007" },
    { L'\xF207', L"\x043E\xE023" },
    { L'\xF208', L"\x043E\xE006" },
    { L'\xF209', L"\x043E\xE011" },
    { L'\xF20A', L"\x043E\xE004\xE001" },
    { L'\xF20B', L"\x043E\xE007\xE001" },
    { L'\xF20C', L"\x043E\xE00F" },
    { L'\xF20D', L"\x043E\xE003" },
    { L'\xF20E', L"\x043E\xE00D" },
    { L'\xF20F', L"\x043E\xE037" },
    { L'\xF210', L"\x043E\xE028" },
    { L'\xF211', L"\x043E\xE003\xE023" },
    { L'\xF212', L"\x043E\xE001\xE039" },
    { L'\xF213', L"\x043E\xE004\xE039" },
    { L'\xF214', L"\x043E\xE008\xE004" },
    { L'\xF215', L"\x043E\xE004\xE023" },
    { L'\xF216', L"\x043E\xE006\xE023" },
    { L'\xF217', L"\x043E\xE028\xE003" },
    { L'\xF218', L"\x043E\xE028\xE006" },
    { L'\xF219', L"\x043E\xE011\xE023" },
    { L'\xF21A', L"\x043E\xE00C" },
    { L'\xF240', L"\x041E\xE000" },
    { L'\xF241', L"\x041E\xE001" },
    { L'\xF242', L"\x041E\xE004" },
    { L'\xF243', L"\x041E\xE00F" },
    { L'\xF244', L"\x041E\xE011" },
    { L'\xF245', L"\x041E\xE023" },
    { L'\xF246', L"\x041E\xE037" },
    { L'\xF247', L"\x041E\xE028" },
    { L'\xF248', L"\x041E\xE006" },
    { L'\xF249', L"\x041E\xE00D" },
    { L'\xF250', L"\x0443\xE000" },
    { L'\xF251', L"\x0443\xE001" },
    { L'\xF252', L"\x0443\xE008\xE001" },
    { L'\xF253', L"\x0443\xE02D" },
    { L'\xF254', L"\x0443\xE037" },
    { L'\xF255', L"\x0443\xE002" },
    { L'\xF256', L"\x0443\xE004\xE006" },
    { L'\xF257', L"\x0223\xE003" },
    { L'\xF258', L"\x0443\xE004\xE001" },
    { L'\xF259', L"\x0443\xE02F" },
    { L'\xF25A', L"\x0443\xE00F" },
    { L'\xF25B', L"\x0443\xE011" },
    { L'\xF25C', L"\x0443\xE00D" },
    { L'\xF25D', L"\x0443\xE008\xE02F" },
    { L'\xF25E', L"\x0443\xE00A" },
    { L'\xF25F', L"\x0443\xE00C" },
    { L'\xF290', L"\x0423\xE000" },
    { L'\xF291', L"\x0423\xE001" },
    { L'\xF292', L"\x0222\xE003" },
    { L'\xF293', L"\x0423\xE00F" },
    { L'\xF294', L"\x0423\xE011" },
    { L'\xF295', L"\x0423\xE00D" },
    { L'\xF2A0', L"\x0431\xE004" },
    { L'\xF2A1', L"\x0431\xE02C" },
    { L'\xF2A2', L"\x0431\xE02D" },
    { L'\xF2A3', L"\x0431\xE001" },
    { L'\xF2A4', L"\x0431\xE09A" },
    { L'\xF2B0', L"\x0432\xE004" },
    { L'\xF2B1', L"\x0432\xE025" },
    { L'\xF2B2', L"\x0432\xE02C" },
    { L'\xF2B3', L"\x0432\xE02F" },
    { L'\xF2B4', L"\x0432\xE02D" },
    { L'\xF2B9', L"\x0412\xE003" },
    { L'\xF2BA', L"\x0412\xE000" },
    { L'\xF2BB', L"\x0412\xE001" },
    { L'\xF2BC', L"\x0412\xE004" },
    { L'\xF2BD', L"\x0412\xE006" },
    { L'\xF2BE', L"\x0412\xE00F" },
    { L'\xF2BF', L"\x0412\xE011" },
    { L'\xF2C0', L"\x0433\xE02C" },
    { L'\xF2C1', L"\x0433\xE02D" },
    { L'\xF2D0', L"\x0434\xE004" },
    { L'\xF2D1', L"\x0434\xE02C" },
    { L'\xF2D2', L"\x0434\xE02D" },
    { L'\xF2D3', L"\x0434\xE001" },
    { L'\xF2D4', L"\x0434\xE025" },
    { L'\xF2D5', L"\x0452\xE02C" },
    { L'\xF2E0', L"\x0436\xE004" },
    { L'\xF2E1', L"\x0436\xE02C" },
    { L'\xF2E2', L"\x0436\xE02D" },
    { L'\xF2E3', L"\x0436\xE001" },
    { L'\xF2E4', L"\x0436\xE023" },
    { L'\xF2EF', L"\x0416\xE023" },
    { L'\xF2F0', L"\x0437\xE004" },
    { L'\xF2F1', L"\x0437\xE02D" },
    { L'\xF2F2', L"\x0437\xE02C" },
    { L'\xF300', L"\x043A\xE002" },
    { L'\xF301', L"\x043A\xE004" },
    { L'\xF310', L"\x043B\xE004" },
    { L'\xF311', L"\x043B\xE025" },
    { L'\xF312', L"\x043B\xE02D" },
    { L'\xF313', L"\x043B\xE003" },
    { L'\xF314', L"\x043B\xE001\xE025" },
    { L'\xF315', L"\x043B\xE02F" },
    { L'\xF316', L"\x043B\xE023" },
    { L'\xF317', L"\x043B\xE035" },
    { L'\xF318', L"\x043B\xE00D\xE025" },
    { L'\xF31F', L"\x041B\xE025" },
    { L'\xF320', L"\x043C\xE004" },
    { L'\xF321', L"\x043C\xE02D" },
    { L'\xF322', L"\x043C\xE001" },
    { L'\xF330', L"\x043D\xE004" },
    { L'\xF331', L"\x043D\xE025" },
    { L'\xF332', L"\x043D\xE02D" },
    { L'\xF333', L"\x043D\xE011" },
    { L'\xF340', L"\x043F\xE002" },
    { L'\xF341', L"\x043F\xE004" },
    { L'\xF342', L"\x043F\xE001" },
    { L'\xF350', L"\x0440\xE000" },
    { L'\xF351', L"\x0440\xE001" },
    { L'\xF352', L"\x0440\xE004" },
    { L'\xF353', L"\x0440\xE00F" },
    { L'\xF354', L"\x0440\xE011" },
    { L'\xF355', L"\x0440\xE025" },
    { L'\xF356', L"\x0440\xE02D" },
    { L'\xF357', L"\x0440\xE001\xE025" },
    { L'\xF358', L"\x0440\xE000\xE025" },
    { L'\xF359', L"\x0440\xE00F\xE025" },
    { L'\xF35A', L"\x0440\xE011\xE025" },
    { L'\xF35B', L"\x0440\xE00D\xE025" },
    { L'\xF35C', L"\x0440\xE003\xE025" },
    { L'\xF35D', L"\x0440\xE006" },
    { L'\xF35E', L"\x0440\xE00D" },
    { L'\xF35F', L"\x0440\xE09A" },
    { L'\xF360', L"\x0420\xE000" },
    { L'\xF361', L"\x0420\xE001" },
    { L'\xF362', L"\x0420\xE004" },
    { L'\xF363', L"\x0420\xE00F" },
    { L'\xF364', L"\x0420\xE011" },
    { L'\xF365', L"\x0420\xE025" },
    { L'\xF370', L"\x0441\xE002" },
    { L'\xF371', L"\x0441\xE004" },
    { L'\xF372', L"\x0441\xE001" },
    { L'\xF380', L"\x0442\xE002" },
    { L'\xF381', L"\x0442\xE004" },
    { L'\xF382', L"\x0442\xE001" },
    { L'\xF383', L"\x0442\xE09A" },
    { L'\xF390', L"\x0444\xE002" },
    { L'\xF3A0', L"\x0445\xE002" },
    { L'\xF3C0', L"\x0447\xE001" },
    { L'\xF3C1', L"\x0447\xE023" },
    { L'\xF3CF', L"\x0427\xE023" },
    { L'\xF3D0', L"\x045F\xE02C" },
    { L'\xF3D1', L"\x045F\xE001" },
    { L'\xF3D2', L"\x045F\xE023" },
    { L'\xF3DF', L"\x040F\xE023" },
    { L'\xF3E0', L"\x0448\xE004" },
    { L'\xF3E1', L"\x0448\xE001" },
    { L'\xF3E2', L"\x0448\xE023" },
    { L'\xF3EF', L"\x0428\xE023" },
    { L'\xF400', L"\x0430\xE061\x0430" },
    { L'\xF410', L"\x0435\xE061\x0438" },
    { L'\xF411', L"\x0435\xE061\xE001\x0435" },
    { L'\xF412', L"\x0435\xE023\xE02F\xE061\x0430\xE008" },
    { L'\xF413', L"\x0435\xE023\xE061\x0435" },
    { L'\xF420', L"\x0438\xE061\x0435" },
    { L'\xF421', L"\x0438\xE061\xE0C5\x0435\xE002\xE0C6" },
    { L'\xF422', L"\xE0C5\x0438\xE0C6\xE061\x0435" },
    { L'\xF422', L"\xE2EC\x0438\xE2ED\xE061\x0435" },
    { L'\xF423', L"\x0456\xE061\x0435" },
    { L'\xF424', L"\x0438\xE061\x0435\xE023" },
    { L'\xF425', L"\x0438\xE061\x025B" },
    { L'\xF430', L"\x043E\xE061\x0443" },
    { L'\xF431', L"\xE0C5\x043E\xE0C6\xE061\x0443" },
    { L'\xF431', L"\xE2EC\x043E\xE2ED\xE061\x0443" },
    { L'\xF432', L"\x043E\xE061\x0430" },
    { L'\xF440', L"\x0443\xE061\x043E" },
    { L'\xF441', L"\x0443\xE061\x043E\xE023" },
    { L'\xF442', L"\x0443\xE061\x0430" },
    { L'\xF45E', L"\x044A\xE05C\x0440" },
    { L'\xF45F', L"\x044C\xE05C\x0440" },
    { L'\xF460', L"\x0434\xE061\x0437" },
    { L'\xF461', L"\x0436\x2019\xE061\x0434" },
    { L'\xF462', L"\x0437\x2019\xE061\x0434" },
    { L'\xF463', L"\x0448\x2019\xE061\x0442" },
    { L'\xF4E0', L"\x03B1\xE004\xE001" },
    { L'\xF4E1', L"\x03B1\xE006\xE001" },
    { L'\xF4E2', L"\x03B9\xE004\xE001" },
    { L'\xF4E3', L"\x03B9\xE006\xE001" },
    { L'\xF4E4', L"\x03C5\xE004\xE001" },
    { L'\xF4E5', L"\x03C5\xE006\xE001" },
    { L'\xF4E7', L"\x03BB\xE0C4\x03BB" },
    { L'\xF4E8', L"\x03C9\xE006" },
    { L'\xF4E9', L"\x03C9\xE006\xE001" },
    { L'\xF4EB', L"\x03C9\xE00D" },
    { L'\xF500', L"\x1D07\xE035\xE004" },
    { L'\xF501', L"\x1D07\xE035" },
    { L'\xF502', L"\x0065\xE054" },
    { L'\xF503', L"\x025B\xE004\xE000" },
    { L'\xF504', L"\x0259\xE004\xE000" },
    { L'\xF505', L"\x025B\xE004\xE001" },
    { L'\xF506', L"\x0259\xE00F\xE023" },
    { L'\xF507', L"\x025B\xE006\xE00F" },
    { L'\xF508', L"\x0065\xE029" },
    { L'\xF509', L"\x0065\xE02F\xE023" },
    { L'\xF50A', L"\x0065\xE006\xE039" },
    { L'\xF50B', L"\x0065\xE028\xE001\xE023" },
    { L'\xF50C', L"\x0065\xE028\xE003\xE023" },
    { L'\xF50D', L"\x0065\xE028\xE003\xE039" },
    { L'\xF50E', L"\x0259\xE039" },
    { L'\xF50F', L"\x0065\xE028\xE084" },
    { L'\xF510', L"\x0065\xE013" },
    { L'\xF511', L"\x025B\xE028\xE000" },
    { L'\xF512', L"\x025B\xE028\xE001" },
    { L'\xF513', L"\x0065\xE003\xE00F" },
    { L'\xF514', L"\x025B\xE054" },
    { L'\xF515', L"\x025B\xE02E" },
    { L'\xF516', L"\x0259\xE02E" },
    { L'\xF517', L"\x0065\xE004\xE00D" },
    { L'\xF518', L"\x0065\xE00D\xE039" },
    { L'\xF519', L"\x0065\xE003\xE002" },
    { L'\xF51A', L"\x0065\xE006\xE001" },
    { L'\xF51B', L"\x0065\xE001\xE02F" },
    { L'\xF51C', L"\x0259\xE007\xE00B" },
    { L'\xF51D', L"\x0065\xE00C\xE070" },
    { L'\xF51E', L"\x0065\xE00C\xE003" },
    { L'\xF51F', L"\x0259\xE00F\xE025" },
    { L'\xF520', L"\x0454\xE006\xE000" },
    { L'\xF521', L"\x0454\xE006\xE001" },
    { L'\xF522', L"\x0454\xE006\xE00B" },
    { L'\xF523', L"\x0065\xE0AA" },
    { L'\xF524', L"\x0065\xE0AA\xE004" },
    { L'\xF526', L"\x03B7\xE023" },
    { L'\xF527', L"\x0065\xE065" },
    { L'\xF528', L"\x0065\xE066" },
    { L'\xF529', L"\x0065\xE067" },
    { L'\xF52A', L"\x0065\xE06E" },
    { L'\xF52B', L"\x0065\xE004\xE00C" },
    { L'\xF52C', L"\x0065\xE028\xE00C" },
    { L'\xF52D', L"\x0065\xE028\xE004\xE003" },
    { L'\xF52E', L"\x03B7\xE000\xE023" },
    { L'\xF52F', L"\x0065\xE003\xE02E" },
    { L'\xF530', L"\x0259\xE008" },
    { L'\xF531', L"\x044D\xE00D" },
    { L'\xF532', L"\x0454\xE00D" },
    { L'\xF533', L"\x0259\xE007\xE00F" },
    { L'\xF534', L"\x0065\xE004\xE002" },
    { L'\xF535', L"\x0065\xE004\xE011" },
    { L'\xF536', L"\x0065\xE007\xE004\xE003" },
    { L'\xF537', L"\x0065\xE007\xE004\xE000" },
    { L'\xF538', L"\x0065\xE007\xE004\xE002" },
    { L'\xF539', L"\x0065\xE007\xE004\xE00D" },
    { L'\xF53A', L"\x0065\xE007\xE004\xE011" },
    { L'\xF53B', L"\x0065\xE007\xE006\xE00D" },
    { L'\xF53C', L"\x0065\xE00C\xE004\xE003" },
    { L'\xF53D', L"\x0065\xE00C\xE004\xE002" },
    { L'\xF53E', L"\x0065\xE00C\xE004\xE00D" },
    { L'\xF53F', L"\x0065\xE00C\xE004\xE011" },
    { L'\xF540', L"\x0065\xE00C\xE006\xE00D" },
    { L'\xF541', L"\x0065\xE004\xE003\xE039" },
    { L'\xF542', L"\x0065\xE004\xE00D\xE039" },
    { L'\xF543', L"\x0065\xE004\xE011\xE039" },
    { L'\xF544', L"\x0065\xE006\xE00D\xE039" },
    { L'\xF545', L"\x0065\xE028\xE00C\xE00F" },
    { L'\xF546', L"\x0065\xE028\xE004\xE00D" },
    { L'\xF547', L"\x0065\xE028\xE004\xE011" },
    { L'\xF548', L"\x0065\xE028\xE006\xE00D" },
    { L'\xF549', L"\x0259\xE004\xE003" },
    { L'\xF54A', L"\x0259\xE004\xE001" },
    { L'\xF54B', L"\x0259\xE004\xE002" },
    { L'\xF54C', L"\x0259\xE004\xE00D" },
    { L'\xF54D', L"\x0259\xE004\xE011" },
    { L'\xF54E', L"\x0259\xE006\xE00D" },
    { L'\xF54F', L"\x0065\xE004\xE002\xE039" },
    { L'\xF550', L"\x0065\xE028\xE004\xE002" },
    { L'\xF551', L"\x0065\xE027\xE000" },
    { L'\xF552', L"\x0065\xE027\xE004\xE000" },
    { L'\xF553', L"\x0065\xE027\xE004" },
    { L'\xF554', L"\x0065\xE003\xE025" },
    { L'\xF555', L"\x0065\xE004\xE02F" },
    { L'\xF556', L"\x0065\xE092\xE029" },
    { L'\xF557', L"\x025B\xE008" },
    { L'\xF558', L"\x0065\xE001\xE031" },
    { L'\xF559', L"\x0259\xE001\xE025" },
    { L'\xF55A', L"\x0065\xE087" },
    { L'\xF55B', L"\x044D\xE087" },
    { L'\xF55C', L"\x0454\xE004\xE089" },
    { L'\xF55D', L"\x0454\xE087" },
    { L'\xF55E', L"\x025B\xE003\xE023" },
    { L'\xF55F', L"\x025B\xE023" },
    { L'\xF560', L"\x0045\xE00D" },
    { L'\xF561', L"\x0045\xE003\xE023" },
    { L'\xF562', L"\x0045\xE004\xE023" },
    { L'\xF563', L"\x018F\xE00F" },
    { L'\xF564', L"\x0045\xE004\xE003" },
    { L'\xF565', L"\x018E\xE00F" },
    { L'\xF566', L"\x0045\xE02E" },
    { L'\xF567', L"\x0045\xE001\xE025" },
    { L'\xF568', L"\x0045\xE037\xE000" },
    { L'\xF569', L"\x0045\xE00D\xE023" },
    { L'\xF56A', L"\x0045\xE00F\xE023" },
    { L'\xF56B', L"\x0045\xE006\xE023" },
    { L'\xF56C', L"\x0045\xE011\xE039" },
    { L'\xF56D', L"\x0045\xE00F\xE039" },
    { L'\xF56E', L"\x0045\xE001\xE039" },
    { L'\xF56F', L"\x0045\xE006\xE039" },
    { L'\xF570', L"\x006F\xE004\xE002\xE039" },
    { L'\xF571', L"\x006F\xE004\xE00D\xE039" },
    { L'\xF572', L"\x006F\xE004\xE011\xE039" },
    { L'\xF573', L"\x006F\xE006\xE00D\xE039" },
    { L'\xF574', L"\x006F\xE016" },
    { L'\xF575', L"\x006F\xE028\xE004\xE002" },
    { L'\xF576', L"\x006F\xE028\xE004\xE00D" },
    { L'\xF577', L"\x006F\xE0AA\xE003\xE004" },
    { L'\xF578', L"\x006F\xE028\xE006\xE00D" },
    { L'\xF579', L"\x006F\xE001\xE003\xE039" },
    { L'\xF57A', L"\x006F\xE004\xE02C" },
    { L'\xF57B', L"\x006F\xE065" },
    { L'\xF57C', L"\x006F\xE067" },
    { L'\xF57D', L"\xE131\xE028\xE000" },
    { L'\xF57E', L"\xE131\xE087" },
    { L'\xF57F', L"\x0254\xE028\xE004" },
    { L'\xF580', L"\x006F\xE006\xE001\xE039" },
    { L'\xF581', L"\x006F\xE063" },
    { L'\xF582', L"\xE131\xE004\xE087" },
    { L'\xF583', L"\x006F\xE0C4\x0065\xE028\xE006" },
    { L'\xF584', L"\x006F\xE0C4\x0065\xE087" },
    { L'\xF585', L"\x006F\xE007\xE002" },
    { L'\xF586', L"\x006F\xE094" },
    { L'\xF587', L"\x006F\xE0C4\x0065\xE003\xE023" },
    { L'\xF588', L"\x006F\xE0C4\x0065\xE011" },
    { L'\xF589', L"\x0254\xE003\xE023" },
    { L'\xF58A', L"\x0254\xE023" },
    { L'\xF58B', L"\x006F\xE072" },
    { L'\xF58C', L"\x006F\xE008\xE006" },
    { L'\xF58D', L"\x006F\xE027" },
    { L'\xF58E', L"\x0254\xE00D" },
    { L'\xF58F', L"\x006F\xE028\xE008\xE004\xE001" },
    { L'\xF590', L"\x006F\xE028\xE007\xE000" },
    { L'\xF592', L"\x006F\xE028\xE00F\xE023" },
    { L'\xF593', L"\x006F\xE028\xE011\xE023" },
    { L'\xF594', L"\x006F\xE028\xE006\xE023" },
    { L'\xF595', L"\x006F\xE007\xE024" },
    { L'\xF596', L"\x006F\xE003\xE001\xE039" },
    { L'\xF597', L"\x006F\xE003\xE001\xE023" },
    { L'\xF598', L"\x006F\xE011\xE003" },
    { L'\xF599', L"\x006F\xE001\xE025" },
    { L'\xF59A', L"\x006F\xE001\xE003\xE023" },
    { L'\xF59B', L"\x006F\xE003\xE02D" },
    { L'\xF59C', L"\x006F\xE000\xE02F" },
    { L'\xF59D', L"\x006F\xE011\xE02D\xE023" },
    { L'\xF59E', L"\x006F\xE001\xE003" },
    { L'\xF59F', L"\x004F\xE007\xE00F" },
    { L'\xF5A0', L"\x004F\xE001\xE039" },
    { L'\xF5A1', L"\x004F\xE004\xE039" },
    { L'\xF5A2', L"\x004F\xE00F\xE039" },
    { L'\xF5A3', L"\x004F\xE011\xE039" },
    { L'\xF5A4', L"\x004F\xE039" },
    { L'\xF5A5', L"\x004F\xE006\xE039" },
    { L'\xF5A6', L"\x004F\xE004\xE023" },
    { L'\xF5A7', L"\x004F\xE006\xE023" },
    { L'\xF5A8', L"\x004F\xE00F\xE023" },
    { L'\xF5A9', L"\x004F\xE008\xE006" },
    { L'\xF5AA', L"\x004F\xE008\xE011" },
    { L'\xF5AB', L"\x004F\xE008\xE00D" },
    { L'\xF5AC', L"\x004F\xE008\xE003" },
    { L'\xF5AD', L"\x004F\xE008\xE00F" },
    { L'\xF5AE', L"\x004F\xE007\xE003" },
    { L'\xF5AF', L"\x004F\xE007\xE011" },
    { L'\xF5D0', L"\x0250\xE003" },
    { L'\xF5D1', L"\x0250\xE003\xE023" },
    { L'\xF5D2', L"\x0250\xE023" },
    { L'\xF5D3', L"\x0252\xE023" },
    { L'\xF5D4', L"\x0061\xE0C4\x0065\xE00B" },
    { L'\xF5D5', L"\x0061\xE0C4\x0065\xE00C" },
    { L'\xF5D6', L"\x0061\xE0C4\x0065\xE00F" },
    { L'\xF5D7', L"\x0061\xE0C4\x0065\xE023" },
    { L'\xF5D8', L"\x03B1\xE003\xE023" },
    { L'\xF5D9', L"\x03B1\xE023" },
    { L'\xF5DA', L"\xE15F\xE023" },
    { L'\xF5DB', L"\x0061\xE008\xE004\xE001" },
    { L'\xF5DC', L"\x0061\xE0C4\x0065\xE002" },
    { L'\xF5DD', L"\x028C\xE004\xE006" },
    { L'\xF5DE', L"\x0061\xE08B\xE004" },
    { L'\xF5DF', L"\x0061\xE08B\xE001" },
    { L'\xF5E0', L"\x0061\xE08B\xE004\xE001" },
    { L'\xF5E1', L"\x0252\xE007" },
    { L'\xF5E2', L"\x0252\xE008" },
    { L'\xF5E3', L"\x0252\xE003" },
    { L'\xF5E4', L"\x0061\xE004\xE030" },
    { L'\xF5E5', L"\x0061\xE008\xE063" },
    { L'\xF5E6', L"\x0061\xE095" },
    { L'\xF5E7', L"\x0061\xE096" },
    { L'\xF5E8', L"\x0061\xE0AA" },
    { L'\xF5E9', L"\x0061\xE098" },
    { L'\xF5EA', L"\x0061\xE008\xE097" },
    { L'\xF5EB', L"\x0061\xE008\xE098" },
    { L'\xF5EC', L"\x0061\xE008\xE093" },
    { L'\xF5ED', L"\x0061\xE008\xE030" },
    { L'\xF5EE', L"\x0061\xE008\xE004\xE030" },
    { L'\xF5EF', L"\x0061\xE006\xE030" },
    { L'\xF5F0', L"\x0061\xE008\xE004\xE006" },
    { L'\xF5F1', L"\x0061\xE003\xE011" },
    { L'\xF5F2', L"\x0061\xE028\xE00A\xE00F" },
    { L'\xF5F3', L"\x0061\xE028\xE004\xE00D\xE023" },
    { L'\xF5F4', L"\x0061\xE028\xE00D\xE023" },
    { L'\xF5F5', L"\x0061\xE028\xE00F\xE023" },
    { L'\xF5F6', L"\x0061\xE028\xE000\xE023" },
    { L'\xF5F7', L"\x0061\xE028\xE004\xE023" },
    { L'\xF5F8', L"\x0061\xE028\xE003\xE025" },
    { L'\xF5F9', L"\x0061\xE028\xE011\xE025" },
    { L'\xF5FA', L"\x0061\xE028\xE004\xE00D\xE025" },
    { L'\xF5FB', L"\x0061\xE028\xE00D\xE025" },
    { L'\xF5FC', L"\x0061\xE028\xE00F\xE025" },
    { L'\xF5FD', L"\x0061\xE028\xE004\xE025" },
    { L'\xF5FE', L"\x0061\xE028\xE006\xE025" },
    { L'\xF5FF', L"\x0061\xE004\xE00D\xE023" },
    { L'\xF600', L"\x0065\xE00C\xE002" },
    { L'\xF601', L"\x0065\xE008\xE001\xE023" },
    { L'\xF602', L"\x0065\xE008\xE023" },
    { L'\xF603', L"\x0065\xE072" },
    { L'\xF604', L"\x0065\xE007\xE006" },
    { L'\xF605', L"\x0065\xE004\xE007" },
    { L'\xF606', L"\x0065\xE004\xE030" },
    { L'\xF607', L"\x0065\xE000\xE003" },
    { L'\xF608', L"\x0259\xE000\xE039" },
    { L'\xF609', L"\x0259\xE00F\xE003" },
    { L'\xF60A', L"\x0065\xE037\xE000" },
    { L'\xF60B', L"\x0259\xE004\xE006" },
    { L'\xF60C', L"\x0259\xE029" },
    { L'\xF60D', L"\x0065\xE004\xE00D\xE023" },
    { L'\xF60E', L"\x0065\xE028\xE004\xE00D\xE023" },
    { L'\xF60F', L"\x0065\xE028\xE00F\xE023" },
    { L'\xF610', L"\x0065\xE028\xE000\xE023" },
    { L'\xF611', L"\x0065\xE028\xE004\xE023" },
    { L'\xF612', L"\x0065\xE028\xE006\xE023" },
    { L'\xF613', L"\x0065\xE028\xE00C\xE004\xE00D\xE023" },
    { L'\xF614', L"\x0065\xE028\xE00C\xE00D\xE023" },
    { L'\xF615', L"\x0259\xE028\xE003" },
    { L'\xF616', L"\x0259\xE028\xE011" },
    { L'\xF617', L"\x0259\xE028\xE004\xE00D" },
    { L'\xF618', L"\x0259\xE028\xE00D" },
    { L'\xF619', L"\x0259\xE028\xE00F" },
    { L'\xF61A', L"\x0259\xE028\xE000" },
    { L'\xF61B', L"\x0259\xE028\xE004" },
    { L'\xF61C', L"\x0259\xE028\xE006" },
    { L'\xF61D', L"\x0259\xE000\xE024" },
    { L'\xF61E', L"\x0259\xE001\xE024" },
    { L'\xF61F', L"\x0259\xE024" },
    { L'\xF620', L"\x0254\xE008" },
    { L'\xF621', L"\x006F\xE004\xE030" },
    { L'\xF622', L"\x006F\xE008\xE097" },
    { L'\xF623', L"\x006F\xE006\xE000" },
    { L'\xF624', L"\x006F\xE0AA" },
    { L'\xF625', L"\x006F\xE008\xE030" },
    { L'\xF626', L"\x006F\xE028\xE001\xE003" },
    { L'\xF627', L"\x006F\xE028\xE003\xE011" },
    { L'\xF628', L"\x006F\xE0C4\x0065\xE001\xE023" },
    { L'\xF629', L"\x006F\xE0C4\x0065\xE023" },
    { L'\xF62A', L"\x006F\xE028\xE007\xE001" },
    { L'\xF62B', L"\x006F\xE004\xE00D\xE023" },
    { L'\xF62C', L"\x006F\xE007\xE003" },
    { L'\xF62D', L"\x006F\xE007\xE004\xE00D" },
    { L'\xF62E', L"\x006F\xE007\xE006" },
    { L'\xF62F', L"\x006F\xE007\xE00D" },
    { L'\xF630', L"\x006F\xE007\xE000\xE023" },
    { L'\xF631', L"\x006F\xE007\xE001\xE023" },
    { L'\xF632', L"\x006F\xE007\xE003\xE023" },
    { L'\xF633', L"\x006F\xE007\xE004\xE023" },
    { L'\xF634', L"\x006F\xE007\xE004\xE00D\xE023" },
    { L'\xF635', L"\x006F\xE007\xE006\xE023" },
    { L'\xF636', L"\x006F\xE007\xE00D\xE023" },
    { L'\xF637', L"\x006F\xE007\xE00F\xE023" },
    { L'\xF638', L"\x006F\xE007\xE011\xE023" },
    { L'\xF639', L"\x006F\xE008\xE004\xE00D" },
    { L'\xF63A', L"\x006F\xE008\xE00D" },
    { L'\xF63B', L"\x006F\xE00D\xE039" },
    { L'\xF63C', L"\x006F\xE028\xE004\xE023" },
    { L'\xF63C', L"\x006F\xE028\xE00D\xE023" },
    { L'\xF63D', L"\x006F\xE028\xE004\xE00D\xE023" },
    { L'\xF63E', L"\x0254\xE02C" },
    { L'\xF640', L"\x0281\xE001\xE025" },
    { L'\xF641', L"\x0072\xE013" },
    { L'\xF642', L"\x0281\xE000\xE025" },
    { L'\xF643', L"\x0281\xE001" },
    { L'\xF644', L"\x0072\xE004\xE00D\xE025" },
    { L'\xF645', L"\x0072\xE00F\xE023" },
    { L'\xF646', L"\x0072\xE011\xE023" },
    { L'\xF647', L"\x0072\xE017" },
    { L'\xF64F', L"\x0052\xE0C2" },
    { L'\xF650', L"\x0061\xE00D\xE023" },
    { L'\xF651', L"\x0061\xE004\xE00D\xE025" },
    { L'\xF652', L"\x0061\xE00D\xE025" },
    { L'\xF653', L"\x0061\xE028\xE004\xE00D" },
    { L'\xF654', L"\x0061\xE028\xE00D" },
    { L'\xF655', L"\x0061\xE001\xE003" },
    { L'\xF656', L"\x0061\xE00A\xE011\xE039" },
    { L'\xF657', L"\x0061\xE00A\xE025" },
    { L'\xF658', L"\x0061\xE011\xE003" },
    { L'\xF659', L"\x0061\xE011\xE00A" },
    { L'\xF65A', L"\x0061\xE011\xE00F" },
    { L'\xF65B', L"\x0252\xE004" },
    { L'\xF65C', L"\x0061\xE0A9" },
    { L'\xF65D', L"\x0061\xE011\xE003" },
    { L'\xF65E', L"\x0061\xE001\xE00A" },
    { L'\xF65F', L"\x0061\xE017" },
    { L'\xF670', L"\x0041\xE003\xE025" },
    { L'\xF671', L"\x0041\xE000\xE025" },
    { L'\xF672', L"\x0041\xE004\xE025" },
    { L'\xF673', L"\x0041\xE006\xE025" },
    { L'\xF674', L"\x0041\xE028\xE003" },
    { L'\xF675', L"\x0041\xE028\xE011" },
    { L'\xF676', L"\x0041\xE028\xE00F" },
    { L'\xF677', L"\x0041\xE028\xE000" },
    { L'\xF678', L"\x0041\xE028\xE004" },
    { L'\xF679', L"\x0041\xE028\xE006" },
    { L'\xF680', L"\x0045\xE028\xE011" },
    { L'\xF681', L"\x0045\xE028\xE00F" },
    { L'\xF682', L"\x0045\xE028\xE000" },
    { L'\xF683', L"\x0045\xE028\xE004" },
    { L'\xF684', L"\x0045\xE028\xE006" },
    { L'\xF685', L"\x018E\xE011" },
    { L'\xF686', L"\x0045\xE039" },
    { L'\xF690', L"\x0065\xE007\xE039" },
    { L'\xF691', L"\x0065\xE011\xE025" },
    { L'\xF692', L"\x0065\xE025\xE039" },
    { L'\xF693', L"\x0065\xE011\xE02D\xE039" },
    { L'\xF694', L"\x0065\xE011\xE007" },
    { L'\xF695', L"\x0065\xE001\xE02C" },
    { L'\xF696', L"\x0258\xE028" },
    { L'\xF697', L"\x0259\xE011\xE00F" },
    { L'\xF698', L"\x0065\xE007\xE011\xE02C" },
    { L'\xF699', L"\x0065\xE017" },
    { L'\xF69A', L"\x0259\xE016" },
    { L'\xF69B', L"\x0065\xE011\xE003\xE023" },
    { L'\xF69C', L"\x025B\xE008\xE024" },
    { L'\xF69D', L"\x0065\xE00B\xE039" },
    { L'\xF69E', L"\x0065\xE006\xE006" },
    { L'\xF69F', L"\x0065\xE00C\xE00C" },
    { L'\xF6A0', L"\x006F\xE001\xE02C" },
    { L'\xF6A1', L"\x006F\xE037\xE004\xE006" },
    { L'\xF6A2', L"\x006F\xE028\xE037" },
    { L'\xF6A3', L"\x006F\xE011\xE039\xE02D" },
    { L'\xF6A5', L"\x006F\xE011\xE003\xE039" },
    { L'\xF6A6', L"\x006F\xE017" },
    { L'\xF6A7', L"\x006F\xE0C4\x0065\xE008" },
    { L'\xF6A8', L"\x006F\xE035\xE024" },
    { L'\xF6A9', L"\x006F\xE0C4\x0065\xE008\xE024" },
    { L'\xF6AA', L"\x006F\xE006\xE00F" },
    { L'\xF6AB', L"\x006F\xE00C\xE00F" },
    { L'\xF6AC', L"\x006F\xE037\xE00D" },
    { L'\xF6AD', L"\x006F\xE004\xE011\xE023" },
    { L'\xF6AF', L"\x004F\xE00D\xE023" },
    { L'\xF6B0', L"\x0252\xE01D" },
    { L'\xF6B1', L"\x0061\xE00F\xE024" },
    { L'\xF6B2', L"\x0061\xE00B\xE025" },
    { L'\xF6B3', L"\x0061\xE008\xE00D" },
    { L'\xF6B4', L"\x0061\xE070" },
    { L'\xF6B5', L"\x0061\xE008\xE011\xE025" },
    { L'\xF6B6', L"\x0061\xE008\xE004\xE00D" },
    { L'\xF6B7', L"\x0061\xE008\xE001\xE025" },
    { L'\xF6C0', L"\x0065\xE004\xE000\xE023" },
    { L'\xF6C1', L"\x0065\xE028\xE00C\xE00B" },
    { L'\xF6C2', L"\x0065\xE016" },
    { L'\xF6C3', L"\x0065\xE004\xE003\xE02C" },
    { L'\xF6C5', L"\x0065\xE004\xE006\xE023" },
    { L'\xF6C6', L"\x0065\xE006\xE001\xE023" },
    { L'\xF700', L"\x007A\xE007\xE023" },
    { L'\xF7F0', L"\x0064\xE05C\x007A" },
    { L'\xF7F1', L"\x0064\xE05C\x007A\xE00C" },
    { L'\xF7F2', L"\x0074\xE05C\x0073\xE00C" },
    { L'\xFB00', L"\x0066\xE0C4\x0066" },
    { L'\xFB01', L"\x0066\xE0C4\x0069" },
    { L'\xFB02', L"\x0066\xE0C4\x006C" },
    { L'\xFB03', L"\x0066\xE0C4\x0066\xE0C4\x0069" },
    { L'\xFB04', L"\x0066\xE0C4\x0066\xE0C4\x006C" },
    { L'\xFB05', L"\x017F\xE0C4\x0074" },
    { L'\xFB06', L"\x0073\xE0C4\x0074" },
};

const ZRCola::decomposition* ZRCola::decompositions = ::decompositions;
const size_t ZRCola::decompositionsCount = _countof(::decompositions);
